#!/usr/bin/python
import user
import pygtk
pygtk.require('2.0')
import gtk
#import numarray as na
import numpy as na
#import numarray.random_array as narand
import numpy.random_array as narand
from matplotlib.figure import Figure
import matplotlib.font_manager as font_manager
from matplotlib.backends.backend_gtkagg import FigureCanvasGTKAgg as FigureCanvas
from matplotlib.backends.backend_gtkagg import NavigationToolbar2GTKAgg as NavigationToolbar
import IRCamSocket
import common
import mircFiberExplorerXchan

import mircMappingXchan
import time
import gobject
import threading
import pdb

class RTPCMainWindow :
    def __init__(self):

        self.mfex = mircFiberExplorerXchan.fiber()
        self.ircs = IRCamSocket.IRCamSocket()
        self.num_stages=6
        self.color=['bs-.','gs-.','rs-.','ms-.','ks-.','bo-.','go-.','ro-.','mo-.','ko-.',\
                    'b^-.','g^-.','r^-.','m^-.','k^-.','bd-.','gd-.','rd-.','md-.','kd-.']

        self.irrs = IRCamSocket.IRCamSocket()
        self.real_time=[]
        self.RT_flux=[[],[],[],[],[],[]]
        self.RT_vis=[[],[],[],[],[],[],[],[],[],[],[],[],[],[],[]]
        self.RT_cp=[[],[],[],[],[],[],[],[],[],[],[],[],[],[],[],[],[],[],[],[]]

        self.disp_state=0
        self.mmx=mircMappingXchan.mircMapping()

        
        self.win = gtk.Window()
        self.win.connect("destroy", lambda x: gtk.main_quit())
        self.win.set_default_size(1500,600)
        self.win.set_title("Real time flux, visibility and closure phase")

        self.table = gtk.Table(100,100)
        self.win.add(self.table)

        ################pack buttons and checks boxes
        self.flux_button_box=gtk.HBox(True,0)
        self.flux_button_box.show()
        
        self.flux_start_button=gtk.Button("Start")
        self.flux_start_button.connect('clicked',self.real_time_disp,1)
        self.flux_button_box.pack_start(self.flux_start_button,False,False,0)
        self.flux_start_button.show()

        self.flux_stop_button=gtk.Button("Stop")
        self.flux_stop_button.connect('clicked',self.real_time_disp,0)
        self.flux_button_box.pack_start(self.flux_stop_button,False,False,0)
        self.flux_stop_button.show()

#        self.flux_refresh_button=gtk.Button("Refresh")
#        self.flux_refresh_button.connect('clicked',self.real_time_disp,2)
#        self.flux_button_box.pack_start(self.flux_refresh_button,False,False,0)
#        self.flux_refresh_button.show()

        #check boxes
        self.flux_check_button=[]
        for ii in range(self.num_stages):
            self.flux_check_button.append(gtk.CheckButton('beam'+str(ii)))
            self.flux_button_box.pack_start(self.flux_check_button[ii],False,False,3)
            self.flux_check_button[ii].show()
            self.flux_check_button[ii].set_active(True)

        self.table.attach(self.flux_button_box,0,1,99,100,True)


        ####simulated data
 #       self.flux_data=[]
 #       for ii in range(self.num_stages):
 #           self.flux_data.append(narand.random(10))

 #       self.vis_data=[]
 #       for ii in range(self.num_stages*(self.num_stages-1)/2):
 #           self.vis_data.append(narand.random(10))

 #       self.cp_data=[]
 #       for ii in range(self.num_stages*(self.num_stages-1)*(self.num_stages-2)/6):
 #           self.cp_data.append(narand.random(10))
            
        ###########draw flux, visibility, closure phase
        
        self.fig = Figure(figsize=(300,100))
        width=0.7
        height=0.3
        
        self.flux_ax = self.fig.add_subplot(311)
        self.flux_ax.set_position([0.25,0.67,width,height])
        self.flux_ax.set_xticklabels('')
        self.flux_ax.set_ylabel('Flux')
        #self.flux_ax.set_label('Flux')
        
        self.vis_ax = self.fig.add_subplot(312)
        self.vis_ax.set_position([0.25,0.37,width,height])
        self.vis_ax.set_xticklabels('')
        self.vis_ax.set_ylabel('Raw Visibility')
        
        self.cp_ax = self.fig.add_subplot(313)
        self.cp_ax.set_position([0.25,0.07,width,height])
        self.cp_ax.set_ylabel('Closure Phase')
        self.cp_ax.set_xlabel('Time')
            
        self.canvas = FigureCanvas(self.fig)
        self.table.attach(self.canvas,0,100,0,99)
        self.toolbar = NavigationToolbar(self.canvas, self.win)
        self.table.attach(self.toolbar,1,100,99,100)
        self.fig_display()
#        self.tag= gobject.timeout_add(100, self.test)
        self.win.show_all()
     

    def real_time_disp(self,widge,data):
        #pdb.set_trace()
#        active_stage=self.checked_stage()
        if data ==  1:
            self.disp_state=1
            self.tag= gobject.timeout_add(5000, self.fig_display)

        else:
            self.disp_state=0
            gobject.source_remove(self.tag)

    def test(self):
        print "testing"
        return 1

    def fig_display(self):
        #update current information
        self.fig.clear()
        self.get_time()
        self.get_flux()
        self.get_vis()
        self.get_cp()
        active_stage=self.checked_stage()
        #################
        width=0.55
        height=0.3
        
        self.flux_ax = self.fig.add_subplot(311)
        self.flux_ax.set_position([0.25,0.80,width,0.19])
        self.flux_ax.set_xticklabels('')
        self.flux_ax.set_ylabel('Flux')
        self.flux_ax.set_label('Flux')
        
        self.vis_ax = self.fig.add_subplot(312)
        self.vis_ax.set_position([0.25,0.45,width,0.35])
        self.vis_ax.set_xticklabels('')
        self.vis_ax.set_ylabel('Raw Visibility')
        
        self.cp_ax = self.fig.add_subplot(313)
        self.cp_ax.set_position([0.25,0.05,width,0.4])
        self.cp_ax.set_ylabel('Closure Phase')
        self.cp_ax.set_xlabel('Time')    
        self.canvas = FigureCanvas(self.fig)
        self.table.attach(self.canvas,0,100,0,99)
        self.toolbar = NavigationToolbar(self.canvas, self.win)
        self.table.attach(self.toolbar,1,100,99,100)
        ################
        

        legendfontsize=font_manager.FontProperties(style="italic",size=14)
        #fluxes
        flux_line=[]
        self.beam_label=[]
        for ii in range(self.num_stages):
            if active_stage[ii]==0: continue
            flux_line.append(self.flux_ax.plot(self.real_time,self.RT_flux[ii],self.color[ii]))
            self.beam_label.append('Beam'+str(ii+1))
        self.fig.legend(flux_line,self.beam_label,'upper left',prop=legendfontsize)

        #visibility
        vis_line=[]
        self.vis_label=[]
        for ii in range(self.num_stages):
            if active_stage[ii]==0:continue
            for jj in range(ii+1,self.num_stages):
                if active_stage[jj]==0:continue
                index=self.index2ij([ii,jj])
                #pdb.set_trace()
                vis_line.append(self.vis_ax.plot(self.real_time,self.RT_vis[index],self.color[index]))
                self.vis_label.append('Beam'+str(ii+1)+str(jj+1))
        self.fig.legend(vis_line,self.vis_label,'lower left',prop=legendfontsize)

        #closure phase
        cp_line=[]
        self.cp_label=[]
        for ii in range(self.num_stages):
            if active_stage[ii]==0: continue
            for jj in range(ii+1,self.num_stages):
                if active_stage[jj]==0:continue
                for kk in range(jj+1,self.num_stages):
                    if active_stage[kk]==0:continue
                    index=self.index2ijk([ii,jj,kk]) 
                    #pdb.set_trace()
                    cp_line.append(self.cp_ax.plot(self.real_time,self.RT_cp[index],self.color[index]))
                    self.cp_label.append('Beam'+str(ii+1)+str(jj+1)+str(kk+1))
        self.fig.legend(cp_line,self.cp_label,'lower right',prop=legendfontsize)

        self.win.show_all()
        return 1

    def index2ijk(self,data):
        length=len(data)
        count=0
        if length==1:
            for ii in range(self.num_stages):
                for jj in range(ii+1,self.num_stages):
                    for kk in range(jj+1,self.num_stages):
                        if count ==data:
                            return [ii,jj,kk]
                        count+=1
        else:
            for ii in range(self.num_stages):
                for jj in range(ii+1,self.num_stages):
                    for kk in range(jj+1,self.num_stages):
                        if data==[ii,jj,kk]:
                            return count
                        count=count+1


                        
    def index2ij(self,data):
        length=len(data)
        count=0
        if length==1:
            for ii in range(self.num_stages):
                for jj in range(ii+1,self.num_stages):
                    if count ==data:
                        return [ii,jj]
                    count+=1
        else:
            for ii in range(self.num_stages):
                for jj in range(ii+1,self.num_stages):
                    if data==[ii,jj]:
                        return count
                    count+=1



    def checked_stage(self):
        active_stage=[]
        for ii in range(self.num_stages):
            if self.flux_check_button[ii].get_active():
                active_stage.append(1)
            else:
                active_stage.append(0)
        return active_stage

    def get_time(self):
        ct=time.localtime()
        ctime=ct[3]+(ct[4]+ct[5]/60.)/60.
        self.real_time.append(ctime)

    def simulated_data(self,num):
        return narand.random(num)
    
    def get_flux(self):
        #inten=self.simulated_data(self.num_stages)
        self.xchan_pos=self.mfex.xchan_pos
        self.updated = self.ircs.readFLFrame()
        self.ij_range=self.mfex.ij_range
        
        if self.updated == 1:
            frame = common.lastFrame - common.firstFrame
            quad_range0 = ij_range[0]
            quad_range1 = ij_range[1]/2 - 1
            for ii in range(self.num_stages):
                temp=frame[quad_range0:quad_range1,self.xchan_pos[ii]-1:self.xchan_pos[ii]+1].sum()
                self.RT_flux[ii].append(temp)
                inten1=[]
                inten2=[]
            for ii in range(self.num_stages):
                temp1=frame[quad_range0:quad_range1,self.xchan_pos[ii]-3:self.xchan_pos[ii]-2].sum()
                temp2=frame[quad_range0:quad_range1,self.xchan_pos[ii]+2].sum()
                self.RT_[ii]=inten[ii]-inten1-inten2
        
        

    def get_vis(self):
        inten=self.simulated_data(self.num_stages*(self.num_stages-1)/2)
        for ii in range(self.num_stages*(self.num_stages-1)/2):
            self.RT_vis[ii].append(inten[ii])

    def get_cp(self):
        inten=self.simulated_data(self.num_stages*(self.num_stages-1)*(self.num_stages-2)/6)
        for ii in range(self.num_stages*(self.num_stages-1)*(self.num_stages-2)/6):
            self.RT_cp[ii].append(inten[ii])
        

    def main(self):
        gtk.main()

def main():
    RTPC = RTPCMainWindow()
    RTPC.main()

print __name__
if __name__ == "__main__":
    main()

