#!/usr/bin/python
import pdb
import matplotlib
matplotlib.use('GTKAgg')

import pylab as pl
from pylab import cm

# switch comments for gtk over gtkagg
#from matplotlib.backends.backend_gtk import FigureCanvasGTK as FigureCanvas
from matplotlib.backends.backend_gtkagg import FigureCanvasGTKAgg as FigureCanvas

#currently backend_gtk DOESN'T have NavigationToolbar functionallity, need to get this fixed
# or NavigationToolbar for classic
#from matplotlib.backends.backend_gtk import NavigationToolbar2GTKAgg as NavigationToolbar

from matplotlib.axes import Subplot
from matplotlib.figure import Figure

#from matplotlib.mlab import meshgrid
from numpy import meshgrid
from matplotlib.mlab import bivariate_normal
from matplotlib import rcParams

import pygtk
## pygtk.require('2.0')
import gtk

from gauss_mpfit2 import gauss_fit
from agpy_gaussfitter import gaussfit
from mapping import *
#import numarray as na
import numpy as na
#import numarray.mlab as mlab
import matplotlib.mlab as mlab
import controlMountSocket
import common
#import mircMapping
import mircMappingXchan
#import mircMappingXchanThread
import IRCamSocket
import IRCamCommands
import time
import os.path

class fiber:		
    #move luminos function
    def move(self,widget,direction):
        xy = long(self.lumi_spin_button[0].get_value())
        zz = long(self.lumi_spin_button[1].get_value())
        dct = {'UP':[3, 250*xy], 'DOWN':[3, -250*xy], 'RIGHT':[2, 250*xy],\
               'LEFT':[2,-250*xy], 'IN':[1, 10*zz],'OUT':[1, -10*zz]}
        try: self.lum.move_relative(self.lum_stage, dct[direction][0], dct[direction][1])
        except: print 'function move received direction = ',direction

        if (self.auto_det_section):
            self.view_detector_section(0)

        if (self.detector_configured):
            self.getFrame()
            print 'intensity: ', self.mm.get_intensity(self.ij_range)
		
        #refresh positions
        self.refresh_positions(0)
			
    #function to automatically display detector section after each move (toggle switch)
    def auto_det_section_toggled(self,widget):
        self.auto_det_section = self.auto_det_section_check.get_active()

    #function for changing active luminos mount, menus in both the luminos and mapping tabs are changed
    def luminos_menu_changed(self,combo_box):
        self.lum_stage = combo_box.get_active() + 1
        self.luminos_combo_box.set_active(self.lum_stage - 1)
		
        #insert function to refresh positions listed
        self.refresh_positions(0)
			
    #function for returning an arrow button
    def create_arrow_button(self,arrow_type, shadow_type):
        button = gtk.Button();
        arrow = gtk.Arrow(arrow_type, shadow_type);
        button.add(arrow)
        button.show()
        arrow.show()
        return button	
	
    #functions for saving current position to a file
    def save_pos(self,widget):		
        self.save_filew = gtk.FileSelection('Save all positions to file')
        self.save_filew.connect("destroy",lambda w: self.save_filew.destroy())
        self.save_filew.ok_button.connect("clicked",self.file_save_action)
        self.save_filew.cancel_button.connect("clicked",lambda w: self.save_filew.destroy())
        self.save_filew.show()

    #function to actually do the filesaving
    def file_save_action(self,widget):
        #pdb.set_trace()
        self.lum.save_position(self.save_filew.get_filename(),self.nluminos)
        print "save info to %s" % self.save_filew.get_filename()
        self.save_filew.destroy()

    #functions for recalling position from a file
    def recall_pos(self,widget):	
        self.recall_filew = gtk.FileSelection('Recall all positions from file')
        self.recall_filew.connect("destroy",lambda w: self.recall_filew.destroy())
        self.recall_filew.ok_button.connect("clicked",self.file_recall_action)
        self.recall_filew.cancel_button.connect("clicked",lambda w: self.recall_filew.destroy())
        self.recall_filew.show()

    def recall_last_posi(self,widget):
        #pdb.set_trace()
        self.lum.recall_position(self.lum_stage_file,self.num_stages)
        print "recalled info from %s" % self.lum_stage_file
        self.refresh_positions(0)
        

    #function that actually recalls the file
    def file_recall_action(self,widget):
        self.lum.recall_position(self.recall_filew.get_filename(),self.nluminos)
        print "recalled info from %s" % self.recall_filew.get_filename()
        self.recall_filew.destroy()		
        
        #insert function to refresh position
        self.refresh_positions(0)

    #move to what's entered in the position text boxes
    def move_to_enterred(self,widget):
        print 'moving mount ',self.lum_stage, ' to X:, ',long(self.lumi_position_entry[0].get_text()),\
              ' Y:,',long(self.lumi_position_entry[1].get_text()),' Z:,',\
              long(self.lumi_position_entry[2].get_text())
        self.lum.move_absolute(self.lum_stage,2,long(self.lumi_position_entry[0].get_text()))
        self.lum.move_absolute(self.lum_stage,3,long(self.lumi_position_entry[1].get_text()))
        self.lum.move_absolute(self.lum_stage,1,long(self.lumi_position_entry[2].get_text()))
		
        if (self.auto_det_section):
            self.view_detector_section(0)
		
        self.refresh_positions(0)


    #reload positions		
    def refresh_positions(self,widget):
        self.xposition += 1
        self.yposition += 1
        self.zposition += 1
        
        #text in the Luminos Tab
        page=self.notebook.get_current_page()
        if page == 0:
            self.lum_stage=self.luminos_combo_box.get_active()+1
            self.lumi_position_entry[0].set_text(str(self.lum.absolute_position(self.lum_stage,2)))
            self.lumi_position_entry[1].set_text(str(self.lum.absolute_position(self.lum_stage,3)))
            self.lumi_position_entry[2].set_text(str(self.lum.absolute_position(self.lum_stage,1)))
		
        #text in the mapping tab (z position in microns)
        if page ==1:
            self.stage_z_position_output.set_text(str(self.lum.absolute_position(self.z_pos_active_stage,1) / 10.))

    def index_to_enterred(self,widget):
        self.lum.set_position(self.lum_stage,1,long(self.lumi_position_entry[2].get_text()))
        self.lum.set_position(self.lum_stage,2,long(self.lumi_position_entry[0].get_text()))
        self.lum.set_position(self.lum_stage,3,long(self.lumi_position_entry[1].get_text()))
        print 'indexing mount ',self.lum_stage, ' to X:, ',self.lumi_position_entry[0].get_text(),\
              ' Y:,',self.lumi_position_entry[1].get_text(),' Z:,',self.lumi_position_entry[2].get_text()
		
    def renumber_mount(self,widget):
        print "self.nluminos = ", self.nluminos
        
        for i in range(self.nluminos):
            self.luminos_combo_box.remove_text(0)

        print 'renumbering mounts '
        self.nluminos = self.lum.renumber()	
		
        for i in range(self.nluminos):
            self.luminos_combo_box.append_text('Luminos Stage # %d' % (i+1))
		
        self.luminos_combo_box.set_active(0)

    def restart_mounts(self,widget):
        self.lum.restart()
        self.renumber_mount(0)		

    def home_dialog(self,stages,index):
        self.dialog=gtk.Dialog(title='Home stages dialog')
        OK_button=gtk.Button('OK')
        self.dialog.action_area.pack_start(OK_button,True,True)
        OK_button.show()
        OK_button.connect('clicked',self.home_stages,stages,index)
        Cancel_button=gtk.Button('Cancel')
        self.dialog.action_area.pack_start(Cancel_button,True,True)
        Cancel_button.show()
        Cancel_button.connect('clicked',self.dialog_destroy)
        Label=gtk.Label('\
        Warning: this action may cause the\n \
        reference positions of some stages\n \
        to drift due to the failure of home\n\
        trigger. Do NOT home fiber stages\n\
        unless there was a power outage.\n\
        ')
        self.dialog.vbox.pack_start(Label,True,True)
        Label.show()
        self.dialog.show() 
        
    def home_all_mount(self,widget):
        self.home_dialog(0,False)
    
    
    def home_mount(self,widget):
        self.home_dialog(self.lum_stage,False)

    def home_mount_index(self,widget):
        self.home_dialog(self.lum_stage,True)

    def home_all_index(self,widget):
        self.home_dialog(0,True)
        

    def home_stages(self,widget,stages,index_as_0):
        #pdb.set_trace()
        self.lum.home(stages,0,index_as_0)
        self.dialog.destroy()
        self.refresh_positions(0)
        

    def dialog_destroy(self,widget):
        self.dialog.destroy()

   

			
    def active_stages(self):
        active_stages=na.zeros(self.num_stages)
        for ii in range(self.num_stages):
            if (self.stage_check_button[ii].get_active()):
                self.all_stage[ii].active=1
                active_stages[ii]=1
            else:
                self.all_stage[ii].active=0
                
        return active_stages

    def z_pos_rbutton_callback(self,widge,data):
        self.z_pos_active_stage=data
        self.refresh_positions(0)

    def move_z_pos(self,widge,data):
        steps=self.z_position_spin_button.get_value_as_int()*10
        if data=='INC':
            self.lum.move_relative(self.z_pos_active_stage, 1, steps)
        else:
            self.lum.move_relative(self.z_pos_active_stage, 1, -steps)
        self.refresh_positions(0)

    def map_it_up(self,widget,data):
#        pdb.set_trace()
        active_stages=self.active_stages()
        if data ==0:
            self.using_new_FE=0
            if na.sum(active_stages)!=1:
                print 'check only 1 stage'
                return
            
        if data ==1:self.using_new_FE=1

        if (self.detector_configured):
            for ii in range(self.num_stages):
                if self.all_stage[ii].active==0:continue
                print 'doing map with mount ',self.all_stage[ii].name
                print ' with number of steps: ',self.stage_num_steps_spin_button[ii].get_value(), ' and spacing ',self.stage_xy_step_spin_button[ii].get_value(), ' in microns'
        else:
            print 'please configure detector'
            return

        if (data == 2):
            for ii in range(self.num_stages):
                if self.all_stage[ii].active==0:continue
                if self.last_map_params[ii][5] == 1:
                    print 'Please do a normal map first for',all_stage[ii].name
                    return
            
            for ii in range(self.num_stages):
                if self.all_stage[ii].active==0:continue                
                print 'params: ',self.last_map_params[ii]
#                self.lum.move_absolute(ii+1,2,self.last_map_params[ii][1])
#                self.lum.move_absolute(ii+1,3,self.last_map_params[ii][2])
##          self.getNextFrame()
            ranges=[self.last_map_params[ii][3] for ii in range(self.num_stages)]
            steps=[self.last_map_params[ii][4] for ii in range(self.num_stages)]
           # pdb.set_trace()            
            self.new_all_stage,self.map_error = self.mm.xy_square(active_stages,ranges,steps,\
                                                                          self.ij_range, self.display_as_mapped,self.using_new_FE)
            for ii in range(self.num_stages):
                if self.all_stage[ii].active==0:continue
                self.all_stage[ii].intensity = na.array(self.all_stage[ii].intensity) +\
                                               na.array(self.new_all_stage[ii].intensity)
            self.nMaps += 1

        else:
            self.nMaps = 1
##             self.getNextFrame()
            self.last_map_params=[]
            moved=0
            for ii in range(self.num_stages):
                temp=self.stage_xy_step_spin_button[ii].get_value()
                last_map_params_temp = [active_stages[ii],long(self.all_stage[ii].xy0[0]),\
                                            long(self.all_stage[ii].xy0[1]),\
                                            self.stage_num_steps_spin_button[ii].get_value()*temp,\
                                            temp,moved]  #moved =1 means stage has been moved either gauss or max.
                self.last_map_params.append(last_map_params_temp)
            #pdb.set_trace()
            xy_range=[self.last_map_params[ii][3] for ii in range(self.num_stages)]
            xy_step=[self.last_map_params[ii][4] for ii in range(self.num_stages)]
#            self.all_stage,self.map_error = self.mm.xy_square(active_stages,self.xy_range_spin_button.get_value(), self.xy_step_spin_button.get_value(), self.ij_range, self.display_as_mapped)
            self.all_stage,self.map_error = self.mm.xy_square(active_stages,xy_range,xy_step,self.ij_range,self.display_as_mapped,self.using_new_FE)    
        #pdb.set_trace()    
        if (self.map_error):
            return
        
        for ii in range(self.num_stages):
            if self.all_stage[ii].active==0:continue
#            self.all_stage[ii].intensity_fit, self.all_stage[ii].fit_params = \
#                gauss_fit(self.all_stage[ii].intensity,self.all_stage[ii].xarray,self.all_stage[ii].yarray)
            fitparams,self.all_stage[ii].intensity_fit = \
                gaussfit(self.all_stage[ii].intensity,returnfitimage=1,limitedmin=[False,True,True,True,True,True,True],\
                             minpars=[0,0,0,0,1,1,0])

#            print "self.allstage[ii].steps:",self.all_stage[ii].steps
#            print "self.allstage[ii].spacing:",self.all_stage[ii].spacing
#            print "self.allstage[ii].side:",self.all_stage[ii].side
            dummysteps = self.all_stage[ii].steps
            dummyspacing = self.all_stage[ii].spacing
            dummyxmin = na.min(self.all_stage[ii].xarray)
            dummyymin = na.min(self.all_stage[ii].yarray)
            self.all_stage[ii].fit_params = [fitparams[0],fitparams[1],fitparams[4]*dummysteps,fitparams[5]*dummysteps,\
                                                dummyxmin+fitparams[2]*dummysteps,dummyymin+fitparams[3]*dummysteps]

            self.all_stage[ii].last_max[0], self.all_stage[ii].last_max[1], self.all_stage[ii].last_max[3]=\
                self.mm.get_max(self.all_stage[ii].intensity,self.all_stage[ii].xarray,self.all_stage[ii].yarray)
        
            ##redundent here, could improve
            self.all_stage[ii].last_gauss = [long(self.all_stage[ii].fit_params[4]),\
                                                 long(self.all_stage[ii].fit_params[5]), \
                                                 self.all_stage[ii].fit_params[2], \
                                                 self.all_stage[ii].fit_params[3]]
            self.all_stage[ii].last_gauss_display = [long(self.all_stage[ii].fit_params[4]),long(self.all_stage[ii].fit_params[5]),\
                                                     self.all_stage[ii].fit_params[2]*2.354/250.,\
                                                     self.all_stage[ii].fit_params[3]*2.354/250.]

            self.stage_max_inten_posix[ii].set_text(str(self.all_stage[ii].last_max[0]))      #max x position
            self.stage_max_inten_posiy[ii].set_text(str(self.all_stage[ii].last_max[1]))      #max y position
            self.stage_max_intensity[ii].set_text(str(self.all_stage[ii].last_max[3]))        #max intensity
            self.stage_gauss_peak_posix[ii].set_text(str(self.all_stage[ii].last_gauss_display[0]))#gauss x peak
            self.stage_gauss_peak_posiy[ii].set_text(str(self.all_stage[ii].last_gauss_display[1]))#gauss y peak
            self.stage_gauss_fwhm_posix[ii].set_text(str(self.all_stage[ii].last_gauss_display[2]))#gauss x sigma
            self.stage_gauss_fwhm_posiy[ii].set_text(str(self.all_stage[ii].last_gauss_display[3]))#gauss y sigma
        self.plot_image()
        return

    def z_map_spin_button_changed(self,widget):
        self.lumi_spin_button[1].set_value(self.z_map_spin_button.get_value())

    def z_spin_button_changed(self,widget):
        self.z_map_spin_button.set_value(self.lumi_spin_button[1].get_value())

## JDM removal
##    def move_to_max_toggled(self,widget):
##        self.move_to_max = self.mapping_settings_check[0].get_active()
##        print 'self.move_to_max = ',self.move_to_max
##        if (self.move_to_max):
##            self.mapping_settings_check[1].set_active(False)	
	
##    def move_to_gauss_peak_toggled(self,widget):
##        self.move_to_gauss_peak = self.mapping_settings_check[1].get_active()
##        print 'self.move_to_gauss_peak = ',self.move_to_gauss_peak
##        if (self.move_to_gauss_peak):
##            self.mapping_settings_check[0].set_active(False)

    def display_as_mapped_toggled(self,widget):
        self.display_as_mapped = self.mapping_settings_check[0].get_active()
## JDM index above was 2.

##    def show_surface_after_toggled(self,widget):
##        self.show_surface_after = self.mapping_settings_check[3].get_active()

    def show_image_after_toggled(self,widget):
        self.show_image_after = self.mapping_settings_check[1].get_active()

    def move_to_max(self,widget):
        active_stages=self.active_stages()
        for ii in range(self.num_stages):
            if self.all_stage[ii].active==0:continue
            if self.last_map_params[ii][5] == 1:
                print 'please do a map first for ',self.all_stage[ii].name
                continue
            else:
                self.lum.move_absolute(self.all_stage[ii].stage,2,long(self.all_stage[ii].last_max[0]))
                self.lum.move_absolute(self.all_stage[ii].stage,3,long(self.all_stage[ii].last_max[1]))
#                self.lum.move_absolute(self.all_stage[ii].stage,1,long(self.all_stage[ii].last_max[2]))
                self.refresh_positions(0)
## JDM 2007 Jul26  SAVE positions for kludgy communcations with IRCam
##  this filename is defined in common.py
        self.lum.save_position(common.luminos_currents,self.nluminos)
        print "saving current positions in ~observe/mirc_python/.current_luminos_positions"


    def get_current_intensity(self,widget):
        active_stages=self.active_stages()
        if (self.detector_configured):
##JDM            self.getFrame()   
##	only add up light from Quadrant 1 (JDM 2007Jul04)
##            quad_range = self.ij_range
##            quad_range[1]=quad_range[1]/2 -1
##            quad_range[3]=quad_range[3]/2 -1
##     	    self.current_intensity = self.mm.get_intensity(quad_range);
            n_act_stages=0
            for ii in range(self.num_stages):
                if self.all_stage[ii].active!=0:n_act_stages+=1

            if n_act_stages == 1:
                inten_temp = self.mm.get_intensity(self.ij_range,usingnewFE =0)
                print inten_temp
                print self.ij_range
                for ii in range(self.num_stages):
                    if self.all_stage[ii].active==0:continue
                    self.stage_current_intensity[ii].set_text(str(inten_temp))
            else:
                inten_temp = self.mm.get_intensity(self.ij_range,usingnewFE =1)
                print inten_temp
                print self.ij_range
                for ii in range(self.num_stages):
                    if self.all_stage[ii].active==0:continue
                    self.stage_current_intensity[ii].set_text(str(inten_temp[ii]))
        else:
            print 'please configure detector'

    def show_last_surface(self,widget):
        if (self.map_error):
            print 'please take a map first'
            return
        
        print 'scipy not yet intalled!'
 		
    def show_last_image(self,widget):
        self.plot_image(gauss=False)
        
    def move_to_gauss_peak(self,widget):
        active_stages=self.active_stages()
        for ii in range(self.num_stages):
            if self.all_stage[ii].active==0:continue
            if self.last_map_params[ii][5] == 1:
                print 'please do a map first',self.all_stage[ii].name
                continue
            self.lum.move_absolute(self.all_stage[ii].stage,2,long(self.all_stage[ii].last_gauss[0]))
            self.lum.move_absolute(self.all_stage[ii].stage,3,long(self.all_stage[ii].last_gauss[1]))
#            self.lum.move_absolute(self.all_stage[ii].stage,1,long(self.all_stage[ii].last_max[2]))
            self.refresh_positions(0)

## JDM 2007 Jul26  SAVE positions for kludgy communcations with IRCam
##   defined in common.py
   	self.lum.save_position(common.luminos_currents,self.nluminos) 
 	print "saving current positions in ~/observe/mirc_python/.current_luminos_positions"

    def show_last_gauss(self,widget):
        if self.last_map_params[0] == 0:
            print 'please do a map first'
        else:
            self.plot_image()

## 	def img_changed(self,widget,letter):
## 		if letter == 'a':
## 			self.range_i[0]=self.a_spin_button.get_value_as_int()
## 		elif letter == 'b':
## 			self.range_i[1]=self.b_spin_button.get_value_as_int()
## 		elif letter == 'c':
## 			self.range_j[0]=self.c_spin_button.get_value_as_int()
## 		elif letter == 'd':
## 			self.range_j[1]=self.d_spin_button.get_value_as_int()
    def img_changed(self,widget,letter):
##         tokenDict = {'a': self.spin_button[0].get_value_as_int,
##                      'b': self.spin_button[1].get_value_as_int,
##                      'c': self.spin_button[2].get_value_as_int,
##                      'd':self.spin_button[3].get_value_as_int}
        tokenDict1 = {'a': 0,'b': 1,'c': 2,'d':3}
        tokenDict2 = {'a': 2,'b': 3,'c': 0,'d':1}
        
        self.ij_range[tokenDict2[letter]] = self.spin_button[tokenDict1[letter]].get_value_as_int()
        print letter, tokenDict2[letter], self.ij_range[tokenDict2[letter]]

    def view_detector_section(self,widget):
        if (self.detector_configured):
            #JDM makes everything a loop...	
            for i in range(self.do_loop_spin_button.get_value_as_int()):
                self.plot_exposure(section=True)
        else:
            print 'please configure detector'
			
    def view_whole_detector(self,widget):
        if (self.detector_configured):
            for i in range(self.do_loop_spin_button.get_value_as_int()):
                self.plot_exposure(section=False)
        else:
            print 'please configure detector'

    def save_image(self,widget):
        if (self.detector_configured):
            print 'set do_save_image to one, take exposure, then set it back to 0'
            self.ircc.doImageSave = 1
            self.ircc.updateDoImageSave()
            self.ircc.startExposure()
            self.ircc.doImageSave = 0
            self.ircc.updateDoImageSave()
        else:
            print 'please configure detector'

    def view_cross_section(self,widget):
        rcParams['interactive']=True        
        if (self.detector_configured):
            fig_cross = pl.figure(3)
            fig_cross.clf()
            a = fig_cross.add_subplot(111)
            canvas = FigureCanvas(fig_cross)
            canvas.queue_draw()
            for i in range(self.do_loop_spin_button.get_value_as_int()):
                self.getFrame()
                pl.xlabel('Cross sectrion across img[:][%s]' %self.e_spin_button.get_value_as_int())
                if i == 0:
                    self.lines, = pl.plot(common.dataArray[self.e_spin_button.get_value_as_int(), :], linewidth=1)
                else:
                    self.lines.set_ydata(common.dataArray[self.e_spin_button.get_value_as_int(), :])
                a.dataLim.update_numerix(self.lines.get_xdata(),self.lines.get_ydata(),True)
                a.autoscale_view()
                canvas.draw()
        else:
            print 'please configure detector'

    def run_do_loop(self,widget):
        if (self.detector_configured):
            for i in range(nloops):
                self.ircc.numberOfFrames = self.exp_time_spin_button.get_value_as_int()*nloops
                self.ircc.numberOfCoadds = self.ircc.numberOfFrames
                print 'sendStruct()'
                self.ircc.sendStruct()
                print 'resetCont()'
                self.ircc.resetCont()
                print 'setCont()'
                self.ircc.setCont()
                print'setBias()'
                self.ircc.setBias()
                self.getFrame()
                
                pl.plot(common.dataArray[:,row])

            print 'run do_loop across img[:][',self.e_spin_button.get_value_as_int(),'] for ',\
                  self.do_loop_spin_button.get_value(),' iterations'
        else:
            print 'please configure detector'

    def start_exposure(self, widget):
        if widget.get_label() == 'Start exposure':
            widget.set_label('Stop exposure')
            print "self.ircc.continuousReadout =", self.ircc.continuousReadout
            if not self.ircc.continuousReadout: self.ircc.continuousReadout = 1
            self.ircc.sendStruct()
            #added a sleep between the two commands
            #without sleep startExp fails
            time.sleep(1)
            self.ircc.startExposure()
        else:
            widget.set_label('Start exposure')
            self.ircc.stopExposure()


    def take_background(self, widget):
        self.ircc.getBackgroundFrame()
    
    def reset_background(self, action):
        self.ircc.resetBackgroundFrame()

    def use_background(self, widget):
        self.ircc.useBackgroundFrame()

    def update_xchan_position(self,widget):
        #pdb.set_trace()
        self.ircc.updatexchanposition()
        print "xchan positions updated:",common.xchanpos
        self.mm.xchan_positions(common.xchanpos)
        for ii in range(self.num_stages):
            self.xchan_position_entry[ii].set_text(str(common.xchanpos[ii]))

    def change_number_of_frames(self,widget):
##         self.ircc.numberOfFrames = self.exp_time_spin_button.get_value_as_int()
##         self.ircc.numberOfCoadds = self.ircc.numberOfFrames
        common.numberOfCumulatedImages = self.exp_time_spin_button.get_value_as_int()
##         print 'number of frames/coadds is set to:', self.ircc.numberOfFrames
        
    def configure_detector(self,widget):
        if self.first_time_configured:
            print 'first configure'
            self.first_time_configured = 0
        self.ircc.rows = 256
        self.ircc.cols = 254
        self.ircc.rowOffset = 0
        self.ircc.colOffset = 1
        self.ircc.nreads = 4
        self.ircc.numberOfCoadds = 10
        self.ircc.framesPerReset = 11
        self.ircc.expTime = 0
        self.ircc.numberOfFrames = 11
        self.ircc.byteSwapping  =False
        self.ircc.doReset = True
        self.ircc.doDeinterlace = False
        self.ircc.doImageSave = False
        self.ircc.daqRunning = False
        self.ircc.read = False
        self.ircc.voffset = 4.0
        self.ircc.vreset = 0.6
        self.ircc.vd = 5.0
        self.ircc.ictl = 3.3
        self.ircc.continuousReadout = 1
        
        self.ircc.imageDirectory = '/data/'
        self.ircc.imageFilename = 'fiberExplorer.fit'
        
        self.ircc.useBackground = False
        self.ircc.numberOfBackgroundFrames = 1000

        common.rows = self.ircc.rows
        common.cols = self.ircc.cols
        common.rowOffset = self.ircc.rowOffset
        common.colOffset = self.ircc.colOffset

        print 'sendStruct()'
        self.ircc.sendStruct()
        time.sleep(.5)
        print 'resetCont()'
        self.ircc.resetCont()
        time.sleep(.5)
        print 'setCont()'
        self.ircc.setCont()
        time.sleep(.5)
        print'setBias()'
        self.ircc.setBias()		
        time.sleep(.5)
		
##         self.dat.do_image_show = 0
##         self.dat.do_image_save = 0
##         self.g = Graphics()
        
        self.detector_extent = (-0.5,255.5,-0.5, 255.5)
        common.dataArray = na.zeros((self.ircc.rows, self.ircc.cols), dtype=na.float32)
        self.detector_extent = (-0.5,self.ircc.cols+0.5,-0.5, self.ircc.rows+0.5)
        self.detector_configured = 1

    def load_detector_config(self,widget):
        print 'getStruct()'
        self.ircc.getStruct()

        self.ircc.imageFilename = 'fiberExplorer.fit'
        self.ij_range[0] = 0
        self.ij_range[1] = self.ircc.rows
        self.ij_range[2] = 0
        self.ij_range[3] = self.ircc.cols

        self.spin_button[2].set_value(0)
        self.spin_button[3].set_value(self.ircc.rows)
        self.spin_button[0].set_value(0)
        self.spin_button[1].set_value(self.ircc.cols)

        self.detector_extent = (-0.5,self.ircc.cols-0.5,-0.5,self.ircc.rows-0.5)
        print self.ircc.cols, self.ircc.rows
        common.dataArray = na.zeros((self.ircc.rows, self.ircc.cols), dtype=na.float32)
        self.detector_configured = 1
        
        
    def kill_server(self,widget):
        self.ircc.killServer()
        self.detector_configured = 0

    def plot_image(self,gauss=True):

        if (self.map_error):
            print 'please take a map first'
            return
		
        rcParams['interactive']=True

        n_act_stages=0
        for ii in range(self.num_stages):
            if self.all_stage[ii].active !=0: n_act_stages+=1

            
	pl.figure(4,figsize=(n_act_stages*5.5,5),dpi=50)
        pl.clf()
        jj=1
	for ii in range(self.num_stages):
            if self.all_stage[ii].active==0:continue
            delta = self.all_stage[ii].xarray[1]-self.all_stage[ii].xarray[0]
            xmin = self.all_stage[ii].xarray[0]-delta/2.
            xmax = self.all_stage[ii].xarray[-1]+delta/2.
            ymin = self.all_stage[ii].yarray[0]-delta/2.
            ymax = self.all_stage[ii].yarray[-1]+delta/2.   # replaced -delta/2 by +delta/2 
            self.extent = (xmin,xmax,ymin,ymax)
        
            #pl.figure(10+ii,dpi=50)
            pl.subplot(1,n_act_stages,jj)
            jj=jj+1		
 
            pl.imshow(self.all_stage[ii].intensity,cmap=cm.hot,extent=self.extent,origin='lower',\
                      vmin =self.all_stage[ii].intensity.min(),\
                      vmax =self.all_stage[ii].intensity.max(),interpolation='nearest',aspect='auto')
            if (gauss):
                pl.contour(self.all_stage[ii].intensity_fit,cmap=cm.bone,extent=self.extent,origin='lower')
                title = 'Intensity Image w/ Gauss Contour, nMaps = %d ' %self.nMaps+self.all_stage[ii].name
                pl.title(title,fontsize=12)
            else:
                title = 'Intensity vs Position Image, nMaps = %d ' %self.nMaps+self.all_stage[ii].name
                pl.title(title)

            if self.first_time_plot:
                pl.xlabel('X Position in Steps')
                pl.ylabel('Y Position in Steps')
                pl.ylabel('Y Position in Steps') #advance the frame
		
    def plot_exposure(self,section=False):
        self.getFrame()
        rcParams['interactive']=True
        
        pl.figure(1)
        if (section):
            self.detector_extent = (self.ij_range[2]-0.5,self.ij_range[3]-0.5,\
                                    self.ij_range[0]-0.5,self.ij_range[1]-0.5)
##             self.reduced_exposure = na.transpose(na.transpose(common.dataArray[self.ij_range[0]:self.ij_range[1]+1].copy())[self.ij_range[2]:self.ij_range[3]+1].copy())
            self.reduced_exposure = common.dataArray[self.ij_range[0]:self.ij_range[1]+1,self.ij_range[2]:self.ij_range[3]+1].copy()
            kludgemedian=mlab.median(mlab.median(1.0*self.reduced_exposure))
            tempvar=na.transpose(1.0*self.reduced_exposure-kludgemedian)
            kludgesum = tempvar.sum()
            tempvar=tempvar/kludgesum
            print 'Median of Section: ', kludgemedian
            print 'flux fraction map: '
            # print fix(tempvar*100.0)
            # print (tempvar*100.0).astype("Int32")
            pl.imshow((self.reduced_exposure),interpolation='nearest', \
                cmap=cm.gray,extent=self.detector_extent,origin='lower',aspect='auto')
            pl.title('Section Exposure w/ max: %e and min %e' % (self.reduced_exposure.max(),\
                                                              self.reduced_exposure.min()))
        else:
            self.detector_extent = (-0.5,self.ircc.cols-0.5,-0.5,self.ircc.rows-0.5)
            pl.imshow(common.dataArray,cmap=cm.gray,extent=self.detector_extent, origin='lower',\
                      interpolation='nearest',aspect='auto') 	
            pl.title('Exposure w/ max: %e and min %e' % (common.dataArray.max(), common.dataArray.min()))
            

        if self.first_time_exposure:
            pl.xlabel('dat.img[x][]')
            pl.ylabel('dat.img[][y]')
            pl.ylabel('dat.img[][y]') # to advance the frame
            self.first_time_exposure = 0

    def getFrame(self):
        #variable that is use to check if the available frame is a new frame
        coadd = common.coaddCount
        cnt = 0
        #img = na.zeros((common.numberOfCumulatedImages, common.rows, common.cols), type = na.Float32)
##         tmp = na.zeros((common.rows, common.cols), type = na.Float32)
        tmp = na.zeros((self.ircc.rows, self.ircc.cols), dtype = na.float32)
        for i in range(common.numberOfCumulatedImages):
            while coadd == common.coaddCount:
                coadd = self.ircc.coaddCount()
                cnt += 1
                time.sleep(.2)
                # a new frame is available, read the new frame
            self.ircs.readFrame()
            common.coaddCount = coadd
            tmp += common.dataArray
            #img[i, :, :] = common.dataArray
        common.dataArray = tmp/common.numberOfCumulatedImages

    def getFrameOld(self):
        #variable that is use to check if the available frame is a new frame
        coadd = common.coaddCount
        cnt = 0
        while coadd == common.coaddCount:
            coadd = self.ircc.coaddCount()
            cnt += 1
            time.sleep(.2)
        # a new frame is available, read the new frame
        self.ircs.readFrame()
        common.coaddCount = coadd
		
    def getNextFrame(self):
        #variable that is use to check if the available frame is a new frame
        common.coaddCount = self.ircc.coaddCount()
        coadd = common.coaddCount
        cnt = 0
        while coadd < common.coaddCount+2:
            coadd = self.ircc.coaddCount()
            cnt += 1
            time.sleep(.2)
        # a new frame is available, read the new frame
        self.ircs.readFrame()
        common.coaddCount = coadd
        if common.numberOfCumulatedImages>1:
            cnt = 0
            tmp = common.dataArray
            for i in range(common.numberOfCumulatedImages-1):
                while coadd == common.coaddCount:
                    coadd = self.ircc.coaddCount()
                    cnt += 1
                    time.sleep(.2)
                    # a new frame is available, read the new frame
                self.ircs.readFrame()
                common.coaddCount = coadd
                tmp += common.dataArray
            common.dataArray = tmp/common.numberOfCumulatedImages
            
    def getNextFrameOld(self):
        #variable that is use to check if the available frame is a new frame
        common.coaddCount = self.ircc.coaddCount()
        coadd = common.coaddCount
        cnt = 0
        while coadd != common.coaddCount+1:
            coadd = self.ircc.coaddCount()
            cnt += 1
            time.sleep(.2)
        # a new frame is available, read the new frame
        self.ircs.readFrame()
        common.coaddCount = coadd

    def destroy(self, widget):
        gtk.main_quit()
#        x=time.localtime()
#        filename=str(x[0])+'_'+str(x[1])+'_'+str(x[2])+'.lum'
#        self.lum.save_position(self.path+self.lum_dir+'/'+filename,self.nluminos)
#        self.lum.save_position(self.path+self.lum_dir+'/'+self.lum_stage_file,self.nluminos)
#        print "save info to %s and %s" % (filename,self.lum_stage_file)
		
    def __init__(self, test = None):

#        self.mm = mircMapping.mircMapping()
        self.mm=mircMappingXchan.mircMapping()
        self.ircs = IRCamSocket.IRCamSocket()
        self.ircc = IRCamCommands.IRCamCommands()
	self.lum = common.lum        
        self.first_time_configured = 1
        self.first_time_exposure = 1
        self.first_time_plot = 1
        self.display_as_mapped=1
        self.stages = [1,2,3,4,5,6]       #change to [1,2,3,4,5,6] for 6 beams
        #self.num_stages=4              #change to 6 for 6 beams
	self.nluminos = self.lum.renumber()
	self.num_stages=self.nluminos
        self.z_pos_active_stage=1        #in mapping tab, the active z position radio button
        self.lum_stage=1               #in luminos tab, the active stage #
        self.lum_stage_file=common.luminos_currents[1]
#        self.lum_stage_file='stage_positions.lum'
#        self.path=os.path.abspath('')
#        self.lum_dir='/lum_stage_positions'



        #pass self.num_stages to mircMappingXchan
        self.mm.stages_number(self.num_stages)

## initialises the serial connections with the luminos and zaber stages


## FIRST DO LUMINOS
	print 'First trying Luminos Mounts....'
##         self.lum = controlMountSocket.mountControl(common.luminosPort, common.luminosNAxis)
#        self.lum = common.lum
##         self.lum = controlMount.mountControl(common.luminosPort, common.luminosBaud, common.luminosNAxis)
##         self.lum.configure()
        time.sleep(.3) 
        self.nluminos = self.lum.renumber()
        print "self.nluminos = ", self.nluminos
        
#        if self.nluminos != 0:
            #try to index stage positions at each startup
#            file=self.path+self.lum_dir+'/'+self.lum_stage_file
#            try:
#                pos=open(file,'r')
#            except:
#                print file+' does not exist'
#                return -1
#            else:
#                print 'setting initial stage positions...'
#                 for ii in range(1,self.nluminos+1):
#                    for jj in range(1,4):
#                        line=pos.readline()
#                        li=int(line)
#                        self.lum.set_position(ii,jj,li)
#                pos.close()



	print 'Now trying Ealing Mounts....'
##         self.zab = controlMountSocket.mountControl(common.zaberPort, common.zaberNAxis)
        self.zab = common.zab
##         self.zab = controlMount.mountControl(common.zaberPort, common.zaberBaud, common.zaberNAxis)
##         self.zab.configure()
	time.sleep(.3)
        self.nzaber = self.zab.renumber()
        print "self.nzaber = ", self.nzaber

        #test variables: (can be deleted)
        self.xposition = 0
        self.yposition = 0
        self.zposition = 0	
        self.current_intensity = 0
		
        self.first_time = 1

        self.last_map_params = [0]*5
		
        self.x = na.arange(50000.,55100.,100.)
        self.y = na.arange(40000.,45100.,100.)
        x_mesh,y_mesh = meshgrid(self.x,self.y)
		
        #test intensity
        base = 10.
        amp = 50.
        sigma = 1000.
        mux = 52500.
        muy = 42500.
		
        self.intensity = base + amp*na.exp(-0.5*(((x_mesh-mux)**2)/(sigma**2) + \
                                              ((y_mesh-muy)**2)/(sigma**2)))
        self.intensity_fit = 0
        self.fit_params = 0
        self.map_error = True
        
        self.i = na.arange(0,256,1)
        self.j = na.arange(0,256,1)
        self.j_mesh,self.i_mesh = meshgrid(self.j,self.i)
        
        self.g = 0

        #x, y, z, intensity
        self.last_max = [0, 0, 0, 0]
        #x, y, sigma_x, sigma_y
        self.last_gauss = [0, 0, 0, 0]
        self.last_gauss_display = [0, 0, 0, 0]
        
        self.ij_range = [0, 256, 0, 256]
        print self.ij_range
        
        self.detector_configured = 0
        
        #create window
        self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
        		
        #give it a name
        self.window.set_title("Fiber Explorer")
		
        #identify the destroy signal
        #self.window.connect("destroy", lambda x: gtk.main_quit())
        self.window.connect("destroy", self.destroy)
        
        #show the window
        self.window.show()				
		
        #create a notebook to sit in the main window
        self.notebook = gtk.Notebook()
        	
        #set tabs along the top
        self.notebook.set_tab_pos(gtk.POS_TOP)
        	
        #attach the notebook to the window
        self.window.add(self.notebook)

        #show the notebook
        self.notebook.show()
        
        #create little tables to sit within each notebook page
        self.luminos_table = gtk.Table(8,8,False)
        self.luminos_table.show()
        luminos_label = gtk.Label('Luminos Control')
        self.notebook.append_page(self.luminos_table,luminos_label)
		
        self.mapping_table = gtk.Table(3,5,False)
        self.mapping_table.show()
        mapping_label = gtk.Label('Fiber Mapping')
        self.notebook.append_page(self.mapping_table,mapping_label)

        self.detector_table = gtk.Table(8,8,False)
        self.detector_table.show()
        detector_label = gtk.Label('Detector Control')
        self.notebook.append_page(self.detector_table,detector_label)

        self.zaber_table = gtk.Table(8,8,False)
        self.zaber_table.show()
        self.zaber_label = gtk.Label('Ealing Control')
        self.notebook.append_page(self.zaber_table,self.zaber_label)

        

        self.all_stage=[]
        for ii in range(self.num_stages):
            #pdb.set_trace()
            self.all_stage.append(mircMappingXchan.Stage_Info(1,ii+1,20,2))   #active, stage,side,spacing
		
		
        ##############  LUMINOS TAB   ###############
        
        self.luminos_combo_box = gtk.combo_box_new_text()
        self.luminos_combo_box.show()
        self.luminos_combo_box.set_wrap_width(1)
        for i in range(self.nluminos):
            self.luminos_combo_box.append_text('Luminos Stage # %d' % (i+1))
        self.luminos_combo_box.set_active(self.lum_stage-1)
        self.luminos_combo_box.connect("changed",self.luminos_menu_changed)
        self.luminos_table.attach(self.luminos_combo_box,0,1,0,1,xoptions = False|True,\
                                  yoptions = False|True,xpadding = 10, ypadding = 10)
        
        #joystick for moving x an d  in and out
		
        self.lumi_joystick_table = gtk.Table(5,3,True)
        self.luminos_table.attach(self.lumi_joystick_table,0,1,1,2,xoptions = False|True,\
                                  yoptions = False|True)
                                             
        lbls = ['LEFT', 'RIGHT', 'UP', 'DOWN', 'IN', 'OUT']
        arrows = [gtk.ARROW_LEFT, gtk.ARROW_RIGHT, gtk.ARROW_UP, gtk.ARROW_DOWN,\
                 gtk.ARROW_UP, gtk.ARROW_DOWN]
        xy = [[0,1,1,2], [2,3,1,2], [1,2,0,1], [1,2,2,3], [4,5,0,1], [4,5,2,3]]
        self.lumi_button = []
        for i in range(6):
            self.lumi_button.append(self.create_arrow_button(arrows[i], gtk.SHADOW_IN))
            self.lumi_button[i].connect('clicked', self.move, lbls[i])
            self.lumi_joystick_table.attach(self.lumi_button[i],xy[i][0],xy[i][1],xy[i][2],\
                                            xy[i][3], xoptions = False,yoptions = False, \
                                            xpadding = 2, ypadding = 2)
				
        #add labels to joystick buttons
	self.lumi_xyz_label = []
        lbl = ['XY', 'Z']
        xy = [[1,2,1,2,], [4,5,1,2]]
        for i in range(2):
            self.lumi_xyz_label.append(gtk.Label(lbl[i]))
            self.lumi_xyz_label[i].show()
            self.lumi_joystick_table.attach(self.lumi_xyz_label[i],xy[i][0],xy[i][1],xy[i][2],\
                                            xy[i][3], xoptions = False,\
                                            yoptions = False,xpadding = 2, ypadding = 2)
        self.lumi_joystick_table.show()
        

        #add spin table to the luminos_table in it's own table with lables
        self.lumi_spin_button_table = gtk.Table(2,3,False)
        #add spin_table to luminos table
        self.luminos_table.attach(self.lumi_spin_button_table,1,2,0,2,xoptions = False,\
                                  yoptions = False,xpadding = 2, ypadding = 2)
        #now add 'spin buttons' to select step size of xy and z motion
        self.lumi_adjustment = []
        self.lumi_spin_button = []
        val = [2., 10.]
        lower = [0.004, 0.1]
        upper = [50., 500.]
        digits = [3, 1]
        
        for i in range(2):
            self.lumi_adjustment.append(gtk.Adjustment(value=val[i], lower=lower[i], \
                                                       upper=upper[i], step_incr=lower[i], \
                                                       page_incr=.5, page_size=0))
            self.lumi_spin_button.append(gtk.SpinButton(adjustment=self.lumi_adjustment[i],\
                                                       climb_rate=0.0, digits=digits[i]))
            #constrain entered values to numbers (not letters)
            self.lumi_spin_button[i].set_numeric(numeric=True)                        
            #do not wrap from 100 microns to 0.
            self.lumi_spin_button[i].set_wrap(wrap=False)              
            #if user enters a non-multiple of 0.004, the number is rounded off
            self.lumi_spin_button[i].set_snap_to_ticks(snap_to_ticks=True)
            #only change the value entered if it is a number within range
            self.lumi_spin_button[i].set_update_policy(gtk.UPDATE_IF_VALID)
            self.lumi_spin_button[i].show()
            #add spin buttons and lables to spin_table
            self.lumi_spin_button_table.attach(self.lumi_spin_button[i],1,2,i,i+1,\
                                               xpadding = 2, ypadding = 2)
            
        self.lumi_label = []
        lbls = ['XY step size:', 'Z step size:', 'microns']
        xy = [[0,1,0,1], [0,1,1,2], [2,3,0,2]]
        for i in range(3):            
            self.lumi_label.append(gtk.Label(lbls[i]))
            self.lumi_label[i].show()
            self.lumi_spin_button_table.attach(self.lumi_label[i], xy[i][0],xy[i][1],xy[i][2],\
                                            xy[i][3],xpadding = 2, ypadding = 2)
        self.lumi_spin_button_table.show()  
        
        #Directly enter position for Luminos:
        self.lumi_position_entry = []
        self.lumi_position_entry_label = []
        #create a table to hold these
        self.lumi_position_table = gtk.Table(4,3,False)
        
        lbls = ['X pos in steps', 'Y pos in steps', 'Z pos in steps']
        for i in range(3):            
            self.lumi_position_entry.append(gtk.Entry(max=6))
            self.lumi_position_entry[i].set_text('0')
            self.lumi_position_entry[i].show()
            self.lumi_position_entry_label.append(gtk.Label(lbls[i]))
            self.lumi_position_entry_label[i].show()
            self.lumi_position_table.attach(self.lumi_position_entry[i], 1, 2, i, i+1,\
                                            xoptions = False, yoptions = False,\
                                            xpadding = 2, ypadding = 2)
            self.lumi_position_table.attach(self.lumi_position_entry_label[i], 0, 1, i, i+1,\
                                            xoptions = False,\
                                            yoptions = False,xpadding = 2, ypadding = 2)
        self.lumi_position_table.show()
		
        #Attach position_tabel to luminos_table
        self.luminos_table.attach(self.lumi_position_table,0,1,2,3,xoptions = False|True,\
                                  yoptions = False|True,xpadding = 2, ypadding = 2)

        #create a table  buttons
        self.lumi_position_button_table = gtk.Table(2,4,False)
        self.lumi_position_button_table.show()
        #Add more control buttons to move to an enterred position
        xy = [[0,1,0,1], [0,1,1,2], [0,1,2,3], [0,1,3,4],[1,2,0,1], [1,2,1,2], [1,2,2,3],[1,2,3,4]]
        lbls = ['Home','Move to', 'Refresh', 'Index as','Home and Index',\
                'Recall last positions','Save all positions to file','Recall all positions from file']
        tokenDict = {lbls[0]:self.home_mount,lbls[1]:self.move_to_enterred,\
                     lbls[2]:self.refresh_positions, lbls[3]:self.index_to_enterred,\
                     lbls[4]:self.home_mount_index, lbls[5]:self.recall_last_posi,\
                     lbls[6]:self.save_pos, lbls[7]:self.recall_pos}
        self.lumi_position_button = []
        for i in range(len(lbls)):
            self.lumi_position_button.append(gtk.Button(lbls[i]))
            self.lumi_position_button[i].connect("clicked", tokenDict[lbls[i]])
            self.lumi_position_button[i].show()
            self.lumi_position_button_table.attach(self.lumi_position_button[i], xy[i][0],xy[i][1],\
                                                xy[i][2],xy[i][3],xpadding = 2, ypadding = 2)
        self.luminos_table.attach(self.lumi_position_button_table,1,2,2,3,xoptions = False|True,\
                                  yoptions = False|True,xpadding = 2, ypadding = 2)
               
        self.lumi_renumber_home_all_table = gtk.Table(1,4,False)
        self.lumi_renumber_home_all_table.show()
        xy = [[0,1,0,1], [1,2,0,1], [2,3,0,1],[3,4,0,1]]
        lbls = ['Home All','Home All and Index', 'Renumber', 'Restart']
        tokenDict = {lbls[0]:self.home_all_mount, lbls[1]:self.home_all_index,\
                     lbls[2]:self.renumber_mount, lbls[3]:self.restart_mounts}
        self.lumi_position_all_button = []
        for i in range(len(xy)):
            self.lumi_position_all_button.append(gtk.Button(lbls[i]))
            self.lumi_position_all_button[i].connect("clicked", tokenDict[lbls[i]])
            self.lumi_position_all_button[i].show()
            self.lumi_renumber_home_all_table.attach(self.lumi_position_all_button[i], \
                                                     xy[i][0],xy[i][1],xy[i][2],xy[i][3],\
                                                     xoptions = False, yoptions=False, \
                                                     xpadding = 2, ypadding = 2)
        
        self.luminos_table.attach(self.lumi_renumber_home_all_table,1,2,3,4,xoptions = False|True,\
                                  yoptions = False|True,xpadding = 2, ypadding = 2)        

        #toggle switch to automatically view detector section
        self.auto_det_section = 0
        self.auto_det_section_check = gtk.CheckButton('View detector section after each move')
        self.auto_det_section_check.show()
        self.auto_det_section_check.connect("toggled",self.auto_det_section_toggled)
        
        self.luminos_table.attach(self.auto_det_section_check,0,1,3,4,xoptions = False|True,\
                                  yoptions = False|True,xpadding = 2, ypadding = 2)
        
        #############################################
    

        #############  MAPPING TAB  #################		

	##########################add action buttons########################################
	self.mapping_action_box=gtk.HBox(True,0)
        self.perform_map_button=gtk.Button("Perform Map")
        self.perform_map_button.connect('clicked',self.map_it_up,0)    #  0 means using old FE; 1 mean using
        self.mapping_action_box.pack_start(self.perform_map_button,True,False,5) #new FE. 2 mean add to last
        self.perform_map_button.show()                                          

        self.perform_map_xchan_button=gtk.Button("Perform Map(Xchan)")
        self.perform_map_xchan_button.connect('clicked',self.map_it_up,1)
        self.mapping_action_box.pack_start(self.perform_map_xchan_button,True,False,5)
        self.perform_map_xchan_button.show()

        self.add_to_last_button=gtk.Button("Add to last")
        self.add_to_last_button.connect('clicked',self.map_it_up,2)        
        self.mapping_action_box.pack_start(self.add_to_last_button,True,False,5)
        self.add_to_last_button.show()

        self.move_to_max_button=gtk.Button("Move to max")
        self.move_to_max_button.connect('clicked',self.move_to_max)        
        self.mapping_action_box.pack_start(self.move_to_max_button,True,False,5)
        self.move_to_max_button.show()

        self.move_to_gauss_peak_button=gtk.Button("Move to Gauss peak")
        self.move_to_gauss_peak_button.connect('clicked',self.move_to_gauss_peak)
        self.mapping_action_box.pack_start(self.move_to_gauss_peak_button,True,False,5)
        self.move_to_gauss_peak_button.show()

        self.image_of_last_map_button=gtk.Button("Image of last map")
        self.image_of_last_map_button.connect('clicked',self.show_last_image)
        self.mapping_action_box.pack_start(self.image_of_last_map_button,True,False,5)
        self.image_of_last_map_button.show()

        self.mapping_action_box.show()
        self.mapping_table.attach(self.mapping_action_box,0,7,0,1,xoptions=False,\
                                 yoptions=False,xpadding =0, ypadding = 10)

        ############################xy stage labels#####################################
        self.stage_num_steps_label = gtk.Label('Num. of steps:')
        self.stage_num_steps_label.show()
        self.stage_xy_step_label = gtk.Label('XY Step(micron): ')
        self.stage_xy_step_label.show()
        self.max_intensity_positionx_label = gtk.Label('Max x: ')
        self.max_intensity_positionx_label.show()
        self.max_intensity_positiony_label = gtk.Label('Max y: ')
        self.max_intensity_positiony_label.show()
        self.gauss_peak_positionx_label = gtk.Label('Gauss peak x: ')
        self.gauss_peak_positionx_label.show()
        self.gauss_peak_positiony_label = gtk.Label('Gauss peak y: ')
        self.gauss_peak_positiony_label.show()
        self.gauss_fwhm_positionx_label = gtk.Label('FWHM x(micron): ')
        self.gauss_fwhm_positionx_label.show()
        self.gauss_fwhm_positiony_label = gtk.Label('FWHM y(micron): ')
        self.gauss_fwhm_positiony_label.show()
        self.max_intensity_label = gtk.Label('Max intensity: ')
        self.max_intensity_label.show()
        self.get_intensity_button = gtk.Button('Get current intensity')
        self.get_intensity_button.connect('clicked',self.get_current_intensity)
        self.get_intensity_button.show()
        self.empty_space_label=gtk.Label('')
        self.empty_space_label.show()

        self.stage_xy_range_step_table=gtk.Table(11,1)
        self.stage_xy_range_step_table.show()
        self.stage_xy_range_step_table.attach(self.empty_space_label,0,1,0,1,xpadding=2,ypadding=6)
        self.stage_xy_range_step_table.attach(self.stage_num_steps_label,0,1,1,2,xpadding=2,ypadding=6)
        self.stage_xy_range_step_table.attach(self.stage_xy_step_label,0,1,2,3,xpadding=2,ypadding=6)
        self.stage_xy_range_step_table.attach(self.max_intensity_positionx_label,0,1,3,4,xpadding=2,ypadding=6)
        self.stage_xy_range_step_table.attach(self.max_intensity_positiony_label,0,1,4,5,xpadding=2,ypadding=6)
        self.stage_xy_range_step_table.attach(self.gauss_peak_positionx_label,0,1,5,6,xpadding=2,ypadding=6)
        self.stage_xy_range_step_table.attach(self.gauss_peak_positiony_label,0,1,6,7,xpadding=2,ypadding=6)
        self.stage_xy_range_step_table.attach(self.gauss_fwhm_positionx_label,0,1,7,8,xpadding=2,ypadding=6)
        self.stage_xy_range_step_table.attach(self.gauss_fwhm_positiony_label,0,1,8,9,xpadding=2,ypadding=6)
        self.stage_xy_range_step_table.attach(self.max_intensity_label,0,1,9,10,xpadding=2,ypadding=6)
        self.stage_xy_range_step_table.attach(self.get_intensity_button,0,1,10,11,xpadding=2,ypadding=6)
        self.mapping_table.attach(self.stage_xy_range_step_table,0,1,1,2,xoptions = False,\
                                  yoptions = False,xpadding = 2, ypadding = 2)

        ###############################add six luminos stages############################
        ##############################First define all the variables
        self.stage_xy_map_table=[]
        self.stage_check_button=[]
        self.stage_num_steps_adjustment=[]
        self.stage_num_steps_spin_button=[]
        self.stage_xy_step_adjustment=[]
        self.stage_xy_step_spin_button=[]
        self.stage_max_inten_posix=[]
        self.stage_max_inten_posiy=[]
        self.stage_gauss_peak_posix=[]
        self.stage_gauss_peak_posiy=[]
        self.stage_gauss_fwhm_posix=[]
        self.stage_gauss_fwhm_posiy=[]
        self.stage_max_intensity=[]
        self.stage_current_intensity=[]
        self.stage_labels=['Stage # 1','Stage # 2','Stage # 3','Stage # 4','Stage # 5','Stage # 6']
        widget_width=20
        widget_height=32
        ##############################create components for all six stages
        for ii in range(self.num_stages): 
            ###get stage positions
            
            self.stage_xy_map_table.append(gtk.Table(11,1))
            self.stage_xy_map_table[ii].show()
            ###check button
            self.stage_check_button.append(gtk.CheckButton(self.stage_labels[ii]))
            self.stage_xy_map_table[ii].attach(self.stage_check_button[ii],0,1,0,1,xpadding=2,ypadding=2)
            self.stage_check_button[ii].show()
            self.stage_check_button[ii].set_active(True)
        
            ###range and step
            self.stage_num_steps_adjustment.append( gtk.Adjustment(value=7, lower=0, upper=500,\
                                                  step_incr=1, page_incr=2, page_size=0))
            self.stage_num_steps_spin_button.append(gtk.SpinButton(adjustment=self.stage_num_steps_adjustment[ii], \
                                                   climb_rate=0.0, digits=0))
            #constrain entered values to numbers (not letters)
            self.stage_num_steps_spin_button[ii].set_numeric(numeric=True)
            #do not wrap around.
            self.stage_num_steps_spin_button[ii].set_wrap(wrap=False)
            #if user enters a non-multiple of 0.1, the number is rounded off
            self.stage_num_steps_spin_button[ii].set_snap_to_ticks(snap_to_ticks=True)
            #only change the value entered if it is a number within range
            self.stage_num_steps_spin_button[ii].set_update_policy(gtk.UPDATE_IF_VALID)
            self.stage_num_steps_spin_button[ii].set_size_request(widget_width,widget_height)
            self.stage_num_steps_spin_button[ii].show()
        
            self.stage_xy_step_adjustment.append(gtk.Adjustment(value=6, lower=0, upper=500, \
                                                 step_incr=1, page_incr=1, page_size=0))
            self.stage_xy_step_spin_button.append(gtk.SpinButton(adjustment=self.stage_xy_step_adjustment[ii], \
                                                  climb_rate=0.0, digits=0))
            #constrain entered values to numbers (not letters)
            self.stage_xy_step_spin_button[ii].set_numeric(numeric=True)
            #do not wrap from 100 microns to 0.
            self.stage_xy_step_spin_button[ii].set_wrap(wrap=False)
            #if user enters a non-multiple of 0.1, the number is rounded off
            self.stage_xy_step_spin_button[ii].set_snap_to_ticks(snap_to_ticks=True)
            #only change the value entered if it is a number within range
            self.stage_xy_step_spin_button[ii].set_update_policy(True)
            self.stage_xy_step_spin_button[ii].set_size_request(widget_width,widget_height)
            self.stage_xy_step_spin_button[ii].show()
            self.stage_xy_map_table[ii].attach(self.stage_num_steps_spin_button[ii],0,1,1,2,xpadding = 2, ypadding = 4)
            self.stage_xy_map_table[ii].attach(self.stage_xy_step_spin_button[ii],0,1,2,3,xpadding = 2, ypadding = 4)
        
            ###max x and y
            self.stage_max_inten_posix.append(gtk.Entry())
            self.stage_max_inten_posix[ii].set_size_request(widget_width,widget_height)
            self.stage_max_inten_posix[ii].show()
            self.stage_max_inten_posix[ii].set_editable(False)
            self.stage_xy_map_table[ii].attach(self.stage_max_inten_posix[ii],0,1,3,4,xpadding = 2, ypadding = 4)
        
            self.stage_max_inten_posiy.append(gtk.Entry())
            self.stage_max_inten_posiy[ii].set_size_request(widget_width,widget_height)
            self.stage_max_inten_posiy[ii].show()
            self.stage_max_inten_posiy[ii].set_editable(False)
            self.stage_xy_map_table[ii].attach(self.stage_max_inten_posiy[ii],0,1,4,5,xpadding = 2, ypadding = 4)

            ###Gauss Peak
            self.stage_gauss_peak_posix.append(gtk.Entry())
            self.stage_gauss_peak_posix[ii].set_size_request(widget_width,widget_height)
            self.stage_gauss_peak_posix[ii].show()
            self.stage_gauss_peak_posix[ii].set_editable(False)
            self.stage_xy_map_table[ii].attach(self.stage_gauss_peak_posix[ii],0,1,5,6,xpadding = 2, ypadding = 4)
        
            self.stage_gauss_peak_posiy.append(gtk.Entry())
            self.stage_gauss_peak_posiy[ii].set_size_request(widget_width,widget_height)
            self.stage_gauss_peak_posiy[ii].show()
            self.stage_gauss_peak_posiy[ii].set_editable(False)
            self.stage_xy_map_table[ii].attach(self.stage_gauss_peak_posiy[ii],0,1,6,7,xpadding = 2, ypadding = 4)

            self.stage_gauss_fwhm_posix.append(gtk.Entry())
            self.stage_gauss_fwhm_posix[ii].set_size_request(widget_width,widget_height)
            self.stage_gauss_fwhm_posix[ii].show()
            self.stage_gauss_fwhm_posix[ii].set_editable(False)
            self.stage_gauss_fwhm_posix[ii].set_max_length(5)        
            self.stage_xy_map_table[ii].attach(self.stage_gauss_fwhm_posix[ii],0,1,7,8,xpadding = 2, ypadding = 4)


            self.stage_gauss_fwhm_posiy.append(gtk.Entry())
            self.stage_gauss_fwhm_posiy[ii].set_size_request(widget_width,widget_height)
            self.stage_gauss_fwhm_posiy[ii].show()
            self.stage_gauss_fwhm_posiy[ii].set_editable(False)
            self.stage_gauss_fwhm_posiy[ii].set_max_length(5)
            self.stage_xy_map_table[ii].attach(self.stage_gauss_fwhm_posiy[ii],0,1,8,9,xpadding = 2, ypadding = 4)

            ###Max intensity
            self.stage_max_intensity.append(gtk.Entry())
            self.stage_max_intensity[ii].set_size_request(widget_width,widget_height)
            self.stage_max_intensity[ii].show()
            self.stage_max_intensity[ii].set_editable(False)
            self.stage_max_intensity[ii].set_max_length(5)
            self.stage_xy_map_table[ii].attach(self.stage_max_intensity[ii],0,1,9,10,xpadding = 2, ypadding = 4)

            ###Current intensity
            self.stage_current_intensity.append(gtk.Entry())
            self.stage_current_intensity[ii].set_size_request(widget_width,widget_height)
            self.stage_current_intensity[ii].show()
            self.stage_current_intensity[ii].set_editable(False)
            self.stage_current_intensity[ii].set_max_length(5)
            self.stage_xy_map_table[ii].attach(self.stage_current_intensity[ii],0,1,10,11,xpadding = 2, ypadding = 4)

            self.mapping_table.attach(self.stage_xy_map_table[ii],ii+1,ii+2,1,2,xoptions = False,\
                                  yoptions = False,xpadding = 2, ypadding = 4)


  
        

        ####################################z position#################################
        self.stage_z_position_table = gtk.Table(1,5)
        self.stage_z_position_table.show()

        self.stage_z_position_label=gtk.Label('Z position(micron):')
        self.stage_z_position_label.show()
        self.stage_z_position_table.attach(self.stage_z_position_label,0,1,0,1,xpadding=2,ypadding=2)

        self.stage_z_position_output=gtk.Entry()
        self.stage_z_position_output.set_editable(False)
        self.stage_z_position_output.show()
        self.stage_z_position_output.set_text((str(self.lum.absolute_position(self.z_pos_active_stage,1) / 10.)))
        self.stage_z_position_table.attach(self.stage_z_position_output,1,2,0,1,xpadding=2,ypadding=2)

        self.z_position_box=gtk.VBox(True,0)
        self.z_position_box.show()
        self.inc_z_position_button = self.create_arrow_button(gtk.ARROW_UP, gtk.SHADOW_IN)
        self.dec_z_position_button = self.create_arrow_button(gtk.ARROW_DOWN, gtk.SHADOW_IN)
        self.inc_z_position_button.show()
        self.dec_z_position_button.show()
        self.inc_z_position_button.connect('clicked', self.move_z_pos, 'INC')
        self.dec_z_position_button.connect('clicked', self.move_z_pos, 'DEC')

        self.z_position_box.pack_start(self.inc_z_position_button,False,False,0)
        self.z_position_box.pack_start(self.dec_z_position_button,False,False,0)  
        self.stage_z_position_table.attach(self.z_position_box,2,3,0,1,xpadding=2,ypadding=2)
        
        #spin button
        self.z_position_adjustment = gtk.Adjustment(value=1, lower=0, upper=500.0, \
                                               step_incr=1, page_incr=5, page_size=0)
        self.z_position_spin_button = gtk.SpinButton(adjustment=self.z_position_adjustment, \
                                                climb_rate=0.0, digits=1)
        #constrain entered values to numbers (not letters)
        self.z_position_spin_button.set_numeric(numeric=True)
        #do not wrap from 100 microns to 0.
        self.z_position_spin_button.set_wrap(wrap=False)
        #if user enters a non-multiple of 0.1, the number is rounded off
        self.z_position_spin_button.set_snap_to_ticks(snap_to_ticks=True)
        #only change the value entered if it is a number within range
        self.z_position_spin_button.set_update_policy(False)
        self.z_position_spin_button.show()
        self.stage_z_position_table.attach(self.z_position_spin_button,3,4,0,1,xpadding=2,ypadding=2)
        
        #radio buttons
        self.z_position_stage_choice_box=gtk.HBox(True,0)
        self.z_position_stage_choice_box.show()
        self.z_position_stage_rbutton=gtk.RadioButton(None,"stage #1")
        self.z_position_stage_rbutton.set_active(True)
        self.z_position_stage_rbutton.connect("released", self.z_pos_rbutton_callback, 1)
        self.z_position_stage_choice_box.pack_start(self.z_position_stage_rbutton,True,True,0)
        self.z_position_stage_rbutton.show()

        for ii in range(self.num_stages-1):
            self.z_position_stage_rbutton=gtk.RadioButton(self.z_position_stage_rbutton,"stage #"+str(ii+2))
            self.z_position_stage_rbutton.connect("released", self.z_pos_rbutton_callback, ii+2)
            self.z_position_stage_choice_box.pack_start(self.z_position_stage_rbutton,True,True,0)
            self.z_position_stage_rbutton.show()
        
       
        self.stage_z_position_table.attach(self.z_position_stage_choice_box,4,7,0,1,xpadding=2,ypadding=2)
        self.mapping_table.attach(self.stage_z_position_table,0,5,2,3,xoptions = False,\
                                  yoptions = False,xpadding = 2, ypadding = 2)

#        self.notebook.connect('changed',self.refresh_positions(0))
        #############################################

        ############ Detector Tab ###################
        
        #create a bunch of buttons
        self.configure_detector_button = gtk.Button('Configure Detector')
        self.configure_detector_button.connect("clicked",self.configure_detector)
        self.configure_detector_button.show()
        
        self.load_detector_config_button = gtk.Button('Load Detector Config')
        self.load_detector_config_button.connect("clicked",self.load_detector_config)
        self.load_detector_config_button.show()
        
        self.free_detector_button = gtk.Button('Kill server')
        self.free_detector_button.connect("clicked",self.kill_server)
        self.free_detector_button.show()
        
        #give these their own table
        self.configure_table = gtk.Table(3,1,True)
        self.configure_table.show()
        self.configure_table.attach(self.configure_detector_button,0,1,0,1,yoptions = False,\
                                    xpadding = 2,ypadding = 2)
        self.configure_table.attach(self.load_detector_config_button,0,1,1,2,yoptions = False,\
                                    xpadding = 2,ypadding = 2)		
        self.configure_table.attach(self.free_detector_button,0,1,2,3,yoptions = False,\
                                    xpadding = 2,ypadding = 2)		
		
        self.detector_table.attach(self.configure_table,0,1,1,2,xoptions=False|True,\
                                   yoptions=False|True,xpadding = 2,ypadding = 2)

        self.detector_buttons_table = gtk.Table(5,1,True)
 	self.detector_button = []
        lbls = ['View section of detector', 'View whole detector',
                'Save image to file', 'View cross section', 'Run do loop', 'Start exposure', \
                'Take background', 'Reset background', 'Use background','Load xchan pos from mirkwood']
        tokenDict = {lbls[0]:self.view_detector_section, lbls[1]:self.view_whole_detector, \
                     lbls[2]:self.save_image, lbls[3]:self.view_cross_section, \
                     lbls[4]:self.run_do_loop, lbls[5]:self.start_exposure, \
                     lbls[6]:self.take_background, lbls[7]:self.reset_background, \
                     lbls[8]:self.use_background,lbls[9]:self.update_xchan_position}
        for i in range(len(lbls)):
            self.detector_button.append(gtk.Button(lbls[i]))
            self.detector_button[i].connect("clicked",tokenDict[lbls[i]])
            self.detector_button[i].show()
            self.detector_buttons_table.attach(self.detector_button[i], 0, 1, i, i+1,\
                                           xpadding =2,ypadding=2)
        self.detector_buttons_table.show()

        #pack this into the detector table
        self.detector_table.attach(self.detector_buttons_table,0,1,0,1,xoptions=False|True,\
                                   yoptions=False|True,xpadding=2,ypadding=2)
		
        #now make some labels and spin buttons for changing settings
        self.pixel_range_label = gtk.Label('Pixel range, img[a:b][c:d]')
        self.pixel_range_label.show()

        self.label = []
        self.adjustment = []
        self.spin_button = []
        self.table = []
        lbls = ['a', 'b', 'c', 'd']
        val = [0, 256, 0, 256]
        for i in range(4):
            self.label.append(gtk.Label(lbls[i]+':'))
            self.label[i].show()
            self.adjustment.append(gtk.Adjustment(value=val[i], lower=0, upper=256, step_incr=1, \
                                           page_incr=0, page_size=0))
            self.spin_button.append(gtk.SpinButton(adjustment=self.adjustment[i], \
                                            climb_rate=0.0, digits=0))
            self.spin_button[i].set_numeric(True)
            self.spin_button[i].set_wrap(False)
            self.spin_button[i].set_update_policy(True)
            self.spin_button[i].connect("value_changed",self.img_changed,lbls[i])
            self.spin_button[i].show()
            #make tables to attach label to spin button
            self.table.append(gtk.Table(1,2,False))
            self.table[i].show()
            self.table[i].attach(self.label[i],0,1,0,1)
            self.table[i].attach(self.spin_button[i],1,2,0,1)
		
        #now create stuff for the cross section
        self.cross_section_label = gtk.Label('Cross sectrion across img[:][e]')
        self.cross_section_label.show()
        self.e_label = gtk.Label('e:')
        self.e_label.show()
        
        self.e_adjustment = gtk.Adjustment(value=125, lower=0, upper=256, step_incr=1, \
                                           page_incr=0, page_size=0)
        self.e_spin_button = gtk.SpinButton(adjustment=self.e_adjustment,climb_rate=0.0,digits=0)
        self.e_spin_button.show()

        self.cross_section_table = gtk.Table(1,2,False)
        self.cross_section_table.show()
        self.cross_section_table.attach(self.e_label,0,1,0,1)#,xpadding = 2,ypadding = 2)
        self.cross_section_table.attach(self.e_spin_button,1,2,0,1)#,xpadding = 2,ypadding =2)
		
        #now create stuff for the interations
        self.do_loop_label = gtk.Label('Do loop iterations:')
        self.do_loop_label.show()
        self.do_loop_iteration_adjustment = gtk.Adjustment(value=1, lower=0, upper=10000, \
                                                           step_incr=5, page_incr=0, page_size=0)
        self.do_loop_spin_button = gtk.SpinButton(adjustment = self.do_loop_iteration_adjustment,\
                                                  climb_rate=0.0,digits=0)
        self.do_loop_spin_button.show()
        
        #now for exposure time
        self.exp_time_label = gtk.Label('Number of frames:')
        self.exp_time_label.show()
        self.exp_time_adjustment = gtk.Adjustment(value=1, lower=1, upper=100, \
                                                  step_incr=1, page_incr=0, page_size=0)
        self.exp_time_spin_button = gtk.SpinButton(adjustment = self.exp_time_adjustment,\
                                                   climb_rate=0.0,digits=0)
        self.exp_time_spin_button.show()
        self.exp_time_spin_button.connect("value_changed",self.change_number_of_frames)

        #photometric channel position on detector
        self.xchan_position_entry=[]
        self.xchan_position_label=[]
        self.xchan_position_table=gtk.Table(self.num_stages,2)
        self.xchan_position_table.show()
        for ii in range (self.num_stages):
            self.xchan_position_label.append(gtk.Label('Beam'+str(ii+1)+' : '))
            self.xchan_position_table.attach(self.xchan_position_label[ii],0,1,ii,ii+1,xpadding=2,ypadding=2)
            self.xchan_position_label[ii].show()
            self.xchan_position_entry.append(gtk.Entry())
            self.xchan_position_entry[ii].set_text(str(common.xchanpos[ii]))
            self.xchan_position_entry[ii].set_size_request(20,20)
            self.xchan_position_entry[ii].show()
            self.xchan_position_table.attach(self.xchan_position_entry[ii],1,2,ii,ii+1,xpadding=2,ypadding=2)
        self.update_xchan_position(None)

        
        #pack this all into one big table
        self.detector_settings_table = gtk.Table(7,2,False)
        self.detector_settings_table.show()
        self.detector_settings_table.attach(self.pixel_range_label,0,2,0,1,xpadding=2,ypadding=2)
        xy = [[0,1,1,2], [1,2,1,2], [0,1,2,3], [1,2,2,3]]
        for i in range(4):
            self.detector_settings_table.attach(self.table[i],xy[i][0],xy[i][1],xy[i][2],\
                                            xy[i][3],xpadding=2,ypadding=2)
        self.detector_settings_table.attach(self.cross_section_label,0,2,3,4,xpadding=2,ypadding=2)
        self.detector_settings_table.attach(self.cross_section_table,0,1,4,5,xpadding=2,ypadding=2)
        self.detector_settings_table.attach(self.xchan_position_table,0,2,6,7,xpadding=2,ypadding=2)
        
        self.detector_settings_table2 = gtk.Table(2,3,False)
        self.detector_settings_table2.show()
        self.detector_settings_table2.attach(self.do_loop_label,0,1,0,1,xpadding=2,ypadding=2)
        self.detector_settings_table2.attach(self.do_loop_spin_button,1,2,0,1,\
                                             xpadding=2,ypadding=2)
        self.detector_settings_table2.attach(self.exp_time_label,0,1,1,2,\
                                             xpadding=2,ypadding=2)
        self.detector_settings_table2.attach(self.exp_time_spin_button,1,2,1,2,\
                                             xpadding=2,ypadding=2)
        self.detector_settings_table.attach(self.detector_settings_table2,0,2,5,6,\
                                            xpadding=2,ypadding=2)
    
        #now add this to the detector table
        self.detector_table.attach(self.detector_settings_table,1,2,0,1,\
                                   xoptions=False|True,yoptions=False|True,xpadding=2,ypadding=2)
        
        #############################################
        
        ######## Pick-off Mirror Delay Tab ##########
		
        ##z.configure()

	## JDM 2007Jul5 commented out the next line and replaced with a simple
	## defintions since the this program begins with a self.zab.renumber
        ##self.m = self.zab.renumber()
	self.m = self.nzaber
        print self.m 
        # set acceleration limits on aperture array and prism stages
        self.zab.command(7,41,255)
        self.zab.command(7,42,180)
#        self.zab.command(8,41,255)
#        self.zab.command(8,42,180)
        
        # set extension limits on all
        self.zab.command(7,44,560000)
#        self.zab.command(8,44,560000)
        
        for i in range(6):
            self.zab.command(i+1,44,210000)

        #add command to limit actuators
            
        self.actuator = 1
				
        #joystick for moving mirror in and out
		
        self.zaber_joystick_table = gtk.Table(10,3,False)
        self.zaber_in_z_button = []
        self.zaber_out_z_button = []
        for i in range(8):
            self.zaber_in_z_button.append(self.create_arrow_button(gtk.ARROW_UP, gtk.SHADOW_IN))
            self.zaber_in_z_button[i].connect('clicked', self.zaber_move, 'IN', i+1)
            self.zaber_joystick_table.attach(self.zaber_in_z_button[i],i+1,i+2,0,1,\
                                             xoptions = False,\
                                             yoptions = False,xpadding = 2, ypadding = 2)
            self.zaber_out_z_button.append(self.create_arrow_button(gtk.ARROW_DOWN, gtk.SHADOW_IN))
            self.zaber_out_z_button[i].connect('clicked',self.zaber_move,'OUT', i+1)
            self.zaber_joystick_table.attach(self.zaber_out_z_button[i],i+1,i+2,2,3,\
                                             xoptions = False,yoptions = False,xpadding = 2, \
                                             ypadding = 2)

        #add labels to joystick buttons
	self.zaber_z_label = []
        lbl = ['IR1', 'IR2', 'IR3', 'IR4', 'IR5', 'IR6', 'Pr1', 'Pr2']
        for i in range(len(lbl)):
            self.zaber_z_label.append(gtk.Label(lbl[i]))
            self.zaber_z_label[i].show()
            self.zaber_joystick_table.attach(self.zaber_z_label[i],i+1,i+2,1,2,xoptions = False,\
                                             yoptions = False,xpadding = 2, ypadding = 2)
        
        self.zaber_jst_label = []
        lbl = ['In', 'Out', 'OPD -', 'OPD +']
        xy = [[9,10,0,1], [9,10,2,3], [0,1,0,1], [0,1,2,3]]
        for i in range(len(lbl)):
            self.zaber_jst_label.append(gtk.Label(lbl[i]))
            self.zaber_jst_label[i].show()
            self.zaber_joystick_table.attach(self.zaber_jst_label[i],xy[i][0],xy[i][1],xy[i][2],\
                                             xy[i][3],xoptions = False,\
                                             yoptions = False,xpadding = 2, ypadding = 2)

        #add menus:
        self.zaber_menu_bar = []
        self.zaber_menu_name = []
        self.zaber_menu = []
        self.zaber_menu_item_home = []
        self.zaber_menu_item_good = []
        self.zaber_menu_item_other = []
        act = [1, 6, 2, 5, 3, 4, 7, 8]
        for i in range(8):
            self.zaber_menu_bar.append(gtk.MenuBar())
            self.zaber_menu_bar[i].show()
            self.zaber_menu_name.append(gtk.MenuItem('Menu'))
            self.zaber_menu_name[i].show()
            self.zaber_menu.append(gtk.Menu())
            self.zaber_menu_item_home.append(gtk.MenuItem('Home'))
            self.zaber_menu_item_good.append(gtk.MenuItem('Good'))
            self.zaber_menu_item_other.append(gtk.MenuItem('Other'))
            self.zaber_menu_item_home[i].show()
            self.zaber_menu_item_good[i].show()
            self.zaber_menu_item_other[i].show()
            self.zaber_menu[i].append(self.zaber_menu_item_home[i])
            self.zaber_menu[i].append(self.zaber_menu_item_good[i])
            self.zaber_menu[i].append(self.zaber_menu_item_other[i])
            self.zaber_menu_item_home[i].connect("activate", self.zaber_home, act[i])
            self.zaber_menu_item_good[i].connect_object("activate", self.zaber_read_file, act[i], 'good.eal')
            self.zaber_menu_item_other[i].connect_object("activate", self.zaber_read_file, act[i], 'other.eal')
            self.zaber_menu_name[i].set_submenu(self.zaber_menu[i])
            self.zaber_menu_bar[i].append(self.zaber_menu_name[i])
            self.zaber_joystick_table.attach(self.zaber_menu_bar[i],\
                                             i+1,i+2,3,4, xoptions = False,\
                                             yoptions = False,xpadding = 2, ypadding = 2)
        self.zaber_joystick_table.show()
        
        #attach joystick table to notebook table
        self.zaber_table.attach(self.zaber_joystick_table,0,2,0,1,xoptions = False|True,\
                                yoptions = False|True)		
        
        #now add 'spin buttons' to select step size of zaber z motion
				
        #now for z, left button does 0.1 microns, right does 10
        self.zaber_z_adjustment = gtk.Adjustment(value=10., lower=0.1, upper=500.0, \
                                                 step_incr=0.1, page_incr=5, page_size=0)
        self.zaber_z_spin_button = gtk.SpinButton(adjustment=self.zaber_z_adjustment, \
                                                  climb_rate=0.0, digits=1)
        #constrain entered values to numbers (not letters)
        self.zaber_z_spin_button.set_numeric(numeric=True)
        #do not wrap from 100 microns to 0.
        self.zaber_z_spin_button.set_wrap(wrap=False)
        #if user enters a non-multiple of 0.1, the number is rounded off
        self.zaber_z_spin_button.set_snap_to_ticks(snap_to_ticks=True)
        #only change the value entered if it is a number within range
        self.zaber_z_spin_button.set_update_policy(gtk.UPDATE_IF_VALID)
        self.zaber_z_spin_button.show()
        
        #toggle switch to automatically view cross section
        self.auto_cross_section = 0
        self.auto_cross_section_check = gtk.CheckButton('View cross section after each move')
        self.auto_cross_section_check.show()
        self.auto_cross_section_check.connect("toggled",self.auto_cross_section_toggled)		
        #add these to the zaber_table in it's own table with lables
        self.zaber_spin_button_table = gtk.Table(3,3,False)
        #add spin_table to zaber table
        
        #add spin buttons and lables to spin_table
        self.zaber_spin_button_table.attach(self.zaber_z_spin_button,1,2,0,1,xpadding = 2, \
                                            ypadding = 2)
        
        self.zaber_z_spin_label = gtk.Label('Z step size:')
        self.zaber_z_spin_label.show()
        self.zaber_microns_label = gtk.Label('microns')
        self.zaber_microns_label.show()
        self.zaber_spin_button_table.attach(self.zaber_z_spin_label,0,1,0,1,xpadding = 2, \
                                            ypadding = 2)
        self.zaber_spin_button_table.attach(self.zaber_microns_label,2,3,0,1,xpadding = 2,\
                                            ypadding = 2)
        self.zaber_spin_button_table.show()
        
        self.zaber_spin_button_table.attach(self.auto_cross_section_check,0,3,2,3,\
                                            xoptions = False|True, yoptions = True|True,\
                                            xpadding = 2, ypadding = 2)

        self.zaber_table.attach(self.zaber_spin_button_table,0,1,1,2,xoptions = False,\
                                yoptions = False,xpadding = 2, ypadding = 2)

        #combo box to choose a ealing actuator and enter position directly
        #self.zaber_renumber_button_label = gtk.Label('Renumber')
        self.zaber_renumber_button = gtk.Button('Renumber')
        self.zaber_renumber_button.connect("clicked",self.zaber_renumber_mount)
        #self.zaber_renumber_button_label.show()
        self.zaber_renumber_button.show()
        
        self.zaber_home_all_button = gtk.Button('Home All')
        self.zaber_home_all_button.show()
        self.zaber_home_all_button.connect("clicked", self.zaber_home, 0)

        self.zaber_restart_button = gtk.Button('Restart')
        self.zaber_restart_button.show()
        self.zaber_restart_button.connect("clicked",self.zaber_restart_mounts)
        
        self.zaber_save_position_button = gtk.Button('Save all positions to file')
        self.zaber_save_position_button.connect("clicked",self.zaber_save_pos)
        self.zaber_save_position_button.show()
		
        self.zaber_recall_position_button = gtk.Button('Recall all positions from file')
        self.zaber_recall_position_button.connect("clicked",self.zaber_recall_pos)
        self.zaber_recall_position_button.show()
        
        #create a table for buttons
        self.zaber_position_button_table = gtk.Table(1,6,False)
        self.zaber_position_button_table.show()
        
        self.zaber_position_button_table.attach(self.zaber_home_all_button,0,1,0,1,\
                                                xpadding = 2, ypadding = 2)
        self.zaber_position_button_table.attach(self.zaber_renumber_button,1,2,0,1,\
                                                xpadding = 2, ypadding = 2)
        self.zaber_position_button_table.attach(self.zaber_save_position_button,2,3,0,1,\
                                                xpadding = 2, ypadding = 2)
        self.zaber_position_button_table.attach(self.zaber_recall_position_button,3,4,0,1,\
                                                xpadding = 2, ypadding = 2)
        self.zaber_position_button_table.attach(self.zaber_restart_button,5,6,0,1,\
                                                xpadding = 2, ypadding = 2)		

        self.zaber_table.attach(self.zaber_position_button_table,0,2,2,3,\
                                xoptions = False|True,yoptions = False|True,\
                                xpadding = 2, ypadding = 2)

        #combo_box to choose ealing mount
        self.zaber_combo_box = gtk.combo_box_new_text()
        self.zaber_combo_box.show()
        self.zaber_combo_box.set_wrap_width(1)
        for i in range(6):#self.m):
            self.zaber_combo_box.append_text('Ealing IR%d' % (i+1))
        self.zaber_combo_box.append_text('Aperture array')
        self.zaber_combo_box.append_text('Prism stage')
		
        self.zaber_combo_box.set_active(self.actuator-1)
        self.zaber_combo_box.connect("changed",self.zaber_menu_changed)
        
        #create another table
        self.zaber_direct_move_table = gtk.Table(2,2,False)
        self.zaber_direct_move_table.show()

        #text box to hold position
        self.zaber_position_entry = gtk.Entry(max=6)
        self.zaber_position_entry.set_text(str(self.zab.absolute_position(self.actuator, 1)))
        self.zaber_position_entry.show()

        self.zaber_move_to_position_button = gtk.Button('Move to')
        self.zaber_move_to_position_button.connect("clicked",self.zaber_move_to_pos)
        self.zaber_move_to_position_button.show()
        
        self.zaber_refresh_position_button = gtk.Button('Refresh')
        self.zaber_refresh_position_button.connect("clicked",self.zaber_refresh_pos)
        self.zaber_refresh_position_button.show()
		
        self.zaber_direct_move_table.attach(self.zaber_combo_box,0,1,0,1,\
                                            xoptions = False|True,yoptions = False|True,\
                                            xpadding = 2, ypadding = 2)
        self.zaber_direct_move_table.attach(self.zaber_position_entry,0,1,1,2,\
                                            xoptions = False|True,yoptions = False|True,\
                                            xpadding = 2, ypadding = 2)
        self.zaber_direct_move_table.attach(self.zaber_move_to_position_button,1,2,0,1,\
                                            xpadding = 2, ypadding = 2)
        self.zaber_direct_move_table.attach(self.zaber_refresh_position_button,1,2,1,2,\
                                            xpadding = 2, ypadding = 2)

        self.zaber_table.attach(self.zaber_direct_move_table,1,2,1,2,xoptions = False|True,\
                                yoptions = False|True,xpadding = 2, ypadding = 2)

        #############################################
    
        ######### Extra Windows for Plots ###########
 
        if self.nluminos != 0:
            print "refreshing luminos positions"
            self.refresh_positions(0)
            
            

    #################  Zaber functions ###############

    #move zaber function
    def zaber_move(self,widget,direction,actuator):
        zz = long(self.zaber_z_spin_button.get_value())
        act = [{'IN':[1, -10*zz], 'OUT':[1,  10*zz]},
               {'IN':[6,  10*zz], 'OUT':[6, -10*zz]},
               {'IN':[2, -10*zz], 'OUT':[2,  10*zz]},
               {'IN':[5,  10*zz], 'OUT':[5, -10*zz]},
               {'IN':[3, -10*zz], 'OUT':[3,  10*zz]},
               {'IN':[4,  10*zz], 'OUT':[4, -10*zz]},
               {'IN':[7,  10*zz], 'OUT':[7, -10*zz]},
               {'IN':[8,  10*zz], 'OUT':[8, -10*zz]}]
        self.zab.move_relative(act[actuator-1][direction][0], 1, act[actuator-1][direction][1])
        self.zaber_refresh_pos(0)
            
        if (self.auto_cross_section):
            self.view_cross_section(0)
	

    #functions for saving current position to a file
    def zaber_save_pos(self,widget):		
        self.zaber_save_filew = gtk.FileSelection('Save all positions to file')
        self.zaber_save_filew.connect("destroy",lambda w: self.zaber_save_filew.destroy())
        self.zaber_save_filew.ok_button.connect("clicked",self.zaber_file_save_action)
        self.zaber_save_filew.cancel_button.connect("clicked",lambda w: \
                                                    self.zaber_save_filew.destroy())
        self.zaber_save_filew.show()

    #function to actually do the filesaving
    def zaber_file_save_action(self,widget):
        self.zab.save_position(self.zaber_save_filew.get_filename(),self.m)
        print "save info to %s" % self.zaber_save_filew.get_filename()
        self.zaber_save_filew.destroy()

    #functions for recalling position from a file
    def zaber_recall_pos(self,widget):
        self.zaber_recall_filew = gtk.FileSelection('Recall all positions from file')
        self.zaber_recall_filew.connect("destroy",lambda w: self.zaber_recall_filew.destroy())
        self.zaber_recall_filew.ok_button.connect("clicked",self.zaber_file_recall_action)
        self.zaber_recall_filew.cancel_button.connect("clicked",\
                                                      lambda w: self.zaber_recall_filew.destroy())
        self.zaber_recall_filew.show()
                
    #function that actually recalls the file
    def zaber_file_recall_action(self,widget):
        self.zab.recall_position(self.zaber_recall_filew.get_filename(),self.m)
        print "recalled info from %s" % self.zaber_recall_filew.get_filename()
        self.zaber_recall_filew.destroy()		
			
    def zaber_renumber_mount(self,widget):            
        print 'renumbering mounts '
        self.nzaber = self.zab.renumber()
	print "self.nzaber = ", self.nzaber
				
    def zaber_restart_mounts(self,widget):
        self.zab.restart()
        self.zab.renumber_mount(0)		

    def zaber_home(self,widget,actuator):
        print 'actuator = ', actuator	
        self.zab.home(actuator, 1)
        self.zaber_refresh_pos(0)

    def zaber_read_file(self,actuator, filename):
        file = open(filename)
        text = file.read()
        positions = text.split("\n")
        self.zab.move_absolute(actuator, 1, long(positions[actuator-1]))
        self.zaber_refresh_pos(0)

    def auto_cross_section_toggled(self,widget):
        self.auto_cross_section = self.auto_cross_section_check.get_active()		

    #function for combo box to enter/see exact postion of ealing actuator:
    def zaber_menu_changed(self,combo_box):
	act = [1, 6, 2, 5, 3, 4, 7, 8]
        self.actuator = act[combo_box.get_active()]
				
        #insert function to set text on position box
        self.zaber_refresh_pos(0)

    def zaber_move_to_pos(self,widget):
        self.zab.move_absolute(self.actuator, 1, long(self.zaber_position_entry.get_text()))
        
    def zaber_refresh_pos(self,widget):
        self.zaber_position_entry.set_text(str(self.zab.absolute_position(self.actuator, 1)))

    def main(self):        
        gtk.main()

def main():
#    pdb.set_trace()
    fib = fiber()
    fib.main()
   
print __name__
if __name__ == "__main__":
    main()
