#!/usr/bin/python
'''
the import user command looks for .pythonrc.py and execute it
in our case .pythonrc.py gives acces to the modules from
$HOME/control/python/pythonLibs
'''
import user

import gtk
import gobject
import threading
import struct
import time
#import numarray as na
import numpy as na
import itertools

### modules in pythonLibs
from socketLib import initSocketIteratePort2 as initSocket
import IRCamLibs.IRCamCommands as ircc
import IRCamLibs.camStructures
import common
import IRCamCommands as ir
import array

import pdb

def getKeyForValue( dict, valueToFind ):
    """Returns the key in dict with the given
    value. If no value is found returns None."""
    answer = None
    for key, value in dict.iteritems():
        if value == valueToFind: answer = key
    return answer

def isStringLike(anobj):
    '''
    Check if anobj is a string
    '''
    try: anobj+''
    except: return False
    else: return True
    
def doNothing(nothing):
    pass


'''
A class that deals with the shutters
shutterConf: queries the current shutter configuration
shutterAction: open/close/query the status of a shutter
shutterStatus: calls shutterAction
shutterOpen: calls shutterAction
shutterClose: calls shutterAction
'''

#class shutterMessageThread(threading.Thread):
    #def __init__(self, name = 'shutterMessageThread'):
        #self.host = '192.168.3.11'  #wobble
        #self.port = 4000
        #self.sock = initSocket(self.host, self.port)
        #self.sock.settimeout(5)
        #while not self.emptySock():
            #time.sleep(.1)
        #self._stopevent = threading.Event()
        #threading.Thread.__init__(self, name = name)
    
    #def run(self):
        #print "run started"
        #cnt = 0
        #print self._stopevent.isSet()
        #while not self._stopevent.isSet():
            #print 'cnt = ', cnt
            #self.readShutterMessage()
            #cnt += 1
            #self._stopevent.wait(.5)
            
    #def emptySock(self):
        #try: mess = self.sock.recv(32)
        #except: 
            #print "nothing to read"
            #return 1
        #else: 
            #print "Read %d bytes" %(len(mess))
            #return 0
        
    #def readShutterMessage(self):
        #try:
            #length = 0
            #data = ''
            #while length <6:
                #message = self.sock.recv(6)
                #l = len(message)
                #length += l
                #data += message
        #except: print "nothing to read"
        #else:
            #messageType, =struct.unpack('H', data[0:2])
            #messageLength, = struct.unpack('I', data[2:6])
            #print "message type = ", messageType
            #print "message length = ", messageLength
            #if messageType != 1102:
                #while not self.emptySock():
                    #time.sleep(.1)
            #else:
                #try: data = self.sock.recv(messageLength-length)
                #except: "failed to read %d bytes" %(messageLength)
                #else:
                    #print data
                    #dt, =  struct.unpack('2s', data)
                    #self.messageType = messageType
                    #self.messageLength = messageLength
                    #self.messageData = na.fromstring(dt, na.int8, (2))
                    #print "self.messageData = ", self.messageData 
    #def join(self, timeout = None):
        #self._stopevent.set()
        #self.sock.close()
        #threading.Thread.join(self, timeout)
        #print "thread stopped"

class shutterCommandsClass:
    def __init__(self):
        self.host = '192.168.3.13'  #was wobble, now ople
        self.port = 4000
        self.NUMBER_SHUTTERS = 16   #/shutter/include/shutter.h
        self.MAX_CONFIGS = 64       #/include/chara_messages.h
    
        self.smessageType = {'OPEN_SHUTTER':   1100, \
                    'CLOSE_SHUTTER':  1101, \
                    'STATUS_SHUTTER': 1102, \
                    'SHUTTER_CONF':   1103}
    
        self.shutterStates = {'NOTHING': -1, \
                    'CLOSED':   0, \
                    'OPEN':     1, \
                    'MOVING':   2, \
                    'INSANE':   3}
    
        self.shutterCommands = {'SHUTTER_OPEN':        1, \
                    'SHUTTER_CLOSE':       2, \
                    'SHUTTER_STATUS':      3, \
                    'SHUTTER_MAX_COMMAND': 3}
    
        self.sockConf = initSocket(self.host, self.port)
        self.sockStatus = initSocket(self.host, self.port)
        self.sockOpen = initSocket(self.host, self.port)
        self.sockClose = initSocket(self.host, self.port)
        self.sockSendOffSet = initSocket(self.host, self.port)
        
        self.socketAction = {1100:self.sockOpen, 1101:self.sockClose, 1102:self.sockStatus, 1103:self.sockConf}

    def emptySock(self, sock):
        try: mess = sock.recv(32)
        except: 
            print "nothing to read"
            return 1
        else: 
            print "Read %d bytes" %(len(mess))
            return 0
    
    def shutterConf(self):
        smessageType = self.smessageType['SHUTTER_CONF']
        smessage_struct = struct.pack('HIs',smessageType,0,'')
        sock = self.socketAction[smessageType]
        if sock == None:
            print "socket frame failed to create"
        else:
            print "socket ok"
            self.sockConf.send(smessage_struct)
            print "sent data"
            while not self.readShutterConf(smessageType):
                time.sleep(0.1)
        sock.close()

    def readShutterConf(self,smessageType):
        sock = self.socketAction[smessageType]
        length = 0
        data = ''
        try: 
            print "trying messageType"
            while length < 2:
                message = sock.recv(2)
                l = len(message)
                length += l
                data += message
            #data = sock.recv(2)
        except: 
            print "failed to read messageType"
        else:
            messageType, = struct.unpack('H', data[0:2])
            print "message type = ", messageType
            if messageType != 1103:
                print "NOT A CONF MESSAGE"
                return 0
            else:
                print "A CONF MESSAGE"
                try: 
                    print "trying messageLength"
                    data = sock.recv(4)
                except: 
                    "failed to read messageLength"
                    return 0
                else:
                    messageLength, = struct.unpack('I', data)
                    print "message length = ", messageLength
                    length = 0
                    data = ''
                    try: 
                        print "trying messageData"
                        #data = sock.recv(messageLength)
                        while length < messageLength:
                            message = sock.recv(messageLength-length)
                            l = len(message)
                            length += l
                            data += message
                    except: 
                            "failed to read %d bytes of messageData" %(messageLength)
                            return 0
                    else:
                        self.messageType = messageType
                        self.messageLength = messageLength
                        self.numberOfConf, = struct.unpack('i', data[0:4])
                        self.name = data[4:85]
                        print "message type = ", self.messageType
                        print "message length = ", self.messageLength
                        print "number of configurations = ", self.numberOfConf 
                        print "name = ", self.name
                
                        posi = 85
                        self.shutterNames = []
                        for ndx in range(self.NUMBER_SHUTTERS-1):
                            self.shutterNames.append(data[posi+81*ndx:posi+81*(ndx+1)].strip('\x00'))
                        print "Shutter names = ", self.shutterNames
                
                        posi += 81*self.NUMBER_SHUTTERS
                        self.confNames = []
                        for ndx in range(self.numberOfConf):
                            self.confNames.append(data[posi+81*ndx:posi+81*(ndx+1)].strip('\x00'))
                        print "Configurations names = ", self.confNames
                
                        posi += 81*self.MAX_CONFIGS
                        self.conf = na.zeros((self.numberOfConf,self.NUMBER_SHUTTERS), dtype = na.int8)
                        self.confStatus = [[]]*self.numberOfConf
                        for ndx in range(self.numberOfConf):
                            dt, = struct.unpack('%ds'%self.NUMBER_SHUTTERS, \
                                        data[posi+self.NUMBER_SHUTTERS*ndx:posi+self.NUMBER_SHUTTERS*(ndx+1)])
                            self.conf[ndx, :] = na.fromstring(dt, na.int8, (self.NUMBER_SHUTTERS))
                            self.confStatus[ndx] = [getKeyForValue(self.shutterStates,x) for x in self.conf[ndx, :]]
                        print "configuration status = ", self.conf
                        print "configuration status ascii= ", self.confStatus
                        return 1
                        
    def shutterAction(self, shutter, action):
        #tests if action is the action name or number ex:'OPEN_SHUTTER' or 1100
        if isStringLike(action):
            smessageType = self.smessageType[action]
        else:
            smessageType = action
        #tests if shutter is the shutter name or number
        if isStringLike(shutter):
            shutter = self.shutterNames.index(shutter)
    
        #self.sock = initSocket(self.host, self.port)
        sock = self.socketAction[smessageType]
        sshutter_status = struct.pack('BB',shutter,0)
    
        messType = struct.pack('H', smessageType)
        messSize = struct.pack('I', struct.calcsize('BB'))
        messData = sshutter_status
        print "message type = ", smessageType
        print "shutter = ", shutter
        if sock == None:
            print "socket frame failed to create"
        else:
            print "socket ok"
            sock.send(messType)
            sock.send(messSize)
            sock.send(messData)
            print "sent data"
            time.sleep(1.)
            while not self.readShutterStatus(shutter, smessageType):
                time.sleep(0.1)

    def readShutterStatus(self,shutter, smessageType):
        sock = self.socketAction[smessageType]
        length = 0
        data = ''
        try: 
            print "trying messageType"
            data = sock.recv(2)
        except: 
            print "failed to read messageType"
            return 0
        else:
            messageType, = struct.unpack('H', data[0:2])
            print "message type * = ", messageType
            if messageType != 1102:
                print "NOT A STATUS MESSAGE"
                return 0
            else:
                print "A STATUS MESSAGE"
                try: 
                    print "trying messageLength"
                    data = sock.recv(4)
                except: 
                    "failed to read messageLength"
                    return 0
                else:
                    messageLength, = struct.unpack('I', data)
                    print "message length = ", messageLength
                    try: 
                        print "trying messageData"
                        data = sock.recv(messageLength)
                    except: 
                        "failed to read %d bytes of messageData" %(messageLength)
                        return 0
                    else:
                        dt, =  struct.unpack('2s', data)
                        self.messageType = messageType
                        self.messageLength = messageLength
                        self.messageData = na.fromstring(dt, na.int8, (2))
                        print "self.messageData = ", self.messageData 
                        if self.messageData[0] == shutter: 
                            self.currentStatus[shutter] = getKeyForValue(self.shutterStates, self.messageData[1])
                            print "shutter %d status = " %(shutter), self.currentStatus[shutter]
                            return 1
                        else: return 0
    def shutterStatus(self, shutter):
        self.shutterAction(shutter, 'STATUS_SHUTTER')

    def openShutter(self, shutter):
        self.shutterAction(shutter, 'OPEN_SHUTTER')

    def closeShutter(self, shutter):
        self.shutterAction(shutter, 'CLOSE_SHUTTER')

    def closeShutterSocket(self):
        #self.sockConf.close()
        self.sockStatus.close()
        self.sockOpen.close()
        self.sockClose.close()


'''
A class that creates a thread checks the status of self.flag
If self.flag == 0: keeps looping and checking for self.flag
If self.flag == 1: goes through the shutter sequence as defined by the GUI
'''
class shutterSequenceThread(threading.Thread):
    def __init__(self, name = 'shutterSequenceThread'):
        #pdb.set_trace()
        self.shutComm = shutterCommandsClass()
        self.shutComm.shutterConf()
        # DEBUGGING THINGS
        #time.sleep(1.)
        #self.shutComm.openShutter(14)
        #time.sleep(1.)
        #self.shutComm.shutterStatus(14)
        #time.sleep(1.)
        #self.shutComm.closeShutter(14)
        #time.sleep(1.)
        #self.shutComm.shutterStatus(14)
        #time.sleep(1.)
        #self.shutComm.openShutter(13)
        #time.sleep(1.)
        #self.shutComm.shutterStatus(13)
        #time.sleep(1.)
        #self.shutComm.closeShutter(13)
        #time.sleep(1.)
        #self.shutComm.shutterStatus(13)
        #if self.shutComm.sock == None: return -1
        # END OF DEBUGGING THINGS
        
        self.ircc = ircc.IRCamCommands()
        #gets the current values of the daq and pythonConfig structures from RT
        self.ircc.getStruct()
        self.ircc.getPythonConfigStruct()
        #self.ircc.pythonConfig['comment1'] = "Tests the new pythonConfig    "
        #self.ircc.sendPythonConfigStruct()
        #self.ircc.pythonConfig['comment1'] = " "
        #print "self.ircc.pythonConfig['comment1'] = ",self.ircc.pythonConfig['comment1']
        #self.ircc.getPythonConfigStruct()
        #print "self.ircc.pythonConfig['comment1'] = ",self.ircc.pythonConfig['comment1']

        #mask = 0 => shutter not moved
        mask = na.zeros(6)
        mask[self.ircc.pythonConfig['BeamOrder']] = 1
        self.largeOffsets = 0.002*mask*na.arange(1,7)
        print "largeOffsets = ", self.largeOffsets
        
        self.shutterIndex = []
        self.defaultShutterNames = ['IRB1','IRB2','IRB3','IRB4','IRB5','IRB6']
        self.shutComm.currentStatus = {}
        for ndx, shut in enumerate(self.defaultShutterNames):
            if shut in self.shutComm.shutterNames:
                self.shutterIndex.append(self.shutComm.shutterNames.index(shut))
                self.shutComm.currentStatus[self.shutterIndex[ndx]] = 'unknown'
            else:
                print "WARNING THE CAN T FIND IR SHUTTERS IN SHUTTER LIST"
                print "CHECK /chara/observe/control/cliserv/shutter/server/shutter.cfg"
                print "FOR UPDATES"
                return -1
        self.shutterIndexDict = dict(itertools.izip(self.defaultShutterNames, self.shutterIndex))

        self.tags = ['BACKGROUND','BEAM1','BEAM2','BEAM3','BEAM4','BEAM5','BEAM6','FOREGROUND','DATA']
        self.lengthOfSequence = len(self.tags)
    
        self.shutterSequenceActions = [[1, 1, 1, 1,1,1],\
                            [0, 1, 1, 1,1,1],\
                            [1, 0, 1, 1,1,1],\
                            [1, 1, 0, 1,1,1],\
                            [1, 1, 1, 0,1,1],\
                            [1, 1, 1, 1,0,1],\
                            [1, 1, 1, 1,1,0],\
                            [0, 0, 0, 0,0,0],\
                            [0, 0, 0, 0,0,0],\
                            [0, 0, 0, 0,0,0]]
        
        self.shutterActionCall = {-1:doNothing, 0:self.shutComm.openShutter,1:self.shutComm.closeShutter}
        self.shutterSequenceActionsDict = [] 
        for ndx in range(self.lengthOfSequence):
            self.shutterSequenceActionsDict.append(dict(itertools.izip(self.defaultShutterNames, \
                                            self.shutterSequenceActions[ndx])))
        #use a dictionnary as a "switch case" statement
        self.switchFlag = {1:self.matrixSequence, 2:self.dataAcquisition}
        self._stopevent = threading.Event()
## JDM 2007Jul26 changed sleep period from 1.0 to 0.5
        self.sleepPeriod = 0.5
        self.flag = 0
        threading.Thread.__init__(self, name = name)
        print "init ok"
    
    def run(self):
        while not self._stopevent.isSet():

##            print " common gdtInfo + ", common.gdtInfo
            print "waiting"
            print "self.flag = ", self.flag
            if self.flag:
                self.switchFlag[self.flag]()
                self.flag = 0
            else: self._stopevent.wait(2.0)
## JDM 2007Jul26  changed the thread wait from 5.0 seconds to 2.0 second
            
    def matrixSequence(self):
        for ndx in range(self.lengthOfSequence-1):
            self.ircc.getStruct()
            print self.flag
            if not self.flag: break
	    ## load in current luminos positions and update pythonConfig
## HARDWIRED.. see common.py for filename of luminos_currents
## current incompatibility between pythonLibs and common.py means
## we have this lame kludge!!
## JDM 2007Jul26  ASSUMES NTEL telescopes are using the first NTEL BEAMS... 1.2.3.4...

            self.ircc.getPythonConfigStruct()
            try: pos = open('/home/observe/MIRC/mirc_python/.current_luminos_positions', 'r')
            except:
                print '/home/observe/MIRC/mirc_python/.current_luminos_positions INVALID'
            else:
                for h in range(1, (self.ircc.pythonConfig['NTels'])+1): #1, ..., self.ircc.pythonConfig['NTels']
            ## Z AXIS FIRST -- NOT SAVED IN CURRENT PYCONFIG: 2007Jul24
                    line = pos.readline()
                    li = int(line)
                    print h,'Z:',li
            ## X AXIS NEXT 
                    line = pos.readline()
                    li = int(line)
                    print h,'X:',li
                    self.ircc.pythonConfig['FiberExplorerX'][h-1]=li
            ## Y Axis NEXT
                    line = pos.readline()
                    li = int(line)
                    print h,'Y:',li
                    self.ircc.pythonConfig['FiberExplorerY'][h-1]=li
                pos.close()
                print 'Luminos positions have been recalled'
            self.ircc.sendPythonConfigStruct()

            nfiles = int(self.numberOfFiles[ndx].get_text())
            if nfiles:
                self.sequenceSteps[ndx].modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('green'))
                print "doing %s from shutter sequence" %(self.tags[ndx])
                #step 0: updates the file tag
                self.ircc.getPythonConfigStruct()
                self.ircc.pythonConfig['fileDescription'] = self.tags[ndx]
                self.ircc.sendPythonConfigStruct()
                #step 1: set the shutter configuration
                for num, shutter in enumerate(self.defaultShutterNames):
                    print "doing shutter ", shutter
                    self.shutterActionCall[self.shutterSequenceActionsDict[ndx][shutter]](shutter)
                    shutNum = self.shutComm.shutterNames.index(shutter)
                    #time.sleep(1)
                    #self.shutComm.shutterStatus(shutter)
                    print "shutter %s current status = " %(shutter), self.shutComm.currentStatus[shutNum], shutNum
                    self.shutterStatus[num].set_text(self.shutComm.currentStatus[shutNum])
                    time.sleep(3)
                #if step == foreground then move the delay line by a large offset
                if self.tags[ndx] == 'FOREGROUND':
##		    print " common gdtInfo + ", ircc.common.gdtInfo
##################################################
## UNLOCK FRINGES AUTOMATICALLY .. JDM 2008Aug24
	            self.ircc.sendGdtOff()
		    time.sleep(3)
###############################################
## UPDATE MASK
                    mask = na.zeros(6)
		    mask[self.ircc.pythonConfig['BeamOrder']] = 1
		    self.largeOffsets = 0.005*mask*na.arange(1,7)
		    print "Sending : ",self.largeOffsets
		    
## MASK UPDATED
##################################################
	            
                    #self.ircc.getDelayLinesOffsets()
                    #savedOffsets = self.ircc.delayLinesOffsets
                    #offsets should be RELATIVE not absolute.
                    self.ircc.updatedOffsets = self.largeOffsets
                    print "Doing self.ircc.sendUpdatedOffsets()"
                    self.ircc.sendUpdatedOffsets()
                    time.sleep(3) 

                #step 2: set savenum
                print "self.ircc.daq['savenum'] = ", nfiles
                self.ircc.daq['savenum'] = nfiles
                #step 3:updates the daq structure with new savenum
                self.ircc.updateDoImageSave()
                print "self.ircc.daq['do_image_save'] = ",self.ircc.daq['do_image_save']
                doImageSave = 1
                savenum = nfiles
                #step 4:wait until self.daq['do_image_save'] == 0
                counter = 0
                print "outWhile: doImageSave",doImageSave," and savenum ",savenum
                while ((doImageSave == 1) or (savenum != 0)):
                    print "counter = ", counter
                    print "self.flag = ", self.flag
                    if (not self.flag): break
                    self.ircc.getStruct()
                    doImageSave = self.ircc.daq['do_image_save']
                    savenum = self.ircc.daq['savenum']
                    counter +=1
                    time.sleep(3.)
                    print "inWhile: doImageSave",doImageSave," savenum: ",savenum
                #step 5:restore delay line offsets if necessary
                if self.tags[ndx] == 'FOREGROUND':
                    if not self.flag: break
                    #fixed the following line to be relative offsets not savedoffsets
		    print "Restoring offsets: ",-self.largeOffsets
                    self.ircc.updatedOffsets = -self.largeOffsets
                    self.ircc.sendUpdatedOffsets()
		    time.sleep(5)

                self.sequenceSteps[ndx].modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('black'))
        #reset file tag to 'DATA'
        self.ircc.getPythonConfigStruct()
        self.ircc.pythonConfig['fileDescription'] = 'DATA'
        self.ircc.sendPythonConfigStruct()
        #self.ircc.pythonConfig['fileDescription'] = ' '
        #print "before", self.ircc.pythonConfig['fileDescription']
        #self.ircc.getPythonConfigStruct()
        #print "after", self.ircc.pythonConfig['fileDescription']
        
    def dataAcquisition(self):
        ndx= self.lengthOfSequence-1
        self.ircc.getStruct()

## load in current luminos positions and update pythonConfig
## HARDWIRED.. see common.py for filename of luminos_currents
## current incompatibility between pythonLibs and common.py means
## we have this lame kludge!!
## JDM 2007Jul26  ASSUMES NTEL telescopes are using the first NTEL BEAMS... 1.2.3.4...

        self.ircc.getPythonConfigStruct()
	try: pos = open('/home/devel/MIRC/mirc_python/.current_luminos_positions', 'r')
        except:
            print '/home/devel/MIRC/mirc_python/.current_luminos_positions INVALID'
        else:
            for h in range(1, (self.ircc.pythonConfig['NTels'])+1): #1, ..., self.ircc.pythonConfig['NTels']
	    ## Z AXIS FIRST -- NOT SAVED IN CURRENT PYCONFIG: 2007Jul24
                    line = pos.readline()
                    li = int(line)
		    print h,'Z:',li
            ## X AXIS NEXT
                    line = pos.readline()
                    li = int(line)
                    print h,'X:',li
		    self.ircc.pythonConfig['FiberExplorerX'][h-1]=li
            ## Y Axis NEXT
                    line = pos.readline()
                    li = int(line)
                    print h,'Y:',li
                    self.ircc.pythonConfig['FiberExplorerY'][h-1]=li
            pos.close()
            print 'Luminos positions have been recalled'
        self.ircc.sendPythonConfigStruct()
## make sure there is time to update config struct
	time.sleep(1.0)

        nfiles = int(self.numberOfFiles[ndx].get_text())
        if nfiles:
            self.ircc.getPythonConfigStruct()
            self.ircc.pythonConfig['fileDescription'] = 'DATA'
            self.ircc.sendPythonConfigStruct()
            self.sequenceSteps[ndx].modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('green'))
#JDM 2007Jul06.  skip shutter setup. Assume fringes are there!
 #           print "doing %s from shutter sequence" %(self.tags[ndx])
            #step 1: set the shutter configuration
##            for num, shutter in enumerate(self.defaultShutterNames):
##                print "doing shutter ", shutter
##                self.shutterActionCall[self.shutterSequenceActionsDict[ndx][shutter]](shutter)
##                shutNum = self.shutComm.shutterNames.index(shutter)
##                print "shutter %s current status = " %(shutter), self.shutComm.currentStatus[shutNum], shutNum
##                self.shutterStatus[num].set_text(self.shutComm.currentStatus[shutNum])
##                time.sleep(1)
            #step 2: set savenum
            print "self.ircc.daq['savenum'] = ", nfiles
            self.ircc.daq['savenum'] = nfiles
            #step 3:updates the daq structure with new savenum
            self.ircc.updateDoImageSave()
            print "self.ircc.daq['do_image_save'] = ",self.ircc.daq['do_image_save']
            doImageSave = 1
            savenum = nfiles
            #step 4:wait until self.daq['do_image_save'] == 0
            counter = 0
            while ((doImageSave == 1) or (savenum != 0)):
                print "counter = ", counter
                if not self.flag: break
                self.ircc.getStruct()
                doImageSave = self.ircc.daq['do_image_save']
                savenum = self.ircc.daq['savenum']
                print "doImageSave = ", doImageSave
                print "savenum = ", savenum
                counter +=1
                time.sleep(5.)
            self.sequenceSteps[ndx].modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('black'))
        
    def join(self, timeout = None):
        self._stopevent.set()
        self.shutComm.closeShutterSocket()
        threading.Thread.join(self, timeout)
        print "thread stopped"


class shutterMatrixTool(gtk.Window):
    def __init__(self, shutterSequenceThread, parent=None):        
        self.shutterSequenceThread = shutterSequenceThread
        self.shutterSequenceThread.start()
        self.shutComm = shutterCommandsClass()
        self.ir = ir.IRCamCommands()
        self.host = self.shutComm.host
        self.port = 2200
        gtk.threads_init()
        # Create the toplevel window
        gtk.Window.__init__(self)
        try:
            self.set_screen(parent.get_screen())
        except AttributeError:
            self.connect('destroy', lambda *w: gtk.main_quit())
    
        self.set_title('Shutter Matrix Tool')
    
        table = gtk.Table(7, 4, False)
    
        self.labelList = ['Background', 'Beam 1', 'Beam 2', 'Beam 3', 'Beam 4', \
                'Beam 5', 'Beam 6', 'Foreground', 'Data']
        self.lengthOfSequence = len(self.labelList)
        self.add(table)
    
        self.numberOfFiles = []
        
        button = gtk.Button('SET DETECTOR PARAMETERS')
        button.connect('clicked',  self.openDetectorParaWindow)
        table.attach(button,
            # X direction #          # Y direction
            0, 3,                      0, 1,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);
        self.shutterSequenceThread.sequenceSteps = []
        for ndx in range(self.lengthOfSequence):
            self.shutterSequenceThread.sequenceSteps.append(gtk.Label(self.labelList[ndx]))
            self.numberOfFiles.append(gtk.Entry())
    
            self.numberOfFiles[ndx].set_size_request(60, 20)
            print self.numberOfFiles[ndx].set_text('0')
            self.numberOfFiles[ndx].set_editable(True)
    
            table.attach(self.shutterSequenceThread.sequenceSteps[ndx],
                # X direction #          # Y direction
                0, 1,                      ndx+1, ndx+2,
                0,     0,
                0,                         0)
    
            table.attach(self.numberOfFiles[ndx],
                # X direction #          # Y direction
                1, 2,                      ndx+1, ndx+2,
                0,     0,
                0,                         0)
        self.shutterSequenceThread.numberOfFiles = self.numberOfFiles
        self.shutterSequenceThread.lengthOfSequence = self.lengthOfSequence
        self.shutterSequenceThread.labelList = self.labelList
    
        posi = ndx+2
        
        self.shutterSequenceThread.shutterStatus = []
        for ndx  in range(6):
            frame = gtk.Frame(self.shutterSequenceThread.defaultShutterNames[ndx])
            self.shutterSequenceThread.shutterStatus.append(gtk.Entry())
            self.shutterSequenceThread.shutterStatus[ndx].set_size_request(60, 30)
            frame.add(self.shutterSequenceThread.shutterStatus[ndx])
            table.attach(frame,
                # X direction #          # Y direction
                ndx, ndx+1,                      posi, posi+1,
                0,     0,
                0,                         0)
        self.shutterSequenceThread.shutterStatusDict = dict(itertools.izip(self.shutterSequenceThread.defaultShutterNames, self.shutterSequenceThread.shutterStatus))
            
        posi+=1
        button = gtk.Button('SHUTTERS')
        button.connect('clicked',  self.launchShutterSequence)
        table.attach(button,
            # X direction #          # Y direction
            0, 1,                      posi, posi+1,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);
    
        button = gtk.Button('GET DATA')
        button.connect('clicked',  self.launchDataAcquisition)
        table.attach(button,
            # X direction #          # Y direction
            1, 2,                      posi, posi+1,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);

        ##add a button to send offset to ople, XC, 2010 June
        #########start
        button = gtk.Button('send offset')
        button.connect('clicked',  self.send_offsets)
        table.attach(button,
            # X direction #          # Y direction
            2, 3,                      posi, posi+1,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);

        
        ##########end
    
        button = gtk.Button('CANCEL')
        button.connect('clicked',  self.cancelShutterSequence)
        table.attach(button,
            # X direction #          # Y direction
            3, 4,                      posi, posi+1,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);
    
        button = gtk.Button('SET VALUES TO 0')
        button.connect('clicked',  self.clearValuesFromEntries)
        table.attach(button,
            # X direction #          # Y direction
            4, 6,                      posi, posi+1,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);
    
        posi+=1
        button = gtk.Button('CLOSE')
        button.connect('clicked', lambda button, w=self: w.destroy())
        table.attach(button,
            # X direction #          # Y direction
            2, 3,                      posi, posi+1,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);
    
        button.set_flags(gtk.CAN_DEFAULT)
        button.grab_default()	
        self.show_all()

    def openDetectorParaWindow(self, widget):
        import IRCamLibs.detectorParams as detectorParams
        detectorParams.main(self.shutterSequenceThread.ircc)
        print IRCamLibs.camStructures.theDaq
        
    def clearValuesFromEntries(self, widget):
        for ndx  in range(6):
            self.numberOfFiles[ndx].set_text('0')
        
    def launchShutterSequence(self, widget):
        if self.shutterSequenceThread.flag:
            self.shutterSequenceThread.start()
        self.shutterSequenceThread.flag = 1

    def launchDataAcquisition(self, widget):
        if self.shutterSequenceThread.flag:
            self.shutterSequenceThread.start()
        self.shutterSequenceThread.flag = 2
    
    def cancelShutterSequence(self, widget):
        self.shutterSequenceThread.flag = 0


        # not working now, because struct.pack('I,48') is wired.
        #need to check this
    def send_offsets(self,widget):

        #pdb.set_trace()
        self.ir.getDelayLinesOffsets()
        #messageType = 'OPLE_BASELINE_SOLUTION_DATA'
        messageType = 400+38
        sm=common.delayLinesOffsets
        #sm=[1.,2.,3.,4.,5.,6.]
        #sm=array.array('d',[1.,2.,3.,4.,5.,6.])
        #address,length=array.array.buffer_info(sm)
 #       smessage_struct = struct.pack(\
 #           'HIL',\
 #           messageType,48,\
 #           sm[0],sm[1],sm[2],sm[3],sm[4],sm[5]\
 #           address
 #            'HIs',messageType,0,''
 #           )
        type=struct.pack('H',messageType)
        length=struct.pack('I',48)
        data=struct.pack('6d',sm[0],sm[1],sm[2],sm[3],sm[4],sm[5])
        #pdb.set_trace()
        sock = initSocket(self.host, self.port)
        if sock == None:
            print "socket frame failed to create"
        else:
            print "socket ok"
            sock.send(type)
            sock.send(length)
	    print sm
            print data
            sock.send(data)
            #sock.send(smessage_struct)
            print "sent data"
        sock.close()

def main():
    shutterSequence = shutterSequenceThread()
    gui = shutterMatrixTool(shutterSequence)
    gtk.main()
    shutterSequence.join()
    
    # DEBUGGING THINGS
    #print "Get shutter config"
    #shutterCommands.shutterConf()
    #print "Check shutter status"
    #shutterCommands.shutterStatus('IRB6')
    #time.sleep(0.1)
    #shutterCommands.openShutter('IRB6')
    #time.sleep(0.1)
    #shutterCommands.closeShutter('IRB6')
    #time.sleep(1)
    #shutterCommands.closeShutterSocket()
    ## create a thread
    #shutterSequence = shutterSequenceThread()
    #starts the GUI
    #gui = shutterMatrixTool(shutterSequence)
    #gtk.main()
    #remove the thread
    #shutterSequence.join()
    #shutterMessage = shutterMessageThread()
    #print 'ok1', shutterMessage._stopevent.isSet()
    #shutterMessage.start()
    #print 'ok2', shutterMessage._stopevent.isSet()
    #time.sleep(10)
    #shutterCommands.closeShutter(14)
    #time.sleep(20)
    #shutterMessage.join()
    #print 'ok3'
    # END OF DEBUGGING THINGS
    
if __name__ == '__main__':
    main()
