#!/usr/bin/env python
"""
An animated image
"""
import matplotlib
matplotlib.use('GTK')
from matplotlib.backends.backend_gtk import FigureCanvasGTK as FigureCanvas

from pylab import imshow
from pylab import cm
from pylab import axis
from matplotlib.figure import Figure
from pylab import ion
from pylab import subplot
import pylab
import gobject
import common
import time
#import numarray as na
import numpy as na
import pdb

class AnimatedImage:
    def __init__(self):
	self.fig1 = Figure(figsize=(256, 256))
        self.a1 = self.fig1.add_subplot(111)
        self.canvas1 = FigureCanvas(self.fig1)

        self.plot1Type = '2D image'
        self.plot1OldType = ''
        self.xrow1 = 0
        self.psxrow1 = 0
        self.psxcol1 = 0
    	self.cnt1 = 0
        self.quad1 = [0, 0, 0, 0]
        self.quad1Old = [0, 0, 0, 0]
        self.ps1XSec = 'row'
        self.ps1XSecOld = ''
        self.cmin1, self.cmax1 = 0, common.cols
        self.cmin1Old = 0
        self.cmax1Old = 0
        self.LC1 = 0
        self.LC1Old = 0
        
	self.fig2 = Figure(figsize=(256, 256))
        self.a2 = self.fig2.add_subplot(111)
        self.canvas2 = FigureCanvas(self.fig2)

        self.plot2Type = '2D image'
        self.plot2OldType = ''
        self.xrow2 = 0
        self.psxrow2 = 0
        self.psxcol2 = 0
    	self.cnt2 = 0
        self.quad2 = [0, 0, 0, 0]
        self.quad2Old = [0, 0, 0, 0]
        self.ps2XSec = 'row'
        self.ps2XSecOld = ''
        self.cmin2, self.cmax2 = 0, common.cols
        self.cmin2Old = 0
        self.cmax2Old = 0
        self.LC2 = 0
        self.LC2Old = 0

               
    def updatefig1(self):
        # left plot window
 
        if self.cnt1 == 0:
            self.plot1OldType = self.plot1Type
            self.ps1XSecOld = self.ps1XSec
            self.cmin1Old = self.cmin1
            self.cmax1Old = self.cmax1
            self.quad1Old = self.quad1
            self.LC1Old = self.LC1
        # check if the type of plot has changed
        if (self.plot1Type != self.plot1OldType) or (self.ps1XSecOld != self.ps1XSec)\
               or (self.cmin1Old != self.cmin1) or (self.cmax1Old != self.cmax1)\
               or (self.quad1Old != self.quad1) or (self.LC1Old != self.LC1):
            print "plot1 type changed"
            self.cnt1 = 0
            self.plot1OldType = self.plot1Type
            self.ps1XSecOld = self.ps1XSec
            self.cmin1Old = self.cmin1
            self.cmax1Old = self.cmax1
            self.quad1Old = self.quad1
            self.LC1Old = self.LC1
            self.fig1.clear()
            self.a1 = self.fig1.add_subplot(111)
            self.canvas1.queue_draw()
            
        if self.plot1Type == '2D image':
            if common.dataready1 == 1 and common.status1 == 1:
		if self.cnt1 == 0:
        # added aspect="auto" to all imshow. EP 10/11/07
                    self.im1 = self.a1.imshow(common.myArray, cmap=cm.bone, \
                                            interpolation='nearest', origin='lower', aspect="auto")
                    self.cnt1 = 1
        	else:
                    self.im1.set_array(common.myArray)
                self.canvas1.draw()
                
        elif self.plot1Type == 'quadrant mode':
            if common.dataready1 == 1 and common.status1 == 1:
                rmin, rmax, cmin, cmax = self.getQuadrant(self.quad1)
		if self.cnt1 == 0:
                    self.im1 = self.a1.imshow(common.myArray[rmin:rmax, cmin:cmax], \
                                              cmap=cm.bone, \
                                              interpolation='nearest', origin='lower', aspect="auto")
                    self.cnt1 = 1
        	else:
                    self.im1.set_array(common.myArray[rmin:rmax, cmin:cmax])
                self.canvas1.draw()
                
        elif self.plot1Type == 'cross section':
            if common.dataready1 == 1 and common.status1 == 1:
		if self.cnt1 == 0:
                    self.line1, = self.a1.plot(common.myArray[self.xrow1, self.cmin1:self.cmax1])
                    self.cnt1 = 1
                else:
                    self.line1.set_ydata(common.myArray[self.xrow1, self.cmin1:self.cmax1])

                    
                #self.a1.dataLim.update_numerix(self.line1.get_xdata(),
                #                               self.line1.get_ydata(),True)
                self.a1.update_datalim_numerix(self.line1.get_xdata(),
                                               self.line1.get_ydata())

                self.a1.autoscale_view()
                self.canvas1.draw()   # redraw the canvas
                
        elif self.plot1Type == 'power spectrum':
            if common.dataready1 == 1 and common.status1 == 1:
		if self.cnt1 == 0:
                    self.im1 = self.a1.imshow(common.psArray, cmap=cm.hot, \
                                            interpolation='nearest', origin='lower', aspect="auto")
                    self.cnt1 = 1
        	else:
                    self.im1.set_array(common.psArray)
                self.canvas1.draw()

        elif self.plot1Type == 'ps cross section':
            if common.dataready1 == 1 and common.status1 == 1:
		if self.cnt1 == 0:
                    if self.ps1XSec == 'row':
                        self.line1, = self.a1.plot(common.psArray[self.psxrow1, :])
                    if self.ps1XSec == 'col':
                        self.line1, = self.a1.plot(common.psArray[:, self.psxcol1])
                    self.cnt1 = 1
                else:
                    if self.ps1XSec == 'row':
                        self.line1.set_ydata(common.psArray[self.psxrow1, :])  # update the data
                    if self.ps1XSec == 'col':
                        self.line1.set_ydata(common.psArray[:, self.psxcol1])  # update the data
                    print self.ps1XSec
                #self.a1.dataLim.update_numerix(self.line1.get_xdata(),
                #                               self.line1.get_ydata(),True)
                self.a1.update_datalim_numerix(self.line1.get_xdata(),
                                               self.line1.get_ydata())
                self.a1.autoscale_view()
                self.canvas1.draw()   # redraw the canvas
                
        elif self.plot1Type == 'Light curve':
            #pdb.set_trace()
            if common.dataready1 == 1 and common.status1 == 1:
                xchanFluxArray = na.array(common.xchanFlux)
                xmin1 = na.min(xchanFluxArray)
                xmax1 = na.max(xchanFluxArray)
		if self.cnt1 == 0:
                    self.line10, = self.a1.plot(xchanFluxArray[:,0],'b-')
                    self.line11, = self.a1.plot(xchanFluxArray[:,1],'g-')
                    self.line12, = self.a1.plot(xchanFluxArray[:,2],'r-')
                    self.line13, = self.a1.plot(xchanFluxArray[:,3],'c-')
                    self.line14, = self.a1.plot(xchanFluxArray[:,4],'m-')
                    self.line15, = self.a1.plot(xchanFluxArray[:,5],'k-')
                    self.a1.set_xlabel('time')
                    self.a1.set_ylabel('flux')
                    self.cnt1 = 1
        	else:
                    self.line10.set_ydata(xchanFluxArray[:,0])
                    self.line11.set_ydata(xchanFluxArray[:,1])
                    self.line12.set_ydata(xchanFluxArray[:,2])
                    self.line13.set_ydata(xchanFluxArray[:,3])
                    self.line14.set_ydata(xchanFluxArray[:,4])
                    self.line15.set_ydata(xchanFluxArray[:,5])
                self.a1.set_ylim([xmin1,xmax1*1.5])
                self.a1.legend(('b1','b2','b3','b4','b5','b6'),loc=2,ncol=3)

                self.canvas1.draw()


        common.dataready1 = 0
        return True
    
    def updatefig2(self):
        # right plot window
        if self.cnt2 == 0:
            self.plot2OldType = self.plot2Type
            self.ps2XSecOld = self.ps2XSec
            self.cmin2Old = self.cmin2
            self.cmax2Old = self.cmax2
            self.quad2Old = self.quad2
            self.LC2Old = self.LC2
       # check if the type of plot has changed
        if (self.plot2Type != self.plot2OldType) or (self.ps2XSecOld != self.ps2XSec)\
               or (self.cmin2Old != self.cmin2) or (self.cmax2Old != self.cmax2)\
               or (self.quad2Old != self.quad2) or (self.LC2Old != self.LC2) :
            print "plot2 type changed"
            self.cnt2 = 0
            self.plot2OldType = self.plot2Type
            self.ps2XSecOld = self.ps2XSec
            self.cmin2Old = self.cmin2
            self.cmax2Old = self.cmax2
            self.quad2Old = self.quad2
            self.LC2Old = self.LC2
            self.fig2.clear()
            self.a2 = self.fig2.add_subplot(111)
            self.canvas2.queue_draw()
            
        if self.plot2Type == '2D image':
            if common.dataready2 == 1 and common.status2 == 1:
		if self.cnt2 == 0:
                    self.im2 = self.a2.imshow(common.myArray, cmap=cm.bone, \
                                            interpolation='nearest', origin='lower', aspect="auto")
                    self.cnt2 = 1
        	else:
                    self.im2.set_array(common.myArray)
                self.canvas2.draw()
                
        elif self.plot2Type == 'quadrant mode':
            if common.dataready2 == 1 and common.status2 == 1:
                rmin, rmax, cmin, cmax = self.getQuadrant(self.quad2)
		if self.cnt2 == 0:
                    self.im2 = self.a2.imshow(common.myArray[rmin:rmax, cmin:cmax], \
                                              cmap=cm.bone, \
                                              interpolation='nearest', origin='lower', aspect="auto")
                    self.cnt2 = 1
        	else:
                    self.im2.set_array(common.myArray[rmin:rmax, cmin:cmax])
                self.canvas2.draw()
                
        elif self.plot2Type == 'cross section':
            if common.dataready2 == 1 and common.status2 == 1:
		if self.cnt2 == 0:
                    self.line2, = self.a2.plot(common.myArray[self.xrow2, self.cmin2:self.cmax2])
                    self.cnt2 = 1
                else:
                    self.line2.set_ydata(common.myArray[self.xrow2, self.cmin2:self.cmax2])
          
                    #self.a2.dataLim.update_numerix(self.line2.get_xdata(),self.line2.get_ydata(),True)
                    self.a2.update_datalim_numerix(self.line2.get_xdata(),
                                               self.line2.get_ydata())
                self.a2.autoscale_view()
                self.canvas2.draw()   # redraw the canvas

        elif self.plot2Type == 'power spectrum':
            if common.dataready2 == 1 and common.status2 == 1:
		if self.cnt2 == 0:
                    self.im2 = self.a2.imshow(common.psArray, cmap=cm.hot, \
                                            interpolation='nearest', origin='lower', aspect="auto")
                    self.cnt2 = 1
        	else:
                    self.im2.set_array(common.psArray)
                self.canvas2.draw()

        elif self.plot2Type == 'ps cross section':
            if common.dataready2 == 1 and common.status2 == 1:
		if self.cnt2 == 0:
                    if self.ps2XSec == 'row':
                        self.line2, = self.a2.plot(common.psArray[self.psxrow2, :])
                    if self.ps2XSec == 'col':
                        self.line2, = self.a2.plot(common.psArray[:, self.psxcol2])
                        
                    self.cnt2 = 1
                else:
                    if self.ps2XSec == 'row':
                        self.line2.set_ydata(common.psArray[self.psxrow2, :])  # update the data
                    if self.ps2XSec == 'col':
                        self.line2.set_ydata(common.psArray[:, self.psxcol2])  # update the data
                #self.a2.dataLim.update_numerix(self.line2.get_xdata(),
                #                               self.line2.get_ydata(),True)
                self.a2.update_datalim_numerix(self.line2.get_xdata(),
                                               self.line2.get_ydata())
                self.a2.autoscale_view()
                self.canvas2.draw()   # redraw the canvas

        elif self.plot2Type == 'Light curve':
            #pdb.set_trace()
            if common.dataready2 == 1 and common.status2 == 1:
                xchanFluxArray = na.array(common.xchanFlux)
                xmin2 = na.min(xchanFluxArray)
                xmax2 = na.max(xchanFluxArray)
		if self.cnt2 == 0:
                    self.line20, = self.a2.plot(xchanFluxArray[:,0],'b-')
                    self.line21, = self.a2.plot(xchanFluxArray[:,1],'g-')
                    self.line22, = self.a2.plot(xchanFluxArray[:,2],'r-')
                    self.line23, = self.a2.plot(xchanFluxArray[:,3],'c-')
                    self.line24, = self.a2.plot(xchanFluxArray[:,4],'m-')
                    self.line25, = self.a2.plot(xchanFluxArray[:,5],'k-')
                    self.a2.set_xlabel('time')
                    self.a2.set_ylabel('flux')
                    self.cnt2 = 1
        	else:
                    self.line20.set_ydata(xchanFluxArray[:,0])
                    self.line21.set_ydata(xchanFluxArray[:,1])
                    self.line22.set_ydata(xchanFluxArray[:,2])
                    self.line23.set_ydata(xchanFluxArray[:,3])
                    self.line24.set_ydata(xchanFluxArray[:,4])
                    self.line25.set_ydata(xchanFluxArray[:,5])
                self.a2.set_ylim([xmin2,xmax2*1.5])
                self.a2.legend(('b1','b2','b3','b4','b5','b6'),loc=2,ncol=3)

                self.canvas2.draw()
     
        common.dataready2 = 0
        return True

    def getQuadrant(self, qd):
        r = common.rows
        c = common.cols
        arr11 = [0, r/2, 0, c/2]
        arr12 = [r/2, r , 0, c/2]
        arr13 = [0, r/2, c/2, c]
        arr14 = [r/2, r , c/2, c]
        arrs1 = [arr11, arr12, arr13, arr14]

        arr21 = [0, r/2, 0, c]
        arr22 = [0, r , 0, c/2]
        arr23 = [0, r, c/2, c]
        arr24 = [r/2, r , 0, c]
        arrs2 = [arr21, arr22, arr23, arr24]
        
        test = [[1,1,0,0], [1,0,1,0], [0,1,0,1], [0,0,1,1]]
        
        if qd.count(1) in [0, 3, 4]:
            return [0, r, 0, c]

        if qd.count(1) == 1:
            return arrs1[qd.index(1)]

        if qd.count(1) == 2:
            if qd in test:
                return arrs2[test.index(qd)]
            else:
                return [0, r, 0, c]
                
        if qd.count(1) == 3:
            return [0, r, 0, c]
        
        if qd.count(1) == 4:
            return [0, r, 0, c]
