import gtk
import socket
#import numarray as  na
import numpy as na
import gobject
import copy
import time
import fringeIconsTiny as fringeIcons
import common
import IRCamCommands
import pdb
from httplib import HTTP
import pickle
from multiprocessing import Process
from threading import Thread

### usage
### write data
### fichier=open('file', 'w')
### pickle.dump(data, fichier)
### fichier.close()
### read data
### fichier=open('file', 'r')
### data = pickle.load(fichier)
### fichier.close()
import string, re, sys

def scale_set_default_values(scale):
    scale.set_update_policy(gtk.UPDATE_CONTINUOUS)
    scale.set_digits(1)
    scale.set_value_pos(gtk.POS_TOP)
    scale.set_draw_value(True)

def create_arrow_button(arrow_type, shadow_type):
    button = gtk.Button();
    arrow = gtk.Arrow(arrow_type, shadow_type);
    button.add(arrow)
    button.show()
    arrow.show()
    return button

def create_double_arrow_button(arrow_type, shadow_type):
    button = gtk.Button();
    hbox = gtk.HBox()
    arrow = gtk.Arrow(arrow_type, shadow_type);
    hbox.add(arrow)
    arrow = gtk.Arrow(arrow_type, shadow_type);
    hbox.add(arrow)
    button.add(hbox)
    button.show()
    arrow.show()
    return button


####################################################################

########################## GDT 2 ###################################
class gdtControl2(gtk.Window):
    def __init__(self, parent=None):
        self.sockTimeout = 20
        self.ircc = IRCamCommands.IRCamCommands()
        self.telNames = ['S1', 'S2', 'E1', 'E2', 'W1', 'W2']
        self.activeTel = [True, True, True, True, True, True]
        self.refTel = [True, False, False, False, False, False]
        self.beamOrder = self.queryTiptilt()
        if self.beamOrder == None:
            self.beamOrder = ['1', '2', '3', '4', '5', '6']
        self.beamInUse = []
        self.nDelayLines = 6
        self.nBaselines = self.nDelayLines*(self.nDelayLines-1)/2
        for i in range(self.nDelayLines):
            if self.activeTel[i] == True:
                self.beamInUse.append(self.beamOrder[i])
        self.beamInUse.sort()
        
        self.telColor = ['purple', 'blue', 'darkgreen', 'darkorange', 'red', 'magenta']
##         self.telColor = ['violet', 'skyblue', 'palegreen', 'orange', 'pink', 'darkred']
        self.colorDict = {}
        self.beamOrderDict = {}
        for i in range(6):
            self.beamOrderDict[self.beamOrder[i]] = self.telNames[i]
            self.colorDict[self.telNames[i]] = self.telColor[i]
        #print self.beamOrderDict, self.beamInUse

        common.activeTel = self.activeTel

        for x in range(6):
            for y in range(6):
                common.matrixFringe[x][y] = -999.


                                
        # Create the toplevel window
        gtk.Window.__init__(self)
        try:
            self.set_screen(parent.get_screen())
        except AttributeError:
            self.connect('destroy', lambda *w: gtk.main_quit())

        screenWidth = gtk.gdk.screen_width()
        screenHeight = gtk.gdk.screen_height()
        
        #print "screenWidth = ", screenWidth, "screenHeight", screenHeight

        import os
        thmdir = gtk.rc_get_theme_dir()
        theme = os.path.join(thmdir, "Grand-Canyon", "gtk-2.0", "gtkrc")
        if os.path.exists(theme): style = "include '%s'\n" % theme
        else: style = ""

        # Here you can change any of the individual widget characteristics
        # as well as default fonts, colours etc.
        style = style + """
        style "mystyle"
        {
          font_name = "%s"
          GtkWidget::interior_focus = 1
        }
        widget "*" style "mystyle"

        style "mymenu"
        {
          font_name = "%s"
        }
        widget "*Menu*" style "mymenu"
        """ % ("Arial 8", "Arial 8")

        scale = 8

        # Apply this theme to your app
        gtk.rc_parse_string(style)
        self.set_title(self.__class__.__name__)
        self.set_default_size(400, 400)
        
        table = gtk.Table(10, 40, False)
        self.add(table)

        self.updateGdtTag = [-1]*self.nBaselines
        self.loopDLTag = -1
        self.checkThreshold = [True]*self.nDelayLines
        self.loopDLFlag = [False]*self.nDelayLines
        self.loopSign = ['plus']*self.nDelayLines
        self.threshold = na.array([20.]*self.nBaselines*2)
        self.thresholdfactor = 5
        self.steps = na.array([0.008]*self.nDelayLines)
        self.Relative = na.zeros(self.nDelayLines,  dtype=na.float64)
        self.Absolute = na.zeros(self.nDelayLines,  dtype=na.float64)
        self.posiEntry = []
        self.entrySteps = []
        self.weightEntry = []
        self.opdEntry = []
        self.thresholdEntry = []
        self.thresholdCalc = []
        self.baselineLabel1 = []
        self.baselineLabel2 = []
        self.weightFrame = []
        self.opdFrame = []
        thresholdFrame = []
        self.matrixFrame = []
        self.lockFringes = []
        self.beam = []
        self.baselineBeam = {1:2, 3:3, 6:4, 10:5, 15:6}
        
        self.fringeDetected = []
        self.loopMinusButton = []
        self.loopPlusButton = []
        
        self.matrixLock = []
        self.matrixSolve = []
        self.matrixCross = []
        self.matrixLabel = []
        self.matrixHBox = []

        self.matrixNrLock =  [5,9,6,10,7,12,1,0,2,3,11,8,13,14,4] # for W1S2S1E1E2W2
        self.matrixNrLock2 = [7,6,8,9,14,0,2,4,11,1,3,10,5,12,13]
        self.matrixNrCross =  [5,9,10,1,11,6,7,0,8,12,2,13,3,14,4]  # for W1S2S1E1E2W2
        self.matrixNrCross2 =  [7,3,10,12,14,0,5,6,8,1,2,4,9,11,13]

        #self.matrixNrLock =  [9,11,13,10,12,14,1,2,4,3,5,6,8,7,0] # for W1W2S1S2E2E1
        #self.matrixNrLock2 = [14,6,7,9,8,10,11,13,12,0,3,1,4,2,5]
        #self.matrixNrCross =  [9,11,10,1,5,13,12,2,6,14,4,8,3,7,0]
        #self.matrixNrCross2 =  [14,3,7,12,10,4,8,13,11,0,2,1,6,5,9]
                

        #self.matrixNrLock =  [14,13,12,11,10,9,4,3,2,1,8,7,6,5,0] # for W1W2E2E1S2S1
        #self.matrixNrLock2 = [14,9,8,7,6,13,12,11,10,5,4,3,2,1,0]
        #self.matrixNrCross =  [14,13,11,4,8,12,10,3,7,9,2,6,1,5,0]
        #self.matrixNrCross2 =  [14,12,10,7,3,13,11,8,4,9,6,2,5,1,0]
                                                                        
                
        #self.matrixNrLock = [9,12,10,13,11,14,6,5,7,8,2,1,3,4,0]   # for W2W1S2S1E1E2
        #self.matrixNrLock2 = [14,11,10,12,13,7,6,8,9,0,2,4,1,3,5]
        #self.matrixNrCross = [9,12,13,6,2,10,11,5,1,14,7,3,8,4,0]    # for W2W1S2S1E1E2 
        #self.matrixNrCross2 =  [14,8,4,11,13,7,3,10,12,0,5,6,1,2,9]

        #self.matrixNrLock = [13,12,14,9,11,10,6,8,7,5,2,4,3,1,0]   # for W2W1E2S1E1S2
        #self.matrixNrLock2 = [14,13,10,12,11,9,6,8,7,3,5,4,1,0,2]
        #self.matrixNrCross = [13,12,9,6,2,14,11,8,4,10,7,3,5,1,0]    # for W2W1E2S1E1S2
        #self.matrixNrCross2 =  [14,13,4,11,8,12,3,10,7,2,9,6,1,0,5]

        #self.matrixNrLock =  [11,14,10,13,9,12,4,1,3,2,8,5,7,6,0] # for W1W2S2E2E1S1
        #self.matrixNrLock2 = [14,7,9,8,6,11,13,12,10,4,2,0,5,3,1]
        #self.matrixNrCross = [11,14,13,4,8,10,9,1,5,12,3,7,2,6,0]  # for W1W2S2E2E1S1
        #self.matrixNrCross2 =[14,7,12,10,3,8,13,11,4,6,5,0,9,2,1]
                        
                                

        #baselines are 1-2, 1-3, 1-4, 1-5, 1-6, 2-3, 2-4, 2-5, 2-6, 3-4, 3-5, 3-6, 4-5, 4-6, 5-6
        self.baselines = [self.beamOrderDict['1']+self.beamOrderDict['2'], self.beamOrderDict['1']+self.beamOrderDict['3'],
                        self.beamOrderDict['1']+self.beamOrderDict['4'], self.beamOrderDict['1']+self.beamOrderDict['5'],
                        self.beamOrderDict['1']+self.beamOrderDict['6'], self.beamOrderDict['2']+self.beamOrderDict['3'],
                        self.beamOrderDict['2']+self.beamOrderDict['4'], self.beamOrderDict['2']+self.beamOrderDict['5'],
                        self.beamOrderDict['2']+self.beamOrderDict['6'], self.beamOrderDict['3']+self.beamOrderDict['4'],
                        self.beamOrderDict['3']+self.beamOrderDict['5'], self.beamOrderDict['3']+self.beamOrderDict['6'],
                        self.beamOrderDict['4']+self.beamOrderDict['5'], self.beamOrderDict['4']+self.beamOrderDict['6'],
                        self.beamOrderDict['5']+self.beamOrderDict['6']]
                        
        self.weightLabels = [self.baselines[0], self.baselines[1], self.baselines[2], self.baselines[3], self.baselines[4], 
                            self.baselines[0], self.baselines[5], self.baselines[6], self.baselines[7], self.baselines[8],
                            self.baselines[1], self.baselines[5], self.baselines[9], self.baselines[10], self.baselines[11],
                            self.baselines[2], self.baselines[6], self.baselines[9], self.baselines[12], self.baselines[13],
                            self.baselines[3], self.baselines[7], self.baselines[10], self.baselines[12], self.baselines[14],
                            self.baselines[4], self.baselines[8], self.baselines[11], self.baselines[13], self.baselines[14]]
        self.weightPairs = [5, 10, 15, 20, 25,
                            0, 11, 16, 21, 26,
                            1, 6, 17, 22, 27,
                            2, 7, 12, 23, 28,
                            3, 8, 13, 18, 29,
                            4, 9, 14, 19, 24]
            
        for i in range(self.nDelayLines):
            self.posiEntry.append(gtk.Entry())
            self.entrySteps.append(gtk.Entry())
            txt = "DELAY LINE %s: beam " %(self.telNames[i])
            label = gtk.Label()
            label.set_markup('<b>%s</b>' %txt)
            label.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.colorDict[self.telNames[i]]))
            hbox = gtk.HBox(False,0)
            hbox.pack_start(label, False, False, 0)
            table.attach(hbox,
                        # X direction #          # Y direction
                        0, 6,                      i*4+1, i*4+2,
                        gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);
            
            self.beam.append(gtk.Entry())
            self.beam[i].set_text(self.beamOrder[i])
            self.beam[i].set_size_request(2*scale, 2*scale)
            self.beam[i].connect("activate", self.manualBeamSet, i)
            self.beam[i].modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.colorDict[self.telNames[i]]))
            #self.beam[i].set_editable(False)
            hbox.pack_start(self.beam[i], False, False, 0)

            button = gtk.CheckButton('use this tel')
            button.modify_text(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.colorDict[self.telNames[i]]))
            button.modify_text(gtk.STATE_PRELIGHT, gtk.gdk.color_parse(self.colorDict[self.telNames[i]]))
            button.set_active(self.activeTel[i])
            button.connect("toggled", self.setActiveTel, i)
            #button.set_size_request(8*scale, 2*scale)
            hbox.pack_start(button, False, False, 10)

            if i == 0:
                refTelButton = gtk.RadioButton(None, 'reference tel')
                refTelButton.set_active(self.refTel[i])
            else: refTelButton = gtk.RadioButton(refTelButton, 'reference tel')
            refTelButton.modify_text(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.colorDict[self.telNames[i]]))    
            refTelButton.modify_text(gtk.STATE_PRELIGHT, gtk.gdk.color_parse(self.colorDict[self.telNames[i]]))    
            refTelButton.connect("toggled", self.setRefTel, i)
            #refTelButton.set_size_request(10*scale, 2*scale)
            hbox.pack_start(refTelButton, False, False, 0)

            self.fringeDetected.append(gtk.Frame())
            image = fringeIcons.makeIcon('grey')
            self.fringeDetected[i].add(image)
            #self.fringeDetected[i].set_size_request(2*scale, 2*scale)
            hbox.pack_start(self.fringeDetected[i], False, False, 0)
        

            button = gtk.Button('ZERO')
            button.set_size_request(4*scale, 2*scale)
            button.connect("clicked", self.move_cb, "zero", i)
            table.attach(button,
                        # X direction #          # Y direction
                        0, 1,                      i*4+2, i*4+3,
            gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
            0,                         0);
            button = create_double_arrow_button(gtk.ARROW_LEFT, gtk.SHADOW_ETCHED_IN)
            #button.set_size_request(4*scale, 2*scale)
            button.connect("clicked", self.move_cb, "fastLeft", i)
            table.attach(button,
                        # X direction #          # Y direction
                        1, 2,                      i*4+2, i*4+3,
                        gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);
            button = create_arrow_button(gtk.ARROW_LEFT, gtk.SHADOW_ETCHED_IN)
            button.set_size_request(4*scale, 2*scale)
            button.connect("clicked", self.move_cb, "left", i)
            table.attach(button,
                        # X direction #          # Y direction
                        2, 3,                      i*4+2, i*4+3,
                        gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);
            
            #self.posiEntry[i].set_editable(True)
            #self.posiEntry[i].connect('activate', self.setManualOffset, i)
            self.posiEntry[i].set_text(str(self.Relative[i]))
            self.posiEntry[i].set_size_request(8*scale, 2*scale)
            table.attach(self.posiEntry[i],
                        # X direction #          # Y direction
                        3, 4,                      i*4+2, i*4+3,
                        gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);
            
            button = create_arrow_button(gtk.ARROW_RIGHT, gtk.SHADOW_ETCHED_IN)
            button.set_size_request(4*scale, 2*scale)
            button.connect("clicked", self.move_cb, "right", i)
            table.attach(button,
                        # X direction #          # Y direction
                        4, 5,                      i*4+2, i*4+3,
            gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);
            
            button = create_double_arrow_button(gtk.ARROW_RIGHT, gtk.SHADOW_ETCHED_IN)
            button.set_size_request(4*scale, 2*scale)
            button.connect("clicked", self.move_cb, "fastRight", i)
            table.attach(button,
                        # X direction #          # Y direction
                        5, 6,                      i*4+2, i*4+3,
                        gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);
            
            
            frame = gtk.Frame("STEP SIZE")
            
            self.entrySteps[i].set_size_request(6*scale, 2*scale)
            self.entrySteps[i].set_text(str(self.steps[i]))
            self.entrySteps[i].connect("activate", self.enter_callback, i)
            frame.add(self.entrySteps[i])
            table.attach(frame,
                        # X direction #          # Y direction
                        0, 1,                      i*4+3, i*4+4,
                        0,     0,
                        0,                         0);
            
            self.loopMinusButton.append(gtk.ToggleButton('LOOP -'))
            #self.loopMinusButton[i].set_size_request(6*scale, 2*scale)
            self.loopMinusButton[i].modify_bg(gtk.STATE_PRELIGHT, gtk.gdk.color_parse("orange"))
            self.loopMinusButton[i].modify_bg(gtk.STATE_ACTIVE, gtk.gdk.color_parse("orange"))
            self.loopMinusButton[i].connect('clicked', self.startLoop, 'minus', i)
            table.attach(self.loopMinusButton[i],
                        # X direction #          # Y direction
                        1, 2,                      i*4+3, i*4+4,
                        gtk.EXPAND | gtk.FILL,     0,
                        0,                         0);

            self.loopPlusButton.append(gtk.ToggleButton('LOOP +'))
            #self.loopPlusButton[i].set_size_request(6*scale, 2*scale)
            self.loopPlusButton[i].modify_bg(gtk.STATE_PRELIGHT, gtk.gdk.color_parse("orange"))
            self.loopPlusButton[i].modify_bg(gtk.STATE_ACTIVE, gtk.gdk.color_parse("orange"))
            self.loopPlusButton[i].connect('clicked', self.startLoop, 'plus', i)
            table.attach(self.loopPlusButton[i],
                        # X direction #          # Y direction
                        2, 3,                      i*4+3, i*4+4,
                        gtk.EXPAND | gtk.FILL,     0,
                        0,                         0);
            
            button = gtk.CheckButton('threshold check')
            button.set_active(self.checkThreshold[i])
            button.modify_text(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.telColor[i]))    
            button.modify_text(gtk.STATE_PRELIGHT, gtk.gdk.color_parse(self.telColor[i]))    
            button.connect("toggled", self.checkThreshButton, i)
            #button.set_size_request(12*scale, 2*scale)
            table.attach(button,
                        # X direction #          # Y direction
                        4, 6,                      i*4+3, i*4+4,
                        gtk.EXPAND | gtk.FILL,     0,
                        0,                         0);

            sep = gtk.VSeparator()
            sep.set_size_request(2*scale, 2*scale)
            table.attach(sep,
                        # X direction #          # Y direction
                        6, 7,                      i*4+1, i*4+5,
                        gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);
            sep = gtk.HSeparator()
            sep.set_size_request(6*scale, 2*scale)
            table.attach(sep,
                        # X direction #          # Y direction
                        0, 6,                      i*4+4, i*4+5,
                        gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);


        label = gtk.Label("BASELINES")
        table.attach(label,
                    # X direction #          # Y direction
                    7, 9,                      1, 2,
                    gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                    0,                         0);
        label = gtk.Label("OPD")
        table.attach(label,
                    # X direction #          # Y direction
                    9, 10,                      1, 2,
                    gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                    0,                         0);
        label = gtk.Label("WEIGHT")
        table.attach(label,
                    # X direction #          # Y direction
                    10, 11,                      1, 2,
                    gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                    0,                         0);
        label = gtk.Label("THRESHOLD")
        table.attach(label,
                    # X direction #          # Y direction
                    11, 12,                     1, 2,
                    gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                    0,                         0);
        label = gtk.Label("                          LOCK")
        table.attach(label,
                    # X direction #          # Y direction
                    12, 14,                     1, 2,
                    gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                    0,                         0);
        

        #SK: generate telescope matrix with weights
        #0 W1 S2
        #1 W1 S1
        #2 W1 E1
        #3 W1 E2
        #4 W1 W2
        #5 S2 S1
        #6 S2 E1
        #7 S2 E2
        #8 S2 W2
        #9 S1 E1
        #10 S1 E2
        #11 S1 W2
        #12 E1 E2
        #13 E1 W2
        #14 E2 W2
        
        #*** Top label
        matrixCrosscount = 0
        matrixSolvecount = 0
        matrixLockcount = 0
        matrixHBoxcount = 0
        
        self.matrixHBox.append(gtk.HBox)
        self.matrixHBox[matrixHBoxcount] = gtk.HBox(True,0)
        self.matrixClear = gtk.Button('Clear Matrix')
        self.matrixClear.set_size_request(90, 28)
        self.matrixClear.connect("clicked", self.matrixClearClick)
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixClear, False, False, 0)
        #label = gtk.Label("")
        #self.matrixHBox[matrixHBoxcount].pack_start(label, False, False, 0)
        label = gtk.Label("")
        self.matrixHBox[matrixHBoxcount].pack_start(label, False, False, 0)
        self.matrixLabel.append(gtk.Label())
        self.matrixLabel[0] = gtk.Label("S1")
        self.matrixLabel[0].modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.telColor[0]))
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLabel[0], False, False, 0)
        self.matrixLabel.append(gtk.Label())
        self.matrixLabel[1] = gtk.Label("S2")
        self.matrixLabel[1].modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.telColor[1]))
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLabel[1], False, False, 0)
        self.matrixLabel.append(gtk.Label())
        self.matrixLabel[2] = gtk.Label("E1")
        self.matrixLabel[2].modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.telColor[2]))
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLabel[2], False, False, 0)
        self.matrixLabel.append(gtk.Label())
        self.matrixLabel[3] = gtk.Label("E2")
        self.matrixLabel[3].modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.telColor[3]))
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLabel[3], False, False, 0)
        self.matrixLabel.append(gtk.Label())
        self.matrixLabel[4] = gtk.Label("W1")
        self.matrixLabel[4].modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.telColor[4]))
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLabel[4], False, False, 0)
        self.matrixLabel.append(gtk.Label())
        self.matrixLabel[5] = gtk.Label("W2")
        self.matrixLabel[5].modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.telColor[5]))
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLabel[5], False, False, 0)
        table.attach(self.matrixHBox[matrixHBoxcount],
                     # X direction #          # Y direction
                     8,14,                     21,22,
                     gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                     0,                         0);

        #*** S1
        matrixHBoxcount = matrixHBoxcount+1
        self.matrixHBox.append(gtk.HBox)
        self.matrixHBox[matrixHBoxcount] = gtk.HBox(True,0)
        table.attach(self.matrixHBox[matrixHBoxcount],
                     # X direction #          # Y direction
                     8,14,                     22,23,
                     gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                     0,                         0);

        self.matrixSolve.append(gtk.Button())
        self.matrixSolve[matrixSolvecount] = gtk.Button('')
        self.matrixSolve[matrixSolvecount].set_size_request(90, 28)
        self.matrixSolve[matrixSolvecount].connect("clicked", self.matrixSolveClick, matrixSolvecount)
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixSolve[matrixSolvecount], False, False, 0)

        self.matrixLabel.append(gtk.Label())
        self.matrixLabel[6] = gtk.Label("S1")
        self.matrixLabel[6].set_size_request(25, 28)
        self.matrixLabel[6].modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.telColor[0]))
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLabel[6], False, False, 0)
        self.matrixLabel.append(gtk.Label())
        self.matrixLabel[7] = gtk.Label("-")
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLabel[7], False, False, 0)


        self.matrixCross.append(gtk.Button())
        self.matrixCross[matrixCrosscount].set_size_request(75, 28)
        self.matrixCross[matrixCrosscount].connect("clicked", self.matrixCrossClick, matrixCrosscount, 5)   #S2S1=5
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixCross[matrixCrosscount], False, False, 0)

        matrixCrosscount = matrixCrosscount+1
        self.matrixCross.append(gtk.Button())
        self.matrixCross[matrixCrosscount].set_size_request(75, 28)
        self.matrixCross[matrixCrosscount].connect("clicked", self.matrixCrossClick, matrixCrosscount, 9)   #E1S1=9
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixCross[matrixCrosscount], False, False, 0)

        matrixCrosscount = matrixCrosscount+1
        self.matrixCross.append(gtk.Button())
        self.matrixCross[matrixCrosscount].set_size_request(75, 28)
        self.matrixCross[matrixCrosscount].connect("clicked", self.matrixCrossClick, matrixCrosscount, 10)  #E2S1=10
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixCross[matrixCrosscount], False, False, 0)

        matrixCrosscount = matrixCrosscount+1
        self.matrixCross.append(gtk.Button())
        self.matrixCross[matrixCrosscount].set_size_request(75, 28)
        self.matrixCross[matrixCrosscount].connect("clicked", self.matrixCrossClick, matrixCrosscount, 1)   #W1S1=1
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixCross[matrixCrosscount], False, False, 0)

        matrixCrosscount = matrixCrosscount+1
        self.matrixCross.append(gtk.Button())
        self.matrixCross[matrixCrosscount].set_size_request(75, 28)
        self.matrixCross[matrixCrosscount].connect("clicked", self.matrixCrossClick, matrixCrosscount, 11)  #W2S1=11
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixCross[matrixCrosscount], False, False, 0)



        #*** S2
        matrixHBoxcount = matrixHBoxcount+1
        self.matrixHBox.append(gtk.HBox)
        self.matrixHBox[matrixHBoxcount] = gtk.HBox(True,0)
        table.attach(self.matrixHBox[matrixHBoxcount],
                     # X direction #          # Y direction
                     8,14,                     23,24,
                     gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                     0,                         0);

        matrixSolvecount = matrixSolvecount+1
        self.matrixSolve.append(gtk.Button())
        self.matrixSolve[matrixSolvecount] = gtk.Button('')
        self.matrixSolve[matrixSolvecount].set_size_request(90, 28)
        self.matrixSolve[matrixSolvecount].connect("clicked", self.matrixSolveClick, matrixSolvecount)
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixSolve[matrixSolvecount], False, False, 0)

        self.matrixLabel.append(gtk.Label())
        self.matrixLabel[8] = gtk.Label("S2")
        self.matrixLabel[8].set_size_request(25, 28)
        self.matrixLabel[8].modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.telColor[1]))
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLabel[8], False, False, 0)

        self.matrixLock.append(gtk.Button())
        self.matrixLock[matrixLockcount] = gtk.ToggleButton('')
        self.matrixLock[matrixLockcount].set_size_request(75, 28)
        self.matrixLock[matrixLockcount].connect("clicked", self.matrixLockClick, matrixLockcount, 5)                         #S1S2=5
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLock[matrixLockcount], False, False, 0)

        self.matrixLabel.append(gtk.Label())
        self.matrixLabel[9] = gtk.Label("-")
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLabel[9], False, False, 0)


        matrixCrosscount = matrixCrosscount+1
        self.matrixCross.append(gtk.Button())
        self.matrixCross[matrixCrosscount].set_size_request(75, 28)
        self.matrixCross[matrixCrosscount].connect("clicked", self.matrixCrossClick, matrixCrosscount, 6)   #E1S2=6
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixCross[matrixCrosscount], False, False, 0)

        matrixCrosscount = matrixCrosscount+1
        self.matrixCross.append(gtk.Button())
        self.matrixCross[matrixCrosscount].set_size_request(75, 28)
        self.matrixCross[matrixCrosscount].connect("clicked", self.matrixCrossClick, matrixCrosscount, 7)   #E2S2=7
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixCross[matrixCrosscount], False, False, 0)

        matrixCrosscount = matrixCrosscount+1
        self.matrixCross.append(gtk.Button())
        self.matrixCross[matrixCrosscount].set_size_request(75, 28)
        self.matrixCross[matrixCrosscount].connect("clicked", self.matrixCrossClick, matrixCrosscount, 0)   #W1S2=0
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixCross[matrixCrosscount], False, False, 0)

        matrixCrosscount = matrixCrosscount+1
        self.matrixCross.append(gtk.Button())
        self.matrixCross[matrixCrosscount].set_size_request(75, 28)
        self.matrixCross[matrixCrosscount].connect("clicked", self.matrixCrossClick, matrixCrosscount, 8)   #W2S2=8
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixCross[matrixCrosscount], False, False, 0)



        #*** E1
        matrixHBoxcount = matrixHBoxcount+1
        self.matrixHBox.append(gtk.HBox)
        self.matrixHBox[matrixHBoxcount] = gtk.HBox(True,0)
        table.attach(self.matrixHBox[matrixHBoxcount],
                     # X direction #          # Y direction
                     8,14,                     24,25,
                     gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                     0,                         0);

        matrixSolvecount = matrixSolvecount+1
        self.matrixSolve.append(gtk.Button())
        self.matrixSolve[matrixSolvecount] = gtk.Button('')
        self.matrixSolve[matrixSolvecount].set_size_request(90, 28)
        self.matrixSolve[matrixSolvecount].connect("clicked", self.matrixSolveClick, matrixSolvecount)
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixSolve[matrixSolvecount], False, False, 0)

        self.matrixLabel.append(gtk.Label())
        self.matrixLabel[10] = gtk.Label("E1")
        self.matrixLabel[10].set_size_request(25, 28)
        self.matrixLabel[10].modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.telColor[2]))
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLabel[10], False, False, 0)

        matrixLockcount = matrixLockcount+1
        self.matrixLock.append(gtk.Button())
        self.matrixLock[matrixLockcount] = gtk.ToggleButton('')
        self.matrixLock[matrixLockcount].set_size_request(75, 28)
        self.matrixLock[matrixLockcount].connect("clicked", self.matrixLockClick, matrixLockcount, 9)                         #S1E1=9
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLock[matrixLockcount], False, False, 0)

        matrixLockcount = matrixLockcount+1
        self.matrixLock.append(gtk.Button())
        self.matrixLock[matrixLockcount] = gtk.ToggleButton('')
        self.matrixLock[matrixLockcount].set_size_request(75, 28)
        self.matrixLock[matrixLockcount].connect("clicked", self.matrixLockClick, matrixLockcount, 6)                         #S2E1=6
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLock[matrixLockcount], False, False, 0)

        self.matrixLabel.append(gtk.Label())
        self.matrixLabel[11] = gtk.Label("-")
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLabel[11], False, False, 0)


        matrixCrosscount = matrixCrosscount+1
        self.matrixCross.append(gtk.Button())
        self.matrixCross[matrixCrosscount].set_size_request(75, 28)
        self.matrixCross[matrixCrosscount].connect("clicked", self.matrixCrossClick, matrixCrosscount, 12)  #E2E1=12
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixCross[matrixCrosscount], False, False, 0)

        matrixCrosscount = matrixCrosscount+1
        self.matrixCross.append(gtk.Button())
        self.matrixCross[matrixCrosscount].set_size_request(75, 28)
        self.matrixCross[matrixCrosscount].connect("clicked", self.matrixCrossClick, matrixCrosscount, 2)   #W1E1=2
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixCross[matrixCrosscount], False, False, 0)

        matrixCrosscount = matrixCrosscount+1
        self.matrixCross.append(gtk.Button())
        self.matrixCross[matrixCrosscount].set_size_request(75, 28)
        self.matrixCross[matrixCrosscount].connect("clicked", self.matrixCrossClick, matrixCrosscount, 13)  #W2E1=13
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixCross[matrixCrosscount], False, False, 0)



        #*** E2
        matrixHBoxcount = matrixHBoxcount+1
        self.matrixHBox.append(gtk.HBox)
        self.matrixHBox[matrixHBoxcount] = gtk.HBox(True,0)
        table.attach(self.matrixHBox[matrixHBoxcount],
                     # X direction #          # Y direction
                     8,14,                     25,26,
                     gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                     0,                         0);

        matrixSolvecount = matrixSolvecount+1
        self.matrixSolve.append(gtk.Button())
        self.matrixSolve[matrixSolvecount] = gtk.Button('')
        self.matrixSolve[matrixSolvecount].set_size_request(90, 28)
        self.matrixSolve[matrixSolvecount].connect("clicked", self.matrixSolveClick, matrixSolvecount)
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixSolve[matrixSolvecount], False, False, 0)

        self.matrixLabel.append(gtk.Label())
        self.matrixLabel[12] = gtk.Label("E2")
        self.matrixLabel[12].set_size_request(25, 28)
        self.matrixLabel[12].modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.telColor[3]))
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLabel[12], False, False, 0)

        matrixLockcount = matrixLockcount+1
        self.matrixLock.append(gtk.Button())
        self.matrixLock[matrixLockcount] = gtk.ToggleButton('')
        self.matrixLock[matrixLockcount].set_size_request(75, 28)
        self.matrixLock[matrixLockcount].connect("clicked", self.matrixLockClick, matrixLockcount, 10)                        #S1E2=10
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLock[matrixLockcount], False, False, 0)

        matrixLockcount = matrixLockcount+1
        self.matrixLock.append(gtk.Button())
        self.matrixLock[matrixLockcount] = gtk.ToggleButton('')
        self.matrixLock[matrixLockcount].set_size_request(75, 28)
        self.matrixLock[matrixLockcount].connect("clicked", self.matrixLockClick, matrixLockcount, 7)                         #S2E2=7
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLock[matrixLockcount], False, False, 0)

        matrixLockcount = matrixLockcount+1
        self.matrixLock.append(gtk.Button())
        self.matrixLock[matrixLockcount] = gtk.ToggleButton('')
        self.matrixLock[matrixLockcount].set_size_request(75, 28)
        self.matrixLock[matrixLockcount].connect("clicked", self.matrixLockClick, matrixLockcount, 12)                        #E1E2=12
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLock[matrixLockcount], False, False, 0)

        self.matrixLabel.append(gtk.Label())
        self.matrixLabel[13] = gtk.Label("-")
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLabel[13], False, False, 0)


        matrixCrosscount = matrixCrosscount+1
        self.matrixCross.append(gtk.Button())
        self.matrixCross[matrixCrosscount].set_size_request(75, 28)
        self.matrixCross[matrixCrosscount].connect("clicked", self.matrixCrossClick, matrixCrosscount, 3)   #W1E2=3
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixCross[matrixCrosscount], False, False, 0)

        matrixCrosscount = matrixCrosscount+1
        self.matrixCross.append(gtk.Button())
        self.matrixCross[matrixCrosscount].set_size_request(75, 28)
        self.matrixCross[matrixCrosscount].connect("clicked", self.matrixCrossClick, matrixCrosscount, 14)  #W2E2=14
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixCross[matrixCrosscount], False, False, 0)




        #*** W1
        matrixHBoxcount = matrixHBoxcount+1
        self.matrixHBox.append(gtk.HBox)
        self.matrixHBox[matrixHBoxcount] = gtk.HBox(True,0)
        table.attach(self.matrixHBox[matrixHBoxcount],
                     # X direction #          # Y direction
                     8,14,                     26,27,
                     gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                     0,                         0);

        matrixSolvecount = matrixSolvecount+1
        self.matrixSolve.append(gtk.Button())
        self.matrixSolve[matrixSolvecount] = gtk.Button('')
        self.matrixSolve[matrixSolvecount].set_size_request(90, 28)
        self.matrixSolve[matrixSolvecount].connect("clicked", self.matrixSolveClick, matrixSolvecount)
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixSolve[matrixSolvecount], False, False, 0)

        self.matrixLabel.append(gtk.Label())
        self.matrixLabel[14] = gtk.Label("W1")
        self.matrixLabel[14].set_size_request(25, 28)
        self.matrixLabel[14].modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.telColor[4]))
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLabel[14], False, False, 0)

        matrixLockcount = matrixLockcount+1
        self.matrixLock.append(gtk.Button())
        self.matrixLock[matrixLockcount] = gtk.ToggleButton('')
        self.matrixLock[matrixLockcount].set_size_request(75, 28)
        self.matrixLock[matrixLockcount].connect("clicked", self.matrixLockClick, matrixLockcount, 1)                         #S1W1=1
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLock[matrixLockcount], False, False, 0)

        matrixLockcount = matrixLockcount+1
        self.matrixLock.append(gtk.Button())
        self.matrixLock[matrixLockcount] = gtk.ToggleButton('')
        self.matrixLock[matrixLockcount].set_size_request(75, 28)
        self.matrixLock[matrixLockcount].connect("clicked", self.matrixLockClick, matrixLockcount, 0)                         #S2W1=0
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLock[matrixLockcount], False, False, 0)

        matrixLockcount = matrixLockcount+1
        self.matrixLock.append(gtk.Button())
        self.matrixLock[matrixLockcount] = gtk.ToggleButton('')
        self.matrixLock[matrixLockcount].set_size_request(75, 28)
        self.matrixLock[matrixLockcount].connect("clicked", self.matrixLockClick, matrixLockcount, 2)                         #E1W1=2
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLock[matrixLockcount], False, False, 0)

        matrixLockcount = matrixLockcount+1
        self.matrixLock.append(gtk.Button())
        self.matrixLock[matrixLockcount] = gtk.ToggleButton('')
        self.matrixLock[matrixLockcount].set_size_request(75, 28)
        self.matrixLock[matrixLockcount].connect("clicked", self.matrixLockClick, matrixLockcount, 3)                         #E2W1=3
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLock[matrixLockcount], False, False, 0)

        self.matrixLabel.append(gtk.Label())
        self.matrixLabel[15] = gtk.Label("-")
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLabel[15], False, False, 0)


        matrixCrosscount = matrixCrosscount+1
        self.matrixCross.append(gtk.Button())
        self.matrixCross[matrixCrosscount].set_size_request(75, 28)
        self.matrixCross[matrixCrosscount].connect("clicked", self.matrixCrossClick, matrixCrosscount, 4)   #W2W1=4
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixCross[matrixCrosscount], False, False, 0)




        #*** W2
        matrixHBoxcount = matrixHBoxcount+1
        self.matrixHBox.append(gtk.HBox)
        self.matrixHBox[matrixHBoxcount] = gtk.HBox(True,0)
        table.attach(self.matrixHBox[matrixHBoxcount],
                     # X direction #          # Y direction
                     8,14,                     27,28,
                     gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                     0,                         0);

        matrixSolvecount = matrixSolvecount+1
        self.matrixSolve.append(gtk.Button())
        self.matrixSolve[matrixSolvecount] = gtk.Button('')
        self.matrixSolve[matrixSolvecount].set_size_request(90, 28)
        self.matrixSolve[matrixSolvecount].connect("clicked", self.matrixSolveClick, matrixSolvecount)
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixSolve[matrixSolvecount], False, False, 0)

        self.matrixLabel.append(gtk.Label())
        self.matrixLabel[16] = gtk.Label("W2")
        self.matrixLabel[16].set_size_request(25, 28)
        self.matrixLabel[16].modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.telColor[5]))
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLabel[16], False, False, 0)

        matrixLockcount = matrixLockcount+1
        self.matrixLock.append(gtk.Button())
        self.matrixLock[matrixLockcount] = gtk.ToggleButton('')
        self.matrixLock[matrixLockcount].set_size_request(75, 28)
        self.matrixLock[matrixLockcount].connect("clicked", self.matrixLockClick, matrixLockcount, 11)                        #S1W2=11
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLock[matrixLockcount], False, False, 0)

        matrixLockcount = matrixLockcount+1
        self.matrixLock.append(gtk.Button())
        self.matrixLock[matrixLockcount] = gtk.ToggleButton('')
        self.matrixLock[matrixLockcount].set_size_request(75, 28)
        self.matrixLock[matrixLockcount].connect("clicked", self.matrixLockClick, matrixLockcount, 8)                         #S2W2=8
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLock[matrixLockcount], False, False, 0)

        matrixLockcount = matrixLockcount+1
        self.matrixLock.append(gtk.Button())
        self.matrixLock[matrixLockcount] = gtk.ToggleButton('')
        self.matrixLock[matrixLockcount].set_size_request(75, 28)
        self.matrixLock[matrixLockcount].connect("clicked", self.matrixLockClick, matrixLockcount, 13)                        #E1W2=13
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLock[matrixLockcount], False, False, 0)

        matrixLockcount = matrixLockcount+1
        self.matrixLock.append(gtk.Button())
        self.matrixLock[matrixLockcount] = gtk.ToggleButton('')
        self.matrixLock[matrixLockcount].set_size_request(75, 28)
        self.matrixLock[matrixLockcount].connect("clicked", self.matrixLockClick, matrixLockcount, 14)                        #E2W2=14
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLock[matrixLockcount], False, False, 0)
        
        matrixLockcount = matrixLockcount+1
        self.matrixLock.append(gtk.Button())
        self.matrixLock[matrixLockcount] = gtk.ToggleButton('')
        self.matrixLock[matrixLockcount].set_size_request(75, 28)
        self.matrixLock[matrixLockcount].connect("clicked", self.matrixLockClick, matrixLockcount, 4)                         #W1W2=4
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLock[matrixLockcount], False, False, 0)

        self.matrixLabel.append(gtk.Label())
        self.matrixLabel[17] = gtk.Label("-")
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLabel[17], False, False, 0)



        button = gtk.Button('QUERY TIPTILT')
        button.set_size_request(4*scale, 3*scale)
        button.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("yellow"))
        button.modify_bg(gtk.STATE_PRELIGHT, gtk.gdk.color_parse("orange"))
        button.connect('clicked', self.updateTiptilt)
        table.attach(button,
                    # X direction #          # Y direction
                    0, 2,                      self.nDelayLines*4+1, self.nDelayLines*4+2,
                    gtk.EXPAND | gtk.FILL,     0,
                    0,                         0);

        button = gtk.Button('GET OFFSETS')
        button.set_size_request(4*scale, 3*scale)
        button.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("yellow"))
        button.modify_bg(gtk.STATE_PRELIGHT, gtk.gdk.color_parse("orange"))
        button.connect('clicked', self.getOffsets)
        table.attach(button,
                    # X direction #          # Y direction
                    2, 4,                      self.nDelayLines*4+1, self.nDelayLines*4+2,
                    gtk.EXPAND | gtk.FILL,     0,
                    0,                         0);

        frame = gtk.Frame('SLEEP TIME')
        sleepEntry= gtk.Entry()
        sleepEntry.set_size_request(4*scale, 2*scale)
        frame.add(sleepEntry)
        sleepEntry.connect("activate", self.enterTime)
        sleepEntry.set_text('0.1')
        self.sleepTime = 0.1
        table.attach(frame,
                    # X direction #          # Y direction
                    4, 6,                      self.nDelayLines*4+1, self.nDelayLines*4+2,
                    gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                    0,                         0);

        c = [[1, 2],[1, 3],[1, 4],[1, 5],[1, 6],[2, 3],[2, 4],[2, 5],[2, 6],[3, 4],[3, 5],[3, 6],[4, 5],[4, 6],[5, 6]]
        for k in range(self.nBaselines):
            self.baselineLabel1.append(gtk.Label())
            txt = self.beamOrderDict[str(c[k][0])]
            self.baselineLabel1[k].set_markup('<b>%s</b>' %txt)            
            self.baselineLabel1[k].modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.colorDict[self.beamOrderDict[str(c[k][0])]]))
            table.attach(self.baselineLabel1[k],
                        # X direction #          # Y direction
                        7, 8,                     2+k, 3+k,
                        gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);
            self.baselineLabel2.append(gtk.Label())
            txt = self.beamOrderDict[str(c[k][1])]
            self.baselineLabel2[k].set_markup('<b>%s</b>' %txt)            
            self.baselineLabel2[k].modify_fg(gtk.STATE_NORMAL, \
                                        gtk.gdk.color_parse(self.colorDict[self.beamOrderDict[str(c[k][1])]]))
            table.attach(self.baselineLabel2[k],
                        # X direction #          # Y direction
                        8, 9,                     2+k, 3+k,
                        gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);

            self.opdEntry.append(gtk.Entry())
            self.opdEntry[k].set_size_request(4*scale, 2*scale)
            table.attach(self.opdEntry[k],
                        # X direction #          # Y direction
                        9, 10,                      2+k, 3+k,
                        gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);
            
            self.weightEntry.append(gtk.Entry())
            self.weightEntry[k].set_size_request(4*scale, 2*scale)
            table.attach(self.weightEntry[k],
                        # X direction #          # Y direction
                        10, 11,                      2+k, 3+k,
                        gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);
            self.thresholdEntry.append(gtk.Entry())
            self.thresholdEntry[k].set_size_request(4*scale, 2*scale)
            self.thresholdEntry[k].set_text(str(self.threshold[k]))
            self.thresholdEntry[k].connect("activate", self.enterThreshold, k)
            table.attach(self.thresholdEntry[k],
                        # X direction #          # Y direction
                        11, 12,                     2+k, 3+k,
                        gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);
            self.thresholdCalc.append(gtk.Button('CALC THRESH'))
            self.thresholdCalc[k].set_size_request(6*scale, 4*scale)
            self.thresholdCalc[k].connect("clicked", self.autoThreshCalc, k)
            table.attach(self.thresholdCalc[k],
                        # X direction #          # Y direction
                        12, 13,                     2+k, 3+k,
                        gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);
            self.lockFringes.append(gtk.CheckButton())
            self.lockFringes[k].set_size_request(0*scale, 2*scale)
            self.lockFringes[k].connect("toggled", self.setLockFringes, k)
            print k, self.beamOrderDict[str(c[k][0])], self.beamOrderDict[str(c[k][1])]
            table.attach(self.lockFringes[k],
                        # X direction #          # Y direction
                        13, 14,                   2+k, 3+k,
                        gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);

        button = gtk.Button('GET FRINGE INFO')
        button.connect('clicked', self.getFringeInfo)
        table.attach(button,
            # X direction #          # Y direction
            9, 10,                      18, 19,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);

        button = gtk.ToggleButton('START LOOP')
        button.connect('clicked', self.startGDTLoop)
        button.modify_bg(gtk.STATE_ACTIVE, gtk.gdk.color_parse("orange"))
        button.modify_bg(gtk.STATE_PRELIGHT, gtk.gdk.color_parse("yellow"))
        table.attach(button,
            # X direction #          # Y direction
            10, 11,                     18, 19,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);

        button = gtk.ToggleButton('LOCK FRINGES')
        button.connect('toggled', self.lockFringesToggled)
        table.attach(button,
            # X direction #          # Y direction
            9, 10,                    19, 20,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);
        button.modify_bg(gtk.STATE_ACTIVE, gtk.gdk.color_parse("orange"))
        button.modify_bg(gtk.STATE_PRELIGHT, gtk.gdk.color_parse("yellow"))
        
        button = gtk.Button('SEND GDT INFO')
        button.connect('clicked', self.sendGdtInfo)
        table.attach(button,
            # X direction #          # Y direction
            10, 11,                    19, 20,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);

        #SK: make buttons for threshold
        button = gtk.Button('CALC ALL')
        #button.set_size_request(6*scale, 4*scale)
        button.connect('clicked', self.autoThreshCalcAll)
        table.attach(button,
            # X direction #          # Y direction
            12, 13,                     18, 19,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);

        button = gtk.Button('UPDATE THRESH')
        #button.set_size_request(6*scale, 4*scale)
        button.connect('clicked', self.autoThreshUpdate)
        table.attach(button,
            # X direction #          # Y direction
            12, 13,                     19, 20,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);

        frame = gtk.Frame('SEARCH THRESH. FACTOR')
        autoThreshFactorEntry = gtk.Entry()
        autoThreshFactorEntry.set_size_request(scale, 2*scale)
        frame.add(autoThreshFactorEntry)
        autoThreshFactorEntry.connect("activate", self.autoThreshFactor)
        autoThreshFactorEntry.set_text('3')
        table.attach(frame,
                    # X direction #          # Y direction
                    11, 12,                    18, 19,
                    gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                    0,                         0);


        button = gtk.Button('CLOSE')
        button.set_size_request(4*scale, 3*scale)
        button.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("yellow"))
        button.modify_bg(gtk.STATE_PRELIGHT, gtk.gdk.color_parse("orange"))
        button.connect('clicked', lambda button, w=self: w.destroy())
        table.attach(button,
            # X direction #          # Y direction
            0, 2,                      self.nDelayLines*4+2, self.nDelayLines*4+3,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);
        
        button.set_flags(gtk.CAN_DEFAULT)
        button.grab_default()

        self.show_all()

    def matrixLockClick(self, widget, ndx, baseline):
        print "Lock baseline #", baseline
        k = 0
        for i in range(6):
            for j in range(i+1, 6):
                try:
                    telcombo = self.beamOrderDict[self.beamInUse[i]]+self.beamOrderDict[self.beamInUse[j]]
                    loc = self.baselines.index(telcombo)
                except:
                    telcombo = self.beamOrderDict[self.beamInUse[j]]+self.beamOrderDict[self.beamInUse[i]]
                    loc = self.baselines.index(telcombo)
                common.gdtInfo[k+1]= self.lockFringes[loc].get_active()
                k += 1
                self.lockFringes[loc].set_active(self.matrixLock[self.matrixNrLock2[loc]].get_active())
        self.ircc.sendGdtInfo()   #SK: ACTIVATE

    def matrixCrossClick(self, widget, ndx, baseline):
        self.matrixCross[ndx].set_label('')
        if (ndx == 0):
            x=1
            y=0
        if (ndx == 1):
            x=2
            y=0
        if (ndx == 2):
            x=3
            y=0
        if (ndx == 3):
            x=4
            y=0
        if (ndx == 4):
            x=5
            y=0
            
        if (ndx == 5):
            x=2
            y=1
        if (ndx == 6):
            x=3
            y=1
        if (ndx == 7):
            x=4
            y=1
        if (ndx == 8):
            x=5
            y=1
            
        if (ndx == 9):
            x=3
            y=2
        if (ndx == 10):
            x=4
            y=2
        if (ndx == 11):
            x=5
            y=2
            
        if (ndx == 12):
            x=4
            y=3
        if (ndx == 13):
            x=5
            y=3
            
        if (ndx == 14):
            x=5
            y=4
            
        common.matrixFringe[x][y] = -999.
        common.matrixFringe[y][x] = -999.

    def matrixSolveClick(self, widget, ndx):
        self.loopPlusButton[ndx].set_active(False)
        self.loopMinusButton[ndx].set_active(False)
        print "Move to fringe prediction: ", common.matrixGuessFinal[ndx]
        self.posiEntry[ndx].set_text("%1.3f" %(common.matrixGuessFinal[ndx]))
        self.setManualOffset(self.posiEntry[ndx], ndx)

    def matrixClearClick(self, widget):
        for ndx in range(15):
            self.matrixCrossClick(widget, ndx, 0)

    def getpositel1(self, ndx):
        if (ndx == 0):  #W1S2
            positel1 = 4
            positel2 = 1
        if (ndx == 1):  #W1S1
            positel1 = 4
            positel2 = 0
        if (ndx == 2):  #W1E1
            positel1 = 4
            positel2 = 2
        if (ndx == 3):  #W1E2
            positel1 = 4
            positel2 = 3
        if (ndx == 4):  #W1W2
            positel1 = 4
            positel2 = 5
        if (ndx == 5):  #S2S1
            positel1 = 1
            positel2 = 0
        if (ndx == 6):  #S2E1
            positel1 = 1
            positel2 = 2
        if (ndx == 7):  #S2E2
            positel1 = 1
            positel2 = 3
        if (ndx == 8):  #S2W2
            positel1 = 1
            positel2 = 5
        if (ndx == 9):  #S1E1
            positel1 = 0
            positel2 = 2
        if (ndx == 10):  #S1E2
            positel1 = 0
            positel2 = 3
        if (ndx == 11):  #S1W2
            positel1 = 0
            positel2 = 5
        if (ndx == 12):  #E1E2
            positel1 = 2
            positel2 = 3
        if (ndx == 13):  #E1W2
            positel1 = 2
            positel2 = 5
        if (ndx == 14):  #E2W2
            positel1 = 3
            positel2 = 5
        return positel1
        

    def getpositel2(self, ndx):
        if (ndx == 0):  #W1S2
            positel1 = 4
            positel2 = 1
        if (ndx == 1):  #W1S1
            positel1 = 4
            positel2 = 0
        if (ndx == 2):  #W1E1
            positel1 = 4
            positel2 = 2
        if (ndx == 3):  #W1E2
            positel1 = 4
            positel2 = 3
        if (ndx == 4):  #W1W2
            positel1 = 4
            positel2 = 5
        if (ndx == 5):  #S2S1
            positel1 = 1
            positel2 = 0
        if (ndx == 6):  #S2E1
            positel1 = 1
            positel2 = 2
        if (ndx == 7):  #S2E2
            positel1 = 1
            positel2 = 3
        if (ndx == 8):  #S2W2
            positel1 = 1
            positel2 = 5
        if (ndx == 9):  #S1E1
            positel1 = 0
            positel2 = 2
        if (ndx == 10):  #S1E2
            positel1 = 0
            positel2 = 3
        if (ndx == 11):  #S1W2
            positel1 = 0
            positel2 = 5
        if (ndx == 12):  #E1E2
            positel1 = 2
            positel2 = 3
        if (ndx == 13):  #E1W2
            positel1 = 2
            positel2 = 5
        if (ndx == 14):  #E2W2
            positel1 = 3
            positel2 = 5
        return positel2


    def setManualOffset(self, widget, ndx):
        manualOffset = float(widget.get_text())
        print manualOffset
        self.Absolute[ndx] = common.delayLinesOffsets[ndx]*1000.
        self.Relative[ndx] = manualOffset-self.Absolute[ndx]
        self.posiEntry[ndx].set_text("%10.3f" %(manualOffset))
        self.moveRelative()
        try:
            self.ircc.getFringeInfo()
        except:
            pass
        
        
    def move_cb(self, widget, status, ndx):
        print "status = ", status
        coeff = 10
        self.ircc.getDelayLinesOffsets()
        self.Absolute[ndx] = common.delayLinesOffsets[ndx]*1000.
        self.Relative[ndx] = 0.

        if (status == "fastLeft"):
                self.Relative[ndx] -= coeff*self.steps[ndx]
                self.posiEntry[ndx].set_text("%10.3f" %(self.Relative[ndx]+self.Absolute[ndx]))
                self.moveRelative()
        elif (status == "left"):
                self.Relative[ndx] -= self.steps[ndx]
                self.posiEntry[ndx].set_text("%10.3f" %(self.Relative[ndx]+self.Absolute[ndx]))
                self.moveRelative()
        elif (status == "zero"):
                self.Relative[ndx] = -self.Absolute[ndx]
                self.posiEntry[ndx].set_text("%10.3f" %(self.Relative[ndx]+self.Absolute[ndx]))
                self.moveRelative()
        elif (status == "right"):
                self.Relative[ndx] += self.steps[ndx]
                self.posiEntry[ndx].set_text("%10.3f" %(self.Relative[ndx]+self.Absolute[ndx]))
                self.moveRelative()
        elif (status == "fastRight"):
                self.Relative[ndx] += coeff*self.steps[ndx]
                self.posiEntry[ndx].set_text("%10.3f" %(self.Relative[ndx]+self.Absolute[ndx]))
                self.moveRelative()
	print "move_cb: getFringeInfo"
        self.getFringeInfo()

    def moveRelative(self):
        common.updatedOffsets = self.Relative.copy()*0.001
        self.Relative = 0.*self.Relative
        self.ircc.sendUpdatedOffsets()

    def sendToOple(self, widget):
        self.ircc.sendToOple()

    def getOffsets(self, widget):
        self.ircc.getDelayLinesOffsets()
        for ndx in range(self.nDelayLines):
            self.Absolute[ndx] = common.delayLinesOffsets[ndx]*1000.
            self.posiEntry[ndx].set_text("%10.3f" %(self.Absolute[ndx]))
        
    def checkThreshButton(self, widget, ndx):
        self.checkThreshold[ndx] = widget.get_active()
        print self.checkThreshold
            
    def setActiveTel(self, widget, ndx):
        self.activeTel[ndx] = widget.get_active()
        common.activeTel = self.activeTel
        self.beamInUse = []
        for i in range(self.nDelayLines):
            if self.activeTel[i] == True:
                self.beamInUse.append(self.beamOrder[i])
                
        for i in range(6):
            if (self.activeTel[i] == True):
                self.matrixHBox[i+1].show()
                self.matrixSolve[i].show()
                self.matrixLabel[i].show()
                self.matrixLabel[6+2*i].show()
                self.matrixLabel[6+2*i+1].show()
            else:
                self.matrixHBox[i+1].hide()
                self.matrixSolve[i].hide()
                self.matrixLabel[i].hide()
                self.matrixLabel[6+2*i].hide()
                self.matrixLabel[6+2*i+1].hide()
                
        for i in range(self.nBaselines):
            Nr = self.getpositel1(self.matrixNrLock[i])
            Nr2 = self.getpositel2(self.matrixNrLock[i])
            if (self.activeTel[Nr] == True) and (self.activeTel[Nr2] == True):
                self.matrixLock[i].show()
            else:
                self.matrixLock[i].hide()

            Nr = self.getpositel1(self.matrixNrCross[i])
            Nr2 = self.getpositel2(self.matrixNrCross[i])
            if (self.activeTel[Nr] == True) and (self.activeTel[Nr2] == True):
                self.matrixCross[i].show()
            else:
                self.matrixCross[i].hide()
                
        self.beamInUse.sort()
        self.findActiveLocs()
            
    def setRefTel(self, widget, ndx):
        self.refTel[ndx] = widget.get_active()

        #color the reference cart buttons
        refTelNr = 0
        if (self.refTel[0] == True): refTelNr = 0
        if (self.refTel[1] == True): refTelNr = 1
        if (self.refTel[2] == True): refTelNr = 2
        if (self.refTel[3] == True): refTelNr = 3
        if (self.refTel[4] == True): refTelNr = 4
        if (self.refTel[5] == True): refTelNr = 5
        for i in range(self.nBaselines):
            if (self.getpositel1(self.matrixNrCross[i]) == refTelNr) or (self.getpositel2(self.matrixNrCross[i]) == refTelNr):
                self.matrixCross[i].modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("darkgrey"))
                self.matrixCross[i].modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("darkgrey"))
            else:
                self.matrixCross[i].modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse('#D3D3D3'))
                self.matrixCross[i].modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse('#D3D3D3'))

            
    def enterTime(self, widget):
        self.sleepTime = float(widget.get_text())
        print "New sleep time: ", self.sleepTime
        
    def enter_callback(self, widget, ndx):
        entry_text = self.entrySteps[ndx].get_text()
        self.steps[ndx] = float(entry_text)
        print "New step size: ", self.steps[ndx]

    def enterThreshold(self, widget, ndx):
        entry_text = widget.get_text()
        self.threshold[ndx] = float(entry_text)
        print "New threshold: ", self.threshold[ndx]

        #SK: send all thresholds
        for n in range(15):
            common.autoThresh[n] = float(self.threshold[n])
        self.ircc.sendautoThresh()


    def findActiveLocs(self):
        k = 0
        activeLocs = na.zeros(self.nBaselines)
        ntels = self.baselineBeam[len(common.opds)]
        ntels = len(self.beamInUse)
        print "ntels = ", ntels
        for i in range(ntels):
            for j in range(i+1, ntels):
                try:
                    wght = self.beamOrderDict[self.beamInUse[i]]+self.beamOrderDict[self.beamInUse[j]]
                    loc = self.baselines.index(wght)
                except:
                    wght = self.beamOrderDict[self.beamInUse[j]]+self.beamOrderDict[self.beamInUse[i]]
                    loc = self.baselines.index(wght)
##                 print self.beamOrderDict, k, loc, wght, self.beamInUse
                activeLocs[k] = loc        
                k+=1
        print activeLocs
        print activeLocs[:ntels*(ntels-1)/2]
        for i in range(self.nBaselines):
            if i in activeLocs[:ntels*(ntels-1)/2]:
                #print "must show line", i
                self.baselineLabel1[i].show()
                self.baselineLabel2[i].show()
                self.weightEntry[i].show()
                self.opdEntry[i].show()
                self.thresholdEntry[i].show()
                self.lockFringes[i].show()
                self.thresholdCalc[i].show()
            else:
                #print "must delete line", i
                self.baselineLabel1[i].hide()
                self.baselineLabel2[i].hide()
                self.weightEntry[i].hide()
                self.opdEntry[i].hide()
                self.thresholdEntry[i].hide()
                self.lockFringes[i].hide()
                self.thresholdCalc[i].hide()
            
        
        #print "activeLocs = ", activeLocs

    def startLoop(self, widget, sign, ndx):
        loopStatus = widget.get_active()
        if self.loopDLFlag[ndx]:
            if self.loopSign[ndx]!= sign:
                if widget == self.loopPlusButton[ndx]:
                    print "plus"
                    self.loopMinusButton[ndx].set_active(False)
                elif widget == self.loopMinusButton[ndx]:
                    print "minus"
                    self.loopPlusButton[ndx].set_active(False)
                else:
                    print "Does not work!"
        self.loopDLFlag[ndx] = widget.get_active()
        self.loopSign[ndx] = sign
        if self.loopDLFlag.count(True) > 0:
            if self.loopDLTag == -1:
                self.updateDLTag = gobject.idle_add(self.loopDelayLine)
#                self.updateDLTag = Process(target=self.loopDelayLine)
#                self.updateDLTag = Thread(target=self.loopDelayLine)
#                self.updateDLTag.start()
                self.loopDLTag = 1
        else:
            gobject.source_remove(self.updateDLTag)
#            print "DLTag terminated"
#            self.updateDLTag.terminate()
            self.loopDLTag = -1
    

            """
    def loopDelayLineMove(self,widget=None):
        for ndx in range(self.nDelayLines):
            if self.loopDLFlag[ndx] == True:
                self.Absolute[ndx] = common.delayLinesOffsets[ndx]*1000.
                self.Relative[ndx] = 0.
                if self.loopSign[ndx] == 'minus':
                    self.Relative[ndx] -= self.steps[ndx]
                    self.posiEntry[ndx].set_text("%10.3f" %(self.Relative[ndx]+self.Absolute[ndx]))
                    print self.Relative[ndx],self.Absolute[ndx]
                    self.moveRelative()
                elif self.loopSign[ndx] == 'plus':
                   self.Relative[ndx] += self.steps[ndx]
                    self.posiEntry[ndx].set_text("%10.3f" %(self.Relative[ndx]+self.Absolute[ndx]))
                    print self.Relative[ndx],self.Absolute[ndx]
                    self.moveRelative()
            """
            """
    def loopDelayLine(self):
        print "inside loop delay"
        self.ircc.getDelayLinesOffsets()
        while(True):
            #self.loopDelayLineMove(None)
        #for all the delay lines, check if a loop+ or lopp- is running
            for ndx in range(self.nDelayLines):
                if self.loopDLFlag[ndx] == True:
                    print "moving delay line"
                    self.Absolute[ndx] = common.delayLinesOffsets[ndx]*1000.
                    self.Relative[ndx] = 0.
                    if self.loopSign[ndx] == 'minus':
                        print "minus"
                        self.Relative[ndx] -= self.steps[ndx]
                        self.posiEntry[ndx].set_text("%10.3f" %(self.Relative[ndx]+self.Absolute[ndx]))
                        self.moveRelative()
                    elif self.loopSign[ndx] == 'plus':
                        print "plus"
                        self.Relative[ndx] += self.steps[ndx]
                        self.posiEntry[ndx].set_text("%10.3f" %(self.Relative[ndx]+self.Absolute[ndx]))
                        self.moveRelative()
                #0.2 seconds to move one delay line  
                #another 0.2 seconds to get Fringe info
	    print "new1: loopDelayLine: getFringeInfo"
            self.getFringeInfo(None)

            for ndx in range(self.nDelayLines):
                if self.loopDLFlag[ndx] == True:
                    k=0
                    ntels = len(self.beamInUse)
                #for all the baselines where ndx is check if fringes are detected 
                # this part is very fast, the time consumed can be ignored
                    for i in range(ntels):
                        beamInUse_i = self.beamInUse[i]
                        for j in range(i+1, ntels):
                            beamInUse_j = self.beamInUse[j]
                       # if one of the beam corresponds to delay line ndx, then check for fringes
                            if ((beamInUse_i == self.beamOrder[ndx]) or (beamInUse_j == self.beamOrder[ndx])):
                                try:
                                    telcombo = self.beamOrderDict[beamInUse_i]+self.beamOrderDict[beamInUse_j]
                                    loc = self.baselines.index(telcombo)
                                except:
                                    telcombo = self.beamOrderDict[beamInUse_j]+self.beamOrderDict[beamInUse_i]
                                    loc = self.baselines.index(telcombo)
                            #check if there are fringes for any baseline with delay line ndx
                                if (common.weights[k] >= (self.threshold[loc]*self.thresholdfactor)):
                                #if there are fringes and the threshold is True then stop the loop for DL ndx12
                                    if self.checkThreshold[ndx] == True:
                                        self.loopPlusButton[ndx].set_active(False)
                                        self.loopMinusButton[ndx].set_active(False)
                                        self.loopDLFlag[ndx] = False
                            k+=1
            if (self.loopDLFlag.count(True) > 0) :
                time.sleep(self.sleepTime)
		print "sleep2"
	    # JDM.. rather than sleep, this might be better as a counter of some kind so that the gui doesn't freeze up entry
        return True
        """

        """
    def loopDelayLine(self):
#        pdb.set_trace()
#        print "inside loop delay"
        self.ircc.getDelayLinesOffsets()
        #for all the delay lines, check if a loop+ or lopp- is running
        for ndx in range(self.nDelayLines):
#            print "moving delay line"
            if self.loopDLFlag[ndx] == True:
                #if looping then moves the delay line
                self.Absolute[ndx] = common.delayLinesOffsets[ndx]*1000.
                self.Relative[ndx] = 0.
                if self.loopSign[ndx] == 'minus':
                    self.Relative[ndx] -= self.steps[ndx]
                    self.posiEntry[ndx].set_text("%10.3f" %(self.Relative[ndx]+self.Absolute[ndx]))
                    self.moveRelative()
                elif self.loopSign[ndx] == 'plus':
                    self.Relative[ndx] += self.steps[ndx]
                    self.posiEntry[ndx].set_text("%10.3f" %(self.Relative[ndx]+self.Absolute[ndx]))
                    self.moveRelative()
                #0.2 seconds to move one delay line  
        #another 0.2 seconds to get Fringe info
	print "new2: loopDelayLine: getFringeInfo"
        self.getFringeInfo(None)

        for ndx in range(self.nDelayLines):
            if self.loopDLFlag[ndx] == True:
                k=0
                ntels = len(self.beamInUse)
                #for all the baselines where ndx is check if fringes are detected 
                # this part is very fast, the time consumed can be ignored
                for i in range(ntels):
                    beamInUse_i = self.beamInUse[i]
                    for j in range(i+1, ntels):
                        beamInUse_j = self.beamInUse[j]
                        # if one of the beam corresponds to delay line ndx, then check for fringes
                        if ((beamInUse_i == self.beamOrder[ndx]) or (beamInUse_j == self.beamOrder[ndx])):
                            try:
                                telcombo = self.beamOrderDict[beamInUse_i]+self.beamOrderDict[beamInUse_j]
                                loc = self.baselines.index(telcombo)
                            except:
                                telcombo = self.beamOrderDict[beamInUse_j]+self.beamOrderDict[beamInUse_i]
                                loc = self.baselines.index(telcombo)
                            #check if there are fringes for any baseline with delay line ndx
                            if (common.weights[k] >= (self.threshold[loc]*self.thresholdfactor)):
                                #if there are fringes and the threshold is True then stop the loop for DL ndx12
                               if self.checkThreshold[ndx] == True:
                                    self.loopPlusButton[ndx].set_active(False)
                                    self.loopMinusButton[ndx].set_active(False)
                                    self.loopDLFlag[ndx] = False
                        k+=1
        if (self.loopDLFlag.count(True) > 0) :
            time.sleep(self.sleepTime)
	    print "sleep3"
	    ## JDM: instead of sleep this maybe should be som ekind of counter so that we don't end up freezing gui entry
            return True
    """
    
#this is the original version of loopDelayLine
    def loopDelayLine(self):
        self.ircc.getDelayLinesOffsets()
        #for all the delay lines, check if a loop+ or lopp- is running
        for ndx in range(self.nDelayLines):
            if self.loopDLFlag[ndx] == True:
                #if looping then moves the delay line
                self.Absolute[ndx] = common.delayLinesOffsets[ndx]*1000.
                self.Relative[ndx] = 0.
                if self.loopSign[ndx] == 'minus':
                    self.Relative[ndx] -= self.steps[ndx]
                    self.posiEntry[ndx].set_text("%10.3f" %(self.Relative[ndx]+self.Absolute[ndx]))
                    self.moveRelative()
                elif self.loopSign[ndx] == 'plus':
                    self.Relative[ndx] += self.steps[ndx]
                    self.posiEntry[ndx].set_text("%10.3f" %(self.Relative[ndx]+self.Absolute[ndx]))
                    self.moveRelative()
                #0.2 seconds to move one delay line
                #another 0.2 seconds to get Fringe info
		print "original loopDelayLine: getFringeInfo"
		# JDM. assume that we only need to check once per cycle.
                #self.getFringeInfo(None)        
                
                k = 0
                ntels = len(self.beamInUse)
            
                #for all the baselines where ndx is check if fringes are detected
                # this part is very fast, the time consumed can be ignored
                for i in range(ntels):
                    beamInUse_i = self.beamInUse[i]
                    for j in range(i+1, ntels):
                        beamInUse_j = self.beamInUse[j]
                        # if one of the beam corresponds to delay line ndx, then check for fringes
                        if ((beamInUse_i == self.beamOrder[ndx]) or (beamInUse_j == self.beamOrder[ndx])):
                            try:
                                telcombo = self.beamOrderDict[beamInUse_i]+self.beamOrderDict[beamInUse_j]
                                loc = self.baselines.index(telcombo)
                            except:
                                telcombo = self.beamOrderDict[beamInUse_j]+self.beamOrderDict[beamInUse_i]
                                loc = self.baselines.index(telcombo)
                            #check if there are fringes for any baseline with delay line ndx
                            if (common.weights[k] >= (self.threshold[loc]*self.thresholdfactor)):
                                #if there are fringes and the threshold is True then stop the loop for DL ndx12    
                                if self.checkThreshold[ndx] == True:
                                    self.loopPlusButton[ndx].set_active(False)
                                    self.loopMinusButton[ndx].set_active(False)
                                    self.loopDLFlag[ndx] = False
                        k+=1

        if (self.loopDLFlag.count(True) > 0) :
            time.sleep(self.sleepTime)
	    print "sleep4"
	    ## JDM this sleepo maybe should be a counter check rather than freezing gui
            return True
    
	
    def getFringeInfo(self, widget = None):
#        self.posiEntry[0].set_text("%10.3f" %(self.Relative[0]+self.Absolute[0]))
#        print "inside getfrigeinfo:",self.Relative[0]+self.Absolute[0]
# JDM thie next two things are the slowest things.
	print "one"
        self.ircc.getFringeInfo()
        self.getOffsets(self)   #refresh offset positions
	print "two"
        for k in range(6):
            self.fringeDetected[k].remove(self.fringeDetected[k].child)
            image = fringeIcons.makeIcon('grey')
            image.show()
            self.fringeDetected[k].add(image)
        #print "three" 
        for k in range(self.nBaselines):
            self.opdEntry[k].set_text('')
            self.weightEntry[k].set_text('')
            self.weightEntry[k].modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("grey"))
        k = 0
        ntels = self.baselineBeam[len(common.opds)]
        ntels = len(self.beamInUse)
	#print "four"
        if ntels < 2:
            print "can't make fringes with only one telescope (now, don't say 'Masking' or 'Speckle'...)"
        else:
            for i in range(ntels):
                for j in range(i+1, ntels):
			#print "a"
                        try:
                            telcombo = self.beamOrderDict[self.beamInUse[i]]+self.beamOrderDict[self.beamInUse[j]]
                            loc = self.baselines.index(telcombo)
                        except:
                            telcombo = self.beamOrderDict[self.beamInUse[j]]+self.beamOrderDict[self.beamInUse[i]]
                            print telcombo, self.beamInUse[j], self.beamInUse[i], i, j, loc
                            loc = self.baselines.index(telcombo)
                        #pdb.set_trace()
			#print "b"
                        self.opdEntry[loc].set_text("%i" %(int(common.opds[k])))          #10.3
                        self.weightEntry[loc].set_text("%i" %(int(common.weights[k])))    #10.3
			#print "c"
                        #SK:
                        refTelNr = 0
                        if (self.refTel[0] == True): refTelNr = 0
                        if (self.refTel[1] == True): refTelNr = 1
                        if (self.refTel[2] == True): refTelNr = 2
                        if (self.refTel[3] == True): refTelNr = 3
                        if (self.refTel[4] == True): refTelNr = 4
                        if (self.refTel[5] == True): refTelNr = 5
                        self.matrixLock[self.matrixNrLock2[loc]].set_label("%1.1f" %(common.weights[loc]/(self.threshold[loc]*self.thresholdfactor)))
                        self.matrixLock[self.matrixNrLock2[loc]].set_active(self.lockFringes[loc].get_active())
			#print "d"
                        if (common.weights[loc]/(self.threshold[loc]*self.thresholdfactor) >= 1.):
                            self.matrixLock[self.matrixNrLock2[loc]].modify_bg(gtk.STATE_ACTIVE, gtk.gdk.color_parse("green"))
                            self.matrixLock[self.matrixNrLock2[loc]].modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("yellow"))
                        if (common.weights[loc]/(self.threshold[loc]*self.thresholdfactor) < 1.):
                            self.matrixLock[self.matrixNrLock2[loc]].modify_bg(gtk.STATE_ACTIVE, gtk.gdk.color_parse("pink"))
                            if (self.getpositel1(loc) == refTelNr) or (self.getpositel2(loc) == refTelNr):
                                self.matrixLock[self.matrixNrLock2[loc]].modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse('darkgrey'))
                            else:
                                self.matrixLock[self.matrixNrLock2[loc]].modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse('#D3D3D3'))
			#print "e"
                        if (common.weights[loc]/(self.threshold[loc]*self.thresholdfactor) > 1.):
			    #print "e1"
			    # JDM I don't think we need to know this information .. at least not LIVE every time. I will move this requiest to top of for loops.
                            #self.getOffsets(self)   #refresh offset positions
                            posicross = (float(self.posiEntry[self.getpositel2(loc)].get_text()) - float(self.posiEntry[self.getpositel1(loc)].get_text()))
			    #print "e2"
                            self.matrixCross[self.matrixNrCross2[loc]].set_label("%1.3f" %(posicross))
                            #found cross-fringe
			    #print "e3"
                            if (refTelNr != self.getpositel1(loc)) and (refTelNr != self.getpositel2(loc)):
                                common.matrixFringe[self.getpositel1(loc)][self.getpositel2(loc)] = -posicross
                                common.matrixFringe[self.getpositel2(loc)][self.getpositel1(loc)] = posicross
                            #found real fringe
			    #print "e4"
                            if (self.getpositel1(loc) == refTelNr):
                                common.matrixFringe[self.getpositel2(loc)][self.getpositel2(loc)] = posicross
			    #print "e4"
                            if (self.getpositel2(loc) == refTelNr):
                                common.matrixFringe[self.getpositel1(loc)][self.getpositel1(loc)] = posicross
			#print "f"
                        if (common.weights[k] >= self.threshold[loc]*self.thresholdfactor):
                            flag = 1
                            self.weightEntry[loc].modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("red"))
                            tel = self.beamOrderDict[self.beamInUse[i]]
                            itel = self.telNames.index(tel)
                            image = fringeIcons.makeIcon(tel)
                            image.show()
                            self.fringeDetected[itel].remove(self.fringeDetected[itel].child)
                            self.fringeDetected[itel].add(image)
                            tel = self.beamOrderDict[self.beamInUse[j]]
                            itel = self.telNames.index(tel)
                            image = fringeIcons.makeIcon(tel)
                            image.show()
                            self.fringeDetected[itel].remove(self.fringeDetected[itel].child)
                            self.fringeDetected[itel].add(image)
                        else:
                            self.weightEntry[loc].modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse('#D3D3D3'))
                        k+=1
			#print "g"
                        #some values, which one might use for debugging:

                        #for x in range(6):
                        #    for y in range(6):
                        #        common.matrixFringe[x][y] = -999.

                        #common.matrixFringe[1][0] = -3.824
                        #common.matrixFringe[3][0] = 0.026
                        #common.matrixFringe[5][0] = 0.047
                        #common.matrixFringe[3][1] = -3.798
                        #common.matrixFringe[4][1] = 6.855
                        #common.matrixFringe[5][1] = -3.777
                        #common.matrixFringe[5][3] = 0.021

                        #common.matrixFringe[0][1] = -3.824
                        #common.matrixFringe[0][3] = 0.026
                        #common.matrixFringe[0][5] = 0.047
                        #common.matrixFringe[1][3] = -3.798
                        #common.matrixFringe[1][4] = 6.855
                        #common.matrixFringe[1][5] = -3.777
                        #common.matrixFringe[3][5] = 0.021

                        #common.matrixFringe[0][0] = 3.031
                        #common.matrixFringe[1][0] = 6.855
                        #common.matrixFringe[3][0] = 3.057
                        #common.matrixFringe[5][0] = 3.078


                        
                        #SK: check whether there is enough information to solve for the fringe position using the cross-fringes
                        #pirint "MATRIX:"
                        #for y in range(6):
                        #    print common.matrixFringe[0][y],common.matrixFringe[1][y],common.matrixFringe[2][y],common.matrixFringe[3][y],common.matrixFringe[4][y],common.matrixFringe[5][y]
				
                        for y in range(6):
       			    break; # JDM comment for testng speed: conclusion: not causing problem
			    common.matrixGuesscount[y] = 0
                            for x in range(6):
                                val1 = 0.
                                val2 = 0.
                                val3 = 0.
                                val4 = 0.
                                common.matrixGuess[y][x] = -999.
                                
                                if (common.matrixFringe[y][x] != -999.) and (x != y):
                                    val1 = common.matrixFringe[y][x]
                                    
                                    for y2 in range(6):
                                        if (y2 != x) and (y2 != y):
                                            if (common.matrixFringe[y2][x] != -999.):
                                                val2 = val1 - common.matrixFringe[y2][x]
                                                if (x == y2):
                                                    #found fringe relative to reference
                                                    common.matrixGuess[y][common.matrixGuesscount[y]] = val2
                                                    common.matrixGuesscount[y] += 1
                                                else:
                                                    #search in next level
                                                    for x2 in range(6):
                                                        if (x2 != x):
                                                            if (common.matrixFringe[y2][x2] != -999.):
                                                                val3 = val2 + common.matrixFringe[y2][x2]
                                                                if (x2 == y2):
                                                                    #found fringe relative to reference
                                                                    common.matrixGuess[y][common.matrixGuesscount[y]] = val3
                                                                    common.matrixGuesscount[y] += 1
                                                                else:
                                                                    #search in next level
                                                                    for y3 in range(6):
                                                                        if (y3 != y2):
                                                                            if (common.matrixFringe[y3][x2] != -999.):
                                                                                val4 = val3 - common.matrixFringe[y3][x2]
                                                                                
                                                                                if (y2 == y3):
                                                                                    #found fringe relative to reference
                                                                                    common.matrixGuess[y][common.matrixGuesscount[y]] = val4
                                                                                    common.matrixGuesscount[y] += 1
                                                                                else:
                                                                                    common.matrixGuess[y][common.matrixGuesscount[y]] = -999.

                            if (common.matrixGuesscount[y] == 0):
                                self.matrixSolve[y].set_label("")
                                for x in range(6):
                                    common.matrixGuess[y][x] = -999.
                            if (common.matrixGuesscount[y] > 0):
                                common.matrixGuessFinal[y] = 0.
                                count = 0.
                                for x in range(common.matrixGuesscount[y]):
                                    if (common.matrixGuess[y][x] != -999.):
                                        common.matrixGuessFinal[y] += common.matrixGuess[y][x]
                                        count += 1.
                                        if x == 0:
                                            text = "%1.2f" %(common.matrixGuess[y][x])
                                        if x > 0:
                                            text = text + "/%1.2f" %(common.matrixGuess[y][x])
                                common.matrixGuessFinal[y] /= count
                                print "Fringe prediction (baseline #", y, "): ", text
                                self.matrixSolve[y].set_label(text)
        #print "five"
                        

    def initSocket(self):
        self.sock = None
        for port in range(6):
            for res in socket.getaddrinfo(self.host, self.port+port, socket.AF_UNSPEC, socket.SOCK_STREAM):
                af, socktype, proto, canonname, sa = res
                try:
                    self.sock = socket.socket(af, socktype, proto)
                    self.sock.settimeout(self.sockTimeout)
                except socket.error, msg:
                    self.sock = None
                    continue
                try:
                    self.sock.connect(sa)
                    self.fd = self.sock.fileno()
                except socket.error, msg:
                    self.sock.close()
                    self.sock = None
                    continue
                break
            if self.sock is None:
                print 'could not open socket on port: ', self.port+port
            else:
                break
            
    def queryTiptilt(self):
        self.host = '192.168.3.26'  #tiptilt
        self.port = 2000
        self.initSocket()
        beamOrder = ['1', '2', '3', '4', '5', '6']
        if self.sock == None:
            print "socket frame failed to create"
            return None
        else:
            self.sock.settimeout(5)
            self.sock.send('status')
            length = 0
            l = 10
            data = ''
            while data.find('COMMAND_COMPLETE') == -1:
                message = self.sock.recv(100)
                l = len(message)
                length += l
                data += message
            self.sock.close()
            splitData = data.splitlines()
            tel = ['S1', 'S2', 'E1', 'E2', 'W1', 'W2']
            for t in range(6):
                for i in range(6):
                    if splitData[i+1].find(tel[t]) != -1:
                        beamOrder[t] = str(i+1)
                        #print str(i+1), beamOrder[t]
                        #print beamOrder
        return beamOrder
    
##     def queryTiptilt(self):
##         return None

    def refreshTiptiltInfo(self):
        self.beamInUse = []
        for i in range(self.nDelayLines):
            self.beam[i].set_text(self.beamOrder[i])
            if self.activeTel[i] == True:
                self.beamInUse.append(self.beamOrder[i])
            self.beamOrderDict[self.beamOrder[i]] = self.telNames[i]
        self.beamInUse.sort()
        #print self.beamOrderDict, self.beamInUse
        
    def updateTiptilt(self,widget):
        self.beamOrder = self.queryTiptilt()
        if self.beamOrder == None:
            self.beamOrder = ['1', '2', '3', '4', '5', '6']
        self.refreshTiptiltInfo()
            
    def setLockFringes(self, widget, ndx):
        #pdb.set_trace()
        print "common.gdtInfo = ", common.gdtInfo
        ntels = self.baselineBeam[len(common.opds)]
        k = 0
        for i in range(ntels):
            for j in range(i+1, ntels):
                try:
                    telcombo = self.beamOrderDict[self.beamInUse[i]]+self.beamOrderDict[self.beamInUse[j]]
                    loc = self.baselines.index(telcombo)
                except:
                    telcombo = self.beamOrderDict[self.beamInUse[j]]+self.beamOrderDict[self.beamInUse[i]]
                    loc = self.baselines.index(telcombo)
                common.gdtInfo[k+1]= self.lockFringes[loc].get_active()
                self.matrixLock[self.matrixNrLock2[loc]].set_active(self.lockFringes[loc].get_active())

        #0 W1 S2
        #1 W1 S1
        #2 W1 E1
        #3 W1 E2
        #4 W1 W2
        #5 S2 S1
        #6 S2 E1
        #7 S2 E2
        #8 S2 W2
        #9 S1 E1
        #10 S1 E2
        #11 S1 W2
        #12 E1 E2
        #13 E1 W2
        #14 E2 W2

                print "CLICK ", ndx, loc, self.matrixNrLock2[loc], self.matrixNrLock2[loc]
                k += 1
        print "common.gdtInfo = ", common.gdtInfo
        self.getFringeInfo()

 
    def lockFringesToggled(self,widget):
        common.gdtInfo[0] = widget.get_active()
        print "common.gdtInfo = ", common.gdtInfo

    def manualBeamSet(self, widget, i):
        self.beamOrder[i] = widget.get_text()
        self.refreshTiptiltInfo()
        
##     def checkButton(self, widget, data=None):
##         common.gdtInfo[self.baseKeyw.index(data)+1] = widget.get_active()
##         print "common.gdtInfo = ", common.gdtInfo
    
            
    def startGDTLoop(self, widget):
        if widget.get_active():
            #pdb.set_trace()
            self.updateGdtTag = gobject.idle_add(self.updateGdt)
	    print "starting loop"
            
        else:
            gobject.source_remove(self.updateGdtTag)       

    def sendGdtInfo(self, widget):
        self.ircc.sendGdtInfo()

    def autoThreshCalc(self, widget, ndx):
        print "CALL autoThreshCalc", ndx
        self.ircc.sendautoThreshCalc(ndx)

    def autoThreshUpdate(self, widget):
        print "CALL autoThreshUpdate"
        self.ircc.getautoThresh()
        for n in range(15):
            self.thresholdEntry[n].set_text("%i" %(int(common.thresh[n])))
            self.threshold[n] = common.thresh[n]

    def autoThreshCalcAll(self, widget):
        print "CALL autoThreshCalcAll"
        self.ircc.sendautoThreshCalcAll()

    def autoThreshFactor(self, widget):
        self.thresholdfactor = float(widget.get_text())
        print "CALL autoThreshFactor", self.thresholdfactor
  
    def updateGdt(self):
	print "updateGdt: getFringeInfo"
        self.getFringeInfo(None)
        time.sleep(self.sleepTime)
	print "sleep1"
	## JDM this sleep maybe should be a counter to avoid freezing gui
        return True
        
    
tokenDict = {"gdt2": gdtControl2}

def main(funct):
    functionToCall = tokenDict[funct]
    functionToCall()
    gtk.main()

if __name__ == '__main__':
    main()

    
## python -c "import childWindows as cw; cw.main('gdt')"
## python -c "import childWindows as cw; cw.main('delayLines')"
