#!/usr/bin/python2.3
'''Application main window

Demonstrates a typical application window, with menubar, toolbar, statusbar.'''
# pygtk version: Maik Hertha <maik.hertha@berlin.de>

import gobject
#from matplotlib.numerix import arange, sin, pi
from numpy import arange, sin, pi

import matplotlib 
matplotlib.use('GTK')

from matplotlib.backends.backend_gtk import FigureCanvasGTK as FigureCanvas
from matplotlib.backends.backend_gtk import NavigationToolbar2GTK as NavigationToolbar
from matplotlib.backends.backend_gtk import new_figure_manager
from matplotlib.axes import Subplot
from matplotlib.figure import Figure

import gtk
#import numarray as na
import numpy as na
from matplotlib.lines import Line2D
from matplotlib.patches import Rectangle

import time
import os
## import sys, os
## myenv = {}
## myenv.update(os.environ)
## sys.path.append(myenv['HOME']+'/mirc_python')
## sys.path.append(myenv['HOME']+'/mirc_python/FiberExplorer')

import common
import IRCamDisplay
import IRCamCommands
import childWindows
(
  COLOR_RED,
  COLOR_GREEN,
  COLOR_BLUE
) = range(3)

(
  SHAPE_SQUARE,
  SHAPE_RECTANGLE,
  SHAPE_OVAL,
) = range(3)

ui_info = \
'''<ui>
  <menubar name='MenuBar'>
    <menu action='FileMenu'>
      <menuitem action='Quit'/>
    </menu>
    <menu action='PreferencesMenu'>
      <menuitem action='mirkwood server'/>
      <menu action='ShapeMenu'>
        <menuitem action='Square'/>
        <menuitem action='Rectangle'/>
        <menuitem action='Oval'/>
      </menu>
      <menuitem action='Bold'/>
    </menu>
    <menu action='HelpMenu'>
      <menuitem action='About'/>
    </menu>
  </menubar>
  <toolbar  name='ToolBar'>
    <toolitem action='Quit'/>
    <separator/>
 <toolitem action='Reset BG'/>
     <separator/>
 <toolitem action='Take BG'/>
     <separator/>
    <toolitem action='Use BG'/>
     <separator/>
    <toolitem action='Start exposure'/>
     <separator/>
    <toolitem action='Stop exposure'/>
     <separator/>
    <toolitem action='Delay lines control'/>
     <separator/>
    <toolitem action='GDT control'/>
     <separator/>
 </toolbar>
</ui>'''

##     <toolitem action='shutterMatrix'/>
##      <separator/>
##     <toolitem action='fiberExplorer'/>
##      <separator/>


class ApplicationMainWindow(gtk.Window):
    def __init__(self, parent=None):
    	self.anim = IRCamDisplay.AnimatedImage()
        self.ircc = IRCamCommands.IRCamCommands()
        self.tag1 = -1
        self.tag2 = -1

        # Create the toplevel window
        gtk.Window.__init__(self)
        try:
            self.set_screen(parent.get_screen())
        except AttributeError:
            self.connect('destroy', lambda *w: gtk.main_quit())
        self.set_title("MIRC Camera")
        self.set_default_size(1200, 600)

        merge = gtk.UIManager()
        self.set_data("ui-manager", merge)
        merge.insert_action_group(self.__create_action_group(), 0)
        self.add_accel_group(merge.get_accel_group())

        try:
            mergeid = merge.add_ui_from_string(ui_info)
        except gobject.GError, msg:
            print "building menus failed: %s" % msg
        bar = merge.get_widget("/MenuBar")

        bigVBox = gtk.VBox(False, 0)

        table1 = gtk.Table(48, 2, False)
        bigVBox.pack_start(table1, False, False, 0)
        table1.attach(bar,
            # X direction #          # Y direction
            0, 48,                      0, 1,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);

        bar = merge.get_widget("/ToolBar")
        bar.set_tooltips(True)
        table1.attach(bar,
            # X direction #       # Y direction
            0, 48,                   1, 2,
            gtk.EXPAND | gtk.FILL,  0,
            0,                      0)


        hpane = gtk.HPaned()
        hpane.set_position(200)

        bigVBox.pack_start(hpane, True, True, 0)

        #left pannel
        cameraParametersVBox = gtk.VBox(False, 2)
##         hpane.add1(cameraParametersVBox)
        
        sw = gtk.ScrolledWindow()
        sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_ALWAYS)
        hpane.add1(sw)
        frame = gtk.Frame()
        frame.add(cameraParametersVBox)
        sw.add_with_viewport(frame)

   #     backgroundCheck = gtk.CheckButton('use background')
   #     backgroundCheck.connect("toggled", self.checkButton, "useBackground")
   #     cameraParametersVBox.add(backgroundCheck)
        
        hbox = gtk.HBox()
        frame = gtk.Frame("rows")
        entry = gtk.Entry()
        entry.set_size_request(40, 20)
        entry.set_text(str(self.ircc.rows))
        common.rows = self.ircc.rows
        entry.connect("activate", self.cameraSetEntry, 'rows')
        frame.add(entry)
        hbox.add(frame)
        
        frame = gtk.Frame("cols")
        entry = gtk.Entry()
        entry.set_size_request(40, 20)
        entry.set_text(str(self.ircc.cols))
        common.cols = self.ircc.cols
        entry.connect("activate", self.cameraSetEntry, 'cols')
        frame.add(entry)
        hbox.add(frame)
        cameraParametersVBox.add(hbox)
        
        hbox = gtk.HBox()
        frame = gtk.Frame("row off")
        entry = gtk.Entry()
        entry.set_size_request(40, 20)
        entry.set_text(str(self.ircc.rowOffset))
        entry.connect("activate", self.cameraSetEntry, 'rowOffset')
        frame.add(entry)
        hbox.add(frame)
        
        frame = gtk.Frame("col off")
        entry = gtk.Entry()
        entry.set_size_request(40, 20)
        entry.set_text(str(self.ircc.colOffset))
        entry.connect("activate", self.cameraSetEntry, 'colOffset')
        frame.add(entry)
        hbox.add(frame)
        cameraParametersVBox.add(hbox)
        
        frame = gtk.Frame("NReads")
        entry = gtk.Entry()
        entry.set_size_request(40, 20)
        entry.set_text(str(self.ircc.nreads))
        entry.connect("activate", self.cameraSetEntry, 'nreads')
        cameraParametersVBox.add(frame)
        frame.add(entry)

        frame = gtk.Frame("Number of frames")
        entry = gtk.Entry()
        entry.set_size_request(40, 20)
        entry.set_text(str(self.ircc.numberOfFrames))
        entry.connect("activate", self.cameraSetEntry, 'nframes')
        cameraParametersVBox.add(frame)
        frame.add(entry)

        frame = gtk.Frame("Frames per reset")
        entry = gtk.Entry()
        entry.set_size_request(40, 20)
        entry.set_text(str(self.ircc.framesPerReset))
        entry.connect("activate", self.cameraSetEntry, 'framesPerReset')
        cameraParametersVBox.add(frame)
        frame.add(entry)

        frame = gtk.Frame("image directory")
        self.dirEntry  = gtk.Entry()
        self.dirEntry.set_size_request(40, 20)
        self.dirEntry.set_text(self.ircc.imageDirectory)
        self.dirEntry.connect("activate", self.cameraSetEntry, 'dirname')
        frame.add(self.dirEntry)
        cameraParametersVBox.add(frame)

        frame = gtk.Frame("Coherent Coadds:")
        entry = gtk.Entry()
        entry.set_size_request(40, 20)
        entry.set_text(str(self.ircc.numberCoherent))
        entry.connect("activate", self.cameraSetEntry, 'numberCoherent')
        cameraParametersVBox.add(frame)
        frame.add(entry)

        frame = gtk.Frame("Number PS Coadds:")
        entry = gtk.Entry()
        entry.set_size_request(40, 20)
        entry.set_text(str(self.ircc.numberOfCoadds))
        entry.connect("activate", self.cameraSetEntry, 'ncoadds')
        cameraParametersVBox.add(frame)
        frame.add(entry)

        frame = gtk.Frame("Save Number:")
        entry = gtk.Entry()
        entry.set_size_request(40, 20)
        entry.set_text(str(self.ircc.savenum))
        entry.connect("activate", self.cameraSetEntry, 'savenum')
        frame.add(entry)
        cameraParametersVBox.add(frame)

        # Create check buttons

    #    button = gtk.CheckButton("do reset")
    #    button.set_active(self.ircc.doReset)
    #    button.connect("toggled", self.checkButton, "doReset")
    #    cameraParametersVBox.add(button)

    #    button = gtk.CheckButton("do image save")
    #    button.set_active(self.ircc.doImageSave)
    #    button.connect("toggled", self.checkButton, "doImageSave")
    #    cameraParametersVBox.add(button)

    #    button = gtk.CheckButton("read")
    #    button.set_active(self.ircc.read)
    #    button.connect("toggled", self.checkButton, "read")
    #    cameraParametersVBox.add(button)

    #    button = gtk.CheckButton("continuous readout")
    #    button.set_active(self.ircc.continuousReadout)
    #    button.connect("toggled", self.checkButton, "continuousReadout")
    #    cameraParametersVBox.add(button)

     
    #    frame = gtk.Frame("image file name")
    #    self.fileEntry  = gtk.Entry()
    #    self.fileEntry.set_size_request(40, 20)
    #    self.fileEntry.set_text(self.ircc.imageFilename)
    #    self.fileEntry.connect("activate", self.cameraSetEntry, 'filename')
    #    frame.add(self.fileEntry)
    #    cameraParametersVBox.add(frame)

             
#        button = gtk.Button("change file name")
#        button.connect("clicked", self.updateDaqStructure)
#        cameraParametersVBox.add(button)
        
        button = gtk.Button("Update DAQ Parameters")
        button.connect("clicked", self.updateDoImageSave)
        cameraParametersVBox.add(button)

        button = gtk.Button("Config Camera (1234)")
        button.connect("clicked", self.configCamera)
        cameraParametersVBox.add(button)
        
#        button = gtk.Button("Setup Camera (1. INIT)")
#        button.connect("clicked", self.updateParameters)
#        cameraParametersVBox.add(button)
        
#        button = gtk.Button("Reset Controller (2. RESET)")
#        button.connect("clicked", self.resetController)
#        cameraParametersVBox.add(button)
        
#        button = gtk.Button("Set Controller (3. SET)")
#        button.connect("clicked", self.setController)
#        cameraParametersVBox.add(button)
        
        button = gtk.Button("Set Picnic Bias (4. BIAS)")
        button.connect("clicked", self.setPicnicBias)
        cameraParametersVBox.add(button)

# While the restart button works fine, the ople/vme system seems
# unstable if it crashes and then comes back up while mirkwood is already
# connected to vme. maybe ople has to be first? not sure.. -JDM

#        button = gtk.Button("Restart OPLE/VME Sockets")
#        button.connect("clicked", self.reOPLE)
#        cameraParametersVBox.add(button)
        
        button = gtk.Button("Kill Server")
        button.connect("clicked", self.killServer)
        cameraParametersVBox.add(button)
        

        #right pannel
        table = gtk.Table(48, 20, False)
##         self.add(table)

        hpane.add2(table)       

        
        #some buttons
        self.rb1 = {"2D image":1, "cross section":0, "Option 3":0, "Option 4":0}
        self.rb2  = {"Option 1":1, "Option 2":0, "Option 3":0, "Option 4":0}

        button1 = gtk.RadioButton(None, "2D image")
        button1.connect("toggled", self.radio_button_cb1, "2D image")
        table.attach(button1,
                         # X direction           Y direction
                         0, 2,                   3, 4,
                         gtk.FILL,                      0,
                         0,                      0)

        button1 = gtk.RadioButton(button1, "cross section")
        button1.connect("toggled", self.radio_button_cb1, "cross section")
        table.attach(button1,
                     # X direction           Y direction
                     0, 2,                   4, 5,
                     gtk.FILL,                      0,
                     0,                      0)

        bigFrame = gtk.Frame()
        vbox = gtk.VBox()
        frame = gtk.Frame("Row #")
        self.row_entry1 = gtk.Entry()
        self.row_entry1.set_size_request(20, 20)
        self.row_entry1.set_text(str(0))
        self.row_entry1.connect("activate", self.row_entry_cb, 1)
        frame.add(self.row_entry1)
        frame.set_shadow_type(gtk.SHADOW_NONE)
        vbox.add(frame)

        hbox = gtk.HBox()
        frame = gtk.Frame("cmin")
        self.row_entry1 = gtk.Entry()
        self.row_entry1.set_size_request(20, 20)
        self.row_entry1.set_text(str(0))
        self.row_entry1.connect("activate", self.col_entry_cb, 1, 'cmin')
        frame.add(self.row_entry1)
        frame.set_shadow_type(gtk.SHADOW_NONE)
        hbox.add(frame)

        frame = gtk.Frame("cmax")
        self.row_entry1 = gtk.Entry()
        self.row_entry1.set_size_request(20, 20)
        self.row_entry1.set_text(str(0))
        self.row_entry1.connect("activate", self.col_entry_cb, 1, 'cmax')
        self.row_entry1.set_text(str(common.cols))
        frame.add(self.row_entry1)
        frame.set_shadow_type(gtk.SHADOW_NONE)
        hbox.add(frame)
        vbox.add(hbox)
        bigFrame.add(vbox)
        
        table.attach(bigFrame,
                     # X direction           Y direction
                     0, 2,                   5,6,
                     0,                      0,
                     0,                      0)

        button1 = gtk.RadioButton(button1, "quadrant mode")
        button1.connect("toggled", self.radio_button_cb1, "quadrant mode")
        table.attach(button1,
                         # X direction           Y direction
                         0, 2,                   6,7,
                         gtk.FILL,                      0,
                         0,                      0)

        bbox1 = gtk.HBox()
        bboxv11 = gtk.VBox()
        bboxv12 = gtk.VBox()

        quadButton1 = gtk.ToggleButton('Q3')
        quadButton1.connect("toggled", self.quadrant1, 2) 
        bboxv11.add(quadButton1)
        quadButton1 = gtk.ToggleButton('Q4')
        quadButton1.connect("toggled", self.quadrant1, 3) 
        bboxv12.add(quadButton1)
        quadButton1 = gtk.ToggleButton('Q1')
        quadButton1.connect("toggled", self.quadrant1, 0) 
        bboxv11.add(quadButton1)
        quadButton1 = gtk.ToggleButton('Q2')
        quadButton1.connect("toggled", self.quadrant1, 1) 
        bboxv12.add(quadButton1)

        bbox1.add(bboxv11)
        bbox1.add(bboxv12)
        table.attach(bbox1,
                         # X direction           Y direction
                         0, 2,                   7,9,
                         0,                      0,
                         0,                      0)

 
        button1 = gtk.RadioButton(button1, "power spectrum")
        button1.connect("toggled", self.radio_button_cb1, "power spectrum")
        table.attach(button1,
                         # X direction           Y direction
                         0, 2,                   9,10,
                         gtk.FILL,                      0,
                         0,                      0)

        button1 = gtk.RadioButton(button1, "ps cross section")
        button1.connect("toggled", self.radio_button_cb1, "ps cross section")
        table.attach(button1,
                         # X direction           Y direction
                         0, 2,                   10, 11,
                         gtk.FILL,                      0,
                         0,                      0)

        frame = gtk.Frame()
        bbox1 = gtk.HBox()
        bboxv11 = gtk.VBox()
        bboxv12 = gtk.VBox()

        buttonps1 = gtk.RadioButton(None, "row #")
        buttonps1.connect("toggled", self.radio_button_cb_ps1, "row")
        bboxv11.add(buttonps1)

        buttonps1 = gtk.RadioButton(buttonps1, "col #")
        buttonps1.connect("toggled", self.radio_button_cb_ps1, "col")
        bboxv12.add(buttonps1)

        self.psrow_entry1 = gtk.Entry()
        self.psrow_entry1.set_size_request(40, 20)
        self.psrow_entry1.set_text(str(0))
        self.psrow_entry1.connect("activate", self.psrow_entry_cb, 1)
        bboxv11.add(self.psrow_entry1)

        self.pscol_entry1 = gtk.Entry()
        self.pscol_entry1.set_size_request(40, 20)
        self.pscol_entry1.set_text(str(0))
        self.pscol_entry1.connect("activate", self.pscol_entry_cb, 1)
        bboxv12.add(self.pscol_entry1)
        
        bbox1.add(bboxv11)
        bbox1.add(bboxv12)
        frame.add(bbox1)
        table.attach(frame,
                         # X direction           Y direction
                         0, 2,                   11,13,
                         0,                      0,
                         0,                      0)

        frame = gtk.Frame()
        vbox = gtk.VBox()
        start_button = gtk.Button('   START   ')
        start_button.connect('clicked', self.control_display, "start1")
        vbox.add(start_button)
        
        stop_button = gtk.Button('   STOP   ')
        stop_button.connect('clicked', self.control_display, "stop1")
        vbox.add(stop_button)

        frame.add(vbox)
        table.attach(frame,
                         # X direction           Y direction
                         0, 2,                   13,15,
                         0,                      0,
                         0,                      0)
        
        button2 = gtk.RadioButton(None, "2D image")        
        button2.connect("toggled", self.radio_button_cb2, "2D image")
        table.attach(button2,
                         # X direction           Y direction
                         24, 26,                   3, 4,
                         gtk.FILL,                      0,
                         0,                      0)

        button2 = gtk.RadioButton(button2, "cross section")
        button2.connect("toggled", self.radio_button_cb2, "cross section")
        table.attach(button2,
                         # X direction           Y direction
                         24, 26,                   4, 5,
                         gtk.FILL,                      0,
                         0,                      0)

        bigFrame = gtk.Frame()
        vbox = gtk.VBox()
        frame = gtk.Frame("Row #")
        self.row_entry2 = gtk.Entry()
        self.row_entry2.set_size_request(20, 20)
        self.row_entry2.set_text(str(0))
        self.row_entry2.connect("activate", self.row_entry_cb, 2)
        frame.add(self.row_entry2)
        frame.set_shadow_type(gtk.SHADOW_NONE)
        vbox.add(frame)

        hbox = gtk.HBox()
        frame = gtk.Frame("cmin")
        self.row_entry2 = gtk.Entry()
        self.row_entry2.set_size_request(20, 20)
        self.row_entry2.set_text(str(0))
        self.row_entry2.connect("activate", self.col_entry_cb, 2, 'cmin')
        frame.add(self.row_entry2)
        frame.set_shadow_type(gtk.SHADOW_NONE)
        hbox.add(frame)

        frame = gtk.Frame("cmax")
        self.row_entry2 = gtk.Entry()
        self.row_entry2.set_size_request(20, 20)
        self.row_entry2.set_text(str(0))
        self.row_entry2.connect("activate", self.col_entry_cb, 2, 'cmax')
        self.row_entry2.set_text(str(common.cols))
        frame.add(self.row_entry2)
        frame.set_shadow_type(gtk.SHADOW_NONE)
        hbox.add(frame)
        vbox.add(hbox)
        bigFrame.add(vbox)
        table.attach(bigFrame,
                     # X direction           Y direction
                     24, 26,                   5,6,
                     0,                      0,
                     0,                      0)

        button2 = gtk.RadioButton(button2, "quadrant mode")
        button2.connect("toggled", self.radio_button_cb2, "quadrant mode")
        table.attach(button2,
                         # X direction           Y direction
                         24, 26,                   6,7,
                         gtk.FILL,                      0,
                         0,                      0)
        self.quad2 = {'q1':0, 'q2':0, 'q3':0, 'q4':0}
        bbox2 = gtk.HBox()
        bboxv21 = gtk.VBox()
        bboxv22 = gtk.VBox()
        q2_button = gtk.ToggleButton('Q3')
        q2_button.connect('clicked', self.quadrant2, 2)
        bboxv21.add(q2_button)
        q2_button = gtk.ToggleButton('Q4')
        q2_button.connect('clicked', self.quadrant2, 3)
        bboxv22.add(q2_button)
        q2_button = gtk.ToggleButton('Q1')
        q2_button.connect('clicked', self.quadrant2, 0)
        bboxv21.add(q2_button)
        q2_button = gtk.ToggleButton('Q2')
        q2_button.connect('clicked', self.quadrant2, 1)
        bboxv22.add(q2_button)
        bbox2.add(bboxv21)
        bbox2.add(bboxv22)
        table.attach(bbox2,
                         # X direction           Y direction
                         24, 26,                   7,9,
                         0,                      0,
                         0,                      0)

        button2 = gtk.RadioButton(button2, "power spectrum")
        button2.connect("toggled", self.radio_button_cb2, "power spectrum")
        table.attach(button2,
                         # X direction           Y direction
                         24, 26,                   9,10,
                         gtk.FILL,                      0,
                         0,                      0)

        button2 = gtk.RadioButton(button2, "ps cross section")
        button2.connect("toggled", self.radio_button_cb2, "ps cross section")
        table.attach(button2,
                         # X direction           Y direction
                         24, 26,                   10, 11,
                         gtk.FILL,                      0,
                         0,                      0)
        frame = gtk.Frame()
        bbox2 = gtk.HBox()
        bboxv21 = gtk.VBox()
        bboxv22 = gtk.VBox()

        buttonps2 = gtk.RadioButton(None, "row #")
        buttonps2.connect("toggled", self.radio_button_cb_ps2, "row")
        bboxv21.add(buttonps2)

        buttonps2 = gtk.RadioButton(buttonps2, "col #")
        buttonps2.connect("toggled", self.radio_button_cb_ps2, "col")
        bboxv22.add(buttonps2)

        self.psrow_entry2 = gtk.Entry()
        self.psrow_entry2.set_size_request(40, 20)
        self.psrow_entry2.set_text(str(0))
        self.psrow_entry2.connect("activate", self.psrow_entry_cb, 2)
        bboxv21.add(self.psrow_entry2)

        self.pscol_entry2 = gtk.Entry()
        self.pscol_entry2.set_size_request(40, 20)
        self.pscol_entry2.set_text(str(0))
        self.pscol_entry2.connect("activate", self.pscol_entry_cb, 2)
        bboxv22.add(self.pscol_entry2)
        
        bbox2.add(bboxv21)
        bbox2.add(bboxv22)
        frame.add(bbox2)
        table.attach(frame,
                         # X direction           Y direction
                         24, 26,                   11,13,
                         0,                      0,
                         0,                      0)
        frame = gtk.Frame()
        vbox = gtk.VBox()
        start_button = gtk.Button('   START   ')
        start_button.connect('clicked', self.control_display, "start2")
        vbox.add(start_button)
	    
        stop_button = gtk.Button('   STOP   ')
        stop_button.connect('clicked', self.control_display, "stop2")
        vbox.add(stop_button)

        frame.add(vbox)
        table.attach(frame,
                         # X direction           Y direction
                         24, 26,                   13,15,
                         0,                      0,
                         0,                      0)
        
        table.attach(self.anim.canvas1,
            2, 24,                   3, 19,
            gtk.EXPAND|gtk.FILL,               gtk.EXPAND|gtk.FILL,
            0,                      0)
        toolbar1 = NavigationToolbar(self.anim.canvas1, self)
        
	
        table.attach(self.anim.canvas2,
            26, 48,                   3, 19,
            gtk.EXPAND|gtk.FILL,               gtk.EXPAND|gtk.FILL,
            0,                      0)
        toolbar2 = NavigationToolbar(self.anim.canvas2, self)

        table.attach(toolbar1,
            # X direction           Y direction
            2, 24,                   19, 20,
            gtk.EXPAND|gtk.FILL,    gtk.EXPAND|gtk.FILL,
            0,                      0)

        table.attach(toolbar2,
            # X direction           Y direction
            26, 48,                   19, 20,
            gtk.EXPAND|gtk.FILL,    gtk.EXPAND|gtk.FILL,
            0,                      0)

        self.add(bigVBox)
        self.show_all()


    def __create_action_group(self):
        # GtkActionEntry
        entries = (
          ( "FileMenu", None, "_File" ),               # name, stock id, label
          ( "PreferencesMenu", None, "_Preferences" ), # name, stock id, label
          ( "mirkwood server", None, "_Server", 
            None, "Server", self.setServerParameters),       # name, stock id, label
          ( "ShapeMenu", None, "_Shape" ),             # name, stock id, label
          ( "HelpMenu", None, "_Help" ),               # name, stock id, label
          ( "Quit", gtk.STOCK_QUIT,                    # name, stock id
            "_Quit", "<control>Q",                     # label, accelerator
            "Quit",                                    # tooltip
            self.quit_cb ),
          ( "About", None,                             # name, stock id
            "_About", "<control>A",                    # label, accelerator
            "About",                                   # tooltip
            self.activate_action ),
          ( "Take BG", None,                   # name, stock id
             "_Take BG", None,                              # label, accelerator
            "Take BG",                                    # tooltip
            self.takeBackgroundFrames ),
       ( "Reset BG", None,                   # name, stock id
             "_Reset BG", None,                              # label, accelerator
            "Reset BG",                                    # tooltip
            self.resetBackgroundFrames ),
       ( "Use BG", None,                   # name, stock id
             "_Use BG", None,                              # label, accelerator
            "Use BG",                                    # tooltip
            self.useBackgroundFrames ),

          ( "Start exposure", None,                   # name, stock id
             "_Start exposure", None,                              # label, accelerator
            "Start exposure",                                    # tooltip
            self.startExposure ),
          ( "Stop exposure", None,                   # name, stock id
             "_Stop exposure", None,                              # label, accelerator
            "Stop exposure",                                    # tooltip
            self.stopExposure ),
         # ( "Abort exposure", None,                   # name, stock id
         #    "_Abort exposure", None,                              # label, accelerator
         #   "Abort exposure",                                    # tooltip
         #   self.abortExposure ),
          ( "Delay lines control", None,                   # name, stock id
             "_Delay lines control", None,                              # label, accelerator
            "delay lines control",                                    # tooltip
            self.delayLinesControl ),
          ( "GDT control", None,                   # name, stock id
             "_GDT control", None,                              # label, accelerator
            "GDT control",                                    # tooltip
            self.gdtControl),
##           ( "shutterMatrix", None,                   # name, stock id
##              "_shutterMatrix", None,                              # label, accelerator
##             "shutterMatrix",                                    # tooltip
##             self.create_shutterMatrix ),
##           ( "fiberExplorer", None,                   # name, stock id
##              "_fiberExplorer", None,                              # label, accelerator
##             "fiberExplorer",                                    # tooltip
##             self.create_fiberExplorer ),
        );
        # GtkToggleActionEntry
        toggle_entries = (
          ( "Bold", gtk.STOCK_BOLD,                    # name, stock id
             "_Bold", "<control>B",                    # label, accelerator
            "Bold",                                    # tooltip
            self.activate_action,
            True ),                                    # is_active
        )

        # GtkRadioActionEntry
        color_entries = (
          ( "Red", None,                               # name, stock id
            "_Red", "<control><shift>R",               # label, accelerator
            "Blood", COLOR_RED ),                      # tooltip, value
          ( "Green", None,                             # name, stock id
            "_Green", "<control><shift>G",             # label, accelerator
            "Grass", COLOR_GREEN ),                    # tooltip, value
          ( "Blue", None,                              # name, stock id
            "_Blue", "<control><shift>B",              # label, accelerator
            "Sky", COLOR_BLUE ),                       # tooltip, value
        )

        # GtkRadioActionEntry
        shape_entries = (
          ( "Square", None,                            # name, stock id
            "_Square", "<control><shift>S",            # label, accelerator
            "Square",  SHAPE_SQUARE ),                 # tooltip, value
          ( "Rectangle", None,                         # name, stock id
            "_Rectangle", "<control><shift>R",         # label, accelerator
            "Rectangle", SHAPE_RECTANGLE ),            # tooltip, value
          ( "Oval", None,                              # name, stock id
            "_Oval", "<control><shift>O",              # label, accelerator
            "Egg", SHAPE_OVAL ),                       # tooltip, value
        )

        # Create the menubar and toolbar
        action_group = gtk.ActionGroup("AppWindowActions")
        action_group.add_actions(entries)
        action_group.add_toggle_actions(toggle_entries)
##         action_group.add_radio_actions(color_entries, COLOR_RED, self.activate_radio_action)
        action_group.add_radio_actions(shape_entries, SHAPE_OVAL, self.activate_radio_action)

        return action_group

    def quit_cb(self, b):
        print 'Quitting program'
        gtk.main_quit()

    def radio_button_cb_ps1(self, widget, data=None):
	active = widget.get_active()
        if active:
            self.anim.ps1XSec = data
            print "ps1XSec = ", self.anim.ps1XSec

    def radio_button_cb_ps2(self, widget, data=None):
	active = widget.get_active()
        if active:
            self.anim.ps2XSec = data
            print "ps2XSec = ", self.anim.ps2XSec

    def radio_button_cb1(self, widget, data=None):
	active = widget.get_active()
	if active:
            self.anim.plot1Type = data
            print "plot1 type = ", self.anim.plot1Type
	        
    def radio_button_cb2(self, widget, data=None):
	active = widget.get_active()
	if active:
            self.anim.plot2Type = data
            print "plot2 type = ", self.anim.plot2Type
		        
    def setServerParameters(self, action):
        cmd = 'childWindows.main'
	window = eval(cmd)('server')        

    def delayLinesControl(self, action):
	#cmd = 'childWindows.main'
	#window = eval(cmd)('delayLines')
        #import childWindows_S1E1W1W2 as cw
        #cw.main('delayLines')
        os.system('/home/observe/mirc_python/IRCam/delayLines_S1E1W1W2 &')

    def gdtControl(self, action):
	#cmd = 'childWindows.main'
	#window = eval(cmd)('gdt')
        #import childWindows_S1E1W1W2 as cw
        #cw.main('gdt')
        os.system('/home/observe/mirc_python/IRCam/gdt_S1E1W1W2 &')
        
    def create_shutterMatrix(self, action):
        pass
##         import shutterMatrix
##         shutterMatrix.main()

    def create_fiberExplorer(self, action):
        pass
##         import mircFiberExplorer
##         mircFiberExplorer.main()

    def create_gerbil(self, action):
    	import gerbil
	cmd = 'gerbil.main'
	window1 = eval(cmd)()
    
    def activate_action(self, action):
        dialog = gtk.MessageDialog(self, gtk.DIALOG_DESTROY_WITH_PARENT,
            gtk.MESSAGE_INFO, gtk.BUTTONS_CLOSE,
            'You activated action: "%s" of type "%s"' % (action.get_name(), type(action)))
        # Close dialog on user response
        dialog.connect ("response", lambda d, r: d.destroy())
        dialog.show()

    def activate_radio_action(self, action, current):
        active = current.get_active()
        value = current.get_current_value()

        if active:
            dialog = gtk.MessageDialog(self, gtk.DIALOG_DESTROY_WITH_PARENT,
                gtk.MESSAGE_INFO, gtk.BUTTONS_CLOSE,
                "You activated radio action: \"%s\" of type \"%s\".\nCurrent value: %d" %
                (current.get_name(), type(current), value))

            # Close dialog on user response
            dialog.connect("response", lambda d, r: d.destroy())
            dialog.show()


    def update_resize_grip(self, widget, event):
        mask = gtk.gdk.WINDOW_STATE_MAXIMIZED | gtk.gdk.WINDOW_STATE_FULLSCREEN
        if (event.changed_mask & mask):
            self.statusbar.set_has_resize_grip(not (event.new_window_state & mask))	

    def quadrant1(self, widget, status):
        if widget.get_active():
            self.anim.quad1[status] = 1
            print "quad1 =", self.anim.quad1
        else:
            self.anim.quad1[status] = 0
            print "quad1 = ", self.anim.quad1

    def quadrant2(self, widget, status):
        if widget.get_active():
            self.anim.quad2[status] = 1
            print "quad2 =", self.anim.quad2
        else:
            self.anim.quad2[status] = 0
            print "quad2 = ", self.anim.quad2

    def control_display(self, widget, status):
	if (status == "start1"):
	    common.status1 = 1
            if self.tag1 == -1:
                self.tag1 = gobject.timeout_add(100, self.anim.updatefig1)
	    print status
	if (status == "stop1"):
	    common.status1 = 0
            if self.tag1 != -1:
                gobject.source_remove(self.tag1)
                self.tag1 = -1
	    print status
	if (status == "start2"):
	    common.status2 = 1
            if self.tag2 == -1:
                self.tag2 = gobject.timeout_add(100, self.anim.updatefig2)
            print status
	if (status == "stop2"):
	    common.status2 = 0
            if self.tag2 != -1:
                gobject.source_remove(self.tag2)
                self.tag2 = -1
	    print status

    def row_entry_cb(self, widget, n):
        entry_text = widget.get_text()
        if n == 1:
            self.anim.xrow1 = int(entry_text)
            print "New row 1: %d\n" % self.anim.xrow1
            if self.anim.xrow1 > common.rows:
                self.anim.xrow1 = common.rows
                widget.set_text(str(self.anim.xrow1))
        if n == 2:
            self.anim.xrow2 = int(entry_text)
            print "New row 2: %d\n" % self.anim.xrow2
            if self.anim.xrow2 > common.rows:
                self.anim.xrow2 = common.rows
                widget.set_text(str(self.anim.xrow2))

    def col_entry_cb(self, widget, n, m):
        entry_text = widget.get_text()
        if n == 1:
            if m == 'cmin':
                self.anim.cmin1 = int(entry_text)
                if self.anim.cmin1 < 0:
                    self.anim.cmin1 = 0
                    widget.set_text(str(self.anim.cmin1))
             
            if m == 'cmax':
                self.anim.cmax1 = int(entry_text)
                if self.anim.cmax1 > common.cols:
                    self.anim.cmax1 = common.cols
                    widget.set_text(str(self.anim.cmax1))
        if n == 2:
            if m == 'cmin':
                self.anim.cmin2 = int(entry_text)
                if self.anim.cmin2 < 0:
                    self.anim.cmin2 = 0
                widget.set_text(str(self.anim.cmin2))
             
            if m == 'cmax':
                self.anim.cmax2 = int(entry_text)
                if self.anim.cmax2 > common.cols:
                    self.anim.cmax2 = common.cols
                    widget.set_text(str(self.anim.cmax2))

    def psrow_entry_cb(self, widget, n):
        entry_text = widget.get_text()
        if n == 1:
            self.anim.psxrow1 = int(entry_text)
            print "New ps row 1: %d\n" % self.anim.psxrow1
            if self.anim.psxrow1 > common.rows/2:
                self.anim.psxrow1 = common.rows/2
                widget.set_text(str(self.anim.psxrow1))
        if n == 2:
            self.anim.psxrow2 = int(entry_text)
            print "New ps row 2: %d\n" % self.anim.psxrow2
            if self.anim.psxrow2 > common.rows/2:
                self.anim.psxrow2 = common.rows/2
                widget.set_text(str(self.anim.psxrow2))

    def pscol_entry_cb(self, widget, n):
        entry_text = widget.get_text()
        if n == 1:
            self.anim.psxcol1 = int(entry_text)
            print "New ps col 1: %d\n" % self.anim.psxcol1
            if self.anim.psxcol1 > 1+common.cols/2:
                self.anim.psxcol1 = 1+common.cols/2
                widget.set_text(str(self.anim.psxcol1))
        if n == 2:
            self.anim.psxcol2 = int(entry_text)
            print "New ps col 2: %d\n" % self.anim.psxcol2
            if self.anim.psxcol2 > 1+common.cols/2:
                self.anim.psxcol2 = 1+common.cols/2
                widget.set_text(str(self.anim.psxcol2))
            
    def checkButton(self, widget, data=None):
        if data == "doReset":
            self.ircc.doReset = widget.get_active()
            print "doReset = ", self.ircc.doReset
            
        elif data == "doImageSave":
            self.ircc.doImageSave = widget.get_active()
            print "doImageSave = ", self.ircc.doImageSave
            
        elif data == "read":
            self.ircc.read = widget.get_active()
            print "read = ", self.ircc.read

        elif data == "continuousReadout":
            self.ircc.continuousReadout = widget.get_active()
            print "continuousReadout= ", self.ircc.continuousReadout

        elif data == "useBackground":
            self.ircc.useBackground = widget.get_active()
            print "useBackground = ", self.ircc.useBackground

	       
    def getDirectory(self, widget):
        dirChooser = gtk.FileChooserDialog("Open..",
                                            None,
                                            gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER,
                                            (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
                                             gtk.STOCK_APPLY, gtk.RESPONSE_OK))
        dirChooser.set_default_response(gtk.RESPONSE_OK)
        response = dirChooser.run()
        if response == gtk.RESPONSE_OK:
            self.imageDirectory = dirChooser.get_current_folder()
            print self.imageDirectory
        elif response == gtk.RESPONSE_CANCEL:
            print 'Closed, no directory selected'
        self.dirEntry.set_text(self.imageDirectory)
        dirChooser.destroy()

    def cameraSetEntry(self, widget, data):
        entry = widget.get_text()
        if data == 'rows':
            self.ircc.rows = int(entry)
            common.rows = self.ircc.rows
            print "new rows = ",  self.ircc.rows

        elif data == 'cols':
            self.ircc.cols = int(entry)
            common.cols = self.ircc.cols
            print "new cols = ",  self.ircc.cols

        elif data == 'rowOffset':
            self.ircc.rowOffset = int(entry)
            print "new rowOffset = ",  self.ircc.rowOffset
            
        elif data == 'colOffset':
            self.ircc.colOffset = int(entry)
            print "new colOffset = ",  self.ircc.colOffset

        elif data == 'nreads':
            self.ircc.nreads = int(entry)
            print "new nreads = ",  self.ircc.nreads

        elif data == 'nframes':
            self.ircc.numberOfFrames = int(entry)
            print "new nframes = ",  self.ircc.numberOfFrames

        elif data == 'numberCoherent':
            self.ircc.numberCoherent = int(entry)
            print "new numberCoherent = ",  self.ircc.numberCoherent

        elif data == 'ncoadds':
            self.ircc.numberOfCoadds = int(entry)
            print "new ncoadds = ",  self.ircc.numberOfCoadds

        elif data == 'framesPerBuffer':
            self.ircc.framesPerBuffer = int(entry)
            print "new framesPerBuffer = ",  self.ircc.framesPerBuffer

        elif data == 'framesPerReset':
            self.ircc.framesPerReset = int(entry)
            print "new framesPerReset = ",  self.ircc.framesPerReset

        elif data == 'savenum':
            self.ircc.savenum = int(entry)
            print "new savenum = ",  self.ircc.savenum
            
        elif data == 'dirname':
            self.ircc.imageDirectory = entry
            print "new imageDirectory = ",  self.ircc.imageDirectory

        elif data == 'filename':
            self.ircc.imageFilename = entry
            print "new imageFilename = ",  self.ircc.imageFilename

    def updateParameters(self, widget):
        self.ircc.sendStruct()
                
    def updateDaqStructure(self, widget):
        self.ircc.updateDaqStructure()
        print "updateDaqStructure"
        
    def updateDoImageSave(self, widget):
        self.ircc.updateDoImageSave()
        
    def resetController(self, widget):
        self.ircc.resetCont()
        
    def setController(self, widget):
        self.ircc.setCont()

    def configCamera(self, widget):
        self.ircc.updateDaqStructure()
        time.sleep(0.2)
        self.ircc.sendStruct()
        time.sleep(0.4)
        self.ircc.resetCont()
        time.sleep(0.5)
        self.ircc.setCont()
        time.sleep(0.5)
        self.ircc.setBias()
        time.sleep(0.5)
        self.ircc.setBias()
        
    def setPicnicBias(self, widget):
        self.ircc.setBias()

    def reOPLE(self, widget):
        self.ircc.reOPLE()
        
    def killServer(self, widget):
        self.ircc.killServer()
        
    def startExposure(self, action):
        self.ircc.sendStruct()
        #added a sleep between the two commands
        #without sleep startExp fails
        time.sleep(1)
        self.ircc.startExposure()

    def stopExposure(self, action):
        self.ircc.stopExposure()

    def abortExposure(self, action):
        self.ircc.abortExposure()

    def takeBackgroundFrames(self, action):
        self.ircc.getBackgroundFrame()

    def resetBackgroundFrames(self, action):
        self.ircc.resetBackgroundFrame()

    def useBackgroundFrames(self, action):
        self.ircc.useBackgroundFrame()



        
        
        
def main():
    ApplicationMainWindow()
    gtk.main()

if __name__ == '__main__':
    main()
