#!/usr/bin/python
import pygtk
## pygtk.require('2.0')
import gtk
import time
import socket
#from socket import *
import pdb

class mircshutter:
    def __init__(self):

	self.num_stages=6
	self.host='192.168.3.145'
	self.port=6001

	self.pos=[0,0,0,0,0,0]
	#create window
        self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)

        #give it a name
        self.window.set_title("MIRC Shutter")
                
        #identify the destroy signal
        self.window.connect("destroy", lambda x: gtk.main_quit())

        #show the window
        self.window.show()

        self.style = self.window.get_style().copy()


	self.table=gtk.Table(2,self.num_stages)
	self.table.show()
	self.window.add(self.table)

	self.beam_togglebutton=[]
	self.stage_labels=['Beam#1','Beam #2','Beam #3','Beam #4','Beam #5', 'Beam #6']
	for ii in range(self.num_stages):
	    self.beam_togglebutton.append(gtk.ToggleButton(self.stage_labels[ii]))
	    self.beam_togglebutton[ii].connect('pressed',self.change_status,ii)
	    map=self.beam_togglebutton[ii].get_colormap()
            color_off=map.alloc_color("red")
            color_on=map.alloc_color("green")
            self.beam_togglebutton[ii].modify_bg(gtk.STATE_NORMAL,color_off)
            self.beam_togglebutton[ii].modify_bg(gtk.STATE_ACTIVE,color_on)

	    self.beam_togglebutton[ii].show()
	    self.table.attach(self.beam_togglebutton[ii],ii,ii+1,0,1,xpadding=5,ypadding=10)	
	self.refresh_all()

	self.open_button=gtk.Button('Open All Shutter')
	self.open_button.connect('clicked',self.open_all)
	self.open_button.show()
	self.table.attach(self.open_button,2,4,1,2,xpadding=5,ypadding=10)

	self.close_button=gtk.Button('Close All Shutter')
        self.close_button.connect('clicked',self.close_all)
        self.close_button.show()
        self.table.attach(self.close_button,4,6,1,2,xpadding=5,ypadding=10)

	self.ping_button=gtk.Button('Ping')
	self.ping_button.connect('clicked',self.ping)
        self.ping_button.show()
        self.table.attach(self.ping_button,0,1,1,2,xpadding=5,ypadding=10)
	
	self.refresh_button=gtk.Button('Refresh')
        self.refresh_button.connect('clicked',self.refresh)
        self.refresh_button.show()
        self.table.attach(self.refresh_button,1,2,1,2,xpadding=5,ypadding=10)

    def initSocket(self):
	self.sock = None
        print "self.host = ", self.host
        print "self.port = ", self.port
# 	self.sock = socket(AF_INET,SOCK_STREAM)
#	self.sock.connect((self.host,self.port))
        for res in socket.getaddrinfo(self.host, self.port, socket.AF_INET, socket.SOCK_STREAM):
            af, socktype, proto, canonname, sa = res
            try:
                self.sock = socket.socket(af, socktype, proto)
                self.sock.settimeout(10)
            except socket.error, msg:
                self.sock = None
                continue
            try:
                self.sock.connect(sa)
                self.fd = self.sock.fileno()
            except socket.error, msg:
                self.sock.close()
                self.sock = None
                continue
            break
        if self.sock is None:
	    self.server_status("OFF")

    def server_status(self,data):
	self.dialog=gtk.Dialog(title='MIRC shutter')
	OK_button=gtk.Button('OK')
	self.dialog.action_area.pack_start(OK_button,True,True)
	OK_button.connect('clicked',self.dialog_destroy)
	OK_button.show()
	if data == "ON":
	    Label=gtk.Label('\
            The MIRC shutter server\n \
            is available'
            )
	else:
	    Label=gtk.Label('\
	    The MIRC shutter server\n \
	    is not responding'
 	    )
   	self.dialog.vbox.pack_start(Label,True,True)
	Label.show()
	self.dialog.show()

    def dialog_destroy(self,widget):
	self.dialog.destroy()

    def ping(self,widget):
        print "self.host = ", self.host
        print "self.port = ", self.port
        for res in socket.getaddrinfo(self.host, self.port, socket.AF_INET, socket.SOCK_STREAM):
            af, socktype, proto, canonname, sa = res
            try:
                self.sock = socket.socket(af, socktype, proto)
                self.sock.settimeout(10)
            except socket.error, msg:
                self.sock = None
                continue
            try:
                self.sock.connect(sa)
                self.fd = self.sock.fileno()
            except socket.error, msg:
                self.sock.close()
                self.sock = None
                continue
	    self.server_status("ON")
	    self.sock.close()
            break
	
        if self.sock is None:
            self.server_status("OFF")
	

    def refresh(self,widget):
	self.read_all()
	self.refresh_all()

    def refresh_all(self):
	for ii in range(self.num_stages):
	    if self.pos[ii]:
		self.beam_togglebutton[ii].set_active(True)	
	    else:
		self.beam_togglebutton[ii].set_active(False)

    def read_all(self):
	#pdb.set_trace()
	self.initSocket()
        #time.sleep(0.2)
        if self.sock == None:
            print 'unable to create socket'
        else:
            for ii in range(self.num_stages):
                outbuf=chr(ii+21)
		self.sock.send(outbuf)
		time.sleep(0.1)
                temp=self.sock.recv(4)
		if temp < '\x5A':               #'\x5A' is 90 degree
		   self.pos[ii]=1
		else:
		   self.pos[ii]=0
            self.sock.close()	

    def open_all(self,widget):
	#pdb.set_trace()
	self.initSocket()
	#time.sleep(0.2)
	if self.sock == None:
	    print 'unable to create socket'
	else:
	    for ii in range(self.num_stages):
		if self.pos[ii]==1: continue
	    	self.pos[ii]=1
		outbuf=chr(ii+1)
	        self.sock.send(outbuf)
	    	time.sleep(0.5)
	    	print "shutter %d opened" %(ii+1)
	    self.sock.close()
	self.refresh_all()	

    def close_all(self,widget):
	#pdb.set_trace()
	self.initSocket()
        #time.sleep(0.2)
        if self.sock == None:
            print 'unable to create socket'
        else:
	    for ii in range(self.num_stages):
		if self.pos[ii]==0:continue
		self.pos[ii]=0
		outbuf=chr(ii+11)
            	self.sock.send(outbuf)
            	time.sleep(0.5)
	    	print 'shutter %d closed' %(ii+1)
            self.sock.close()
	self.refresh_all()
 
    def change_status(self,widget,data):
	#pdb.set_trace()

#      	map=widget.get_colormap()
#        color_off=map.alloc_color("red")
#        color_on=map.alloc_color("green")
#        widget.modify_bg(gtk.STATE_NORMAL,color_off)
#        widget.modify_bg(gtk.STATE_ACTIVE,color_on)
	
	self.initSocket()
	if self.sock == None:
            print 'unable to create socket'
        else:
	    if  self.beam_togglebutton[data].get_active():
		self.pos[data]=0
	        outbuf=chr(data+11)
                self.sock.send(outbuf)
                time.sleep(0.5)
                print 'shutter %d closed' %(data+1)
	    else:
		self.pos[data]=1
		outbuf=chr(data+1)
                self.sock.send(outbuf)
                time.sleep(0.5)
                print 'shutter %d opened' %(data+1)


	
    def main(self):
	gtk.main()


def main():
#    pdb.set_trace()
    mirc_shutter = mircshutter()
    mirc_shutter.main()

print __name__
if __name__ == "__main__":
    main()

