#!/usr/bin/python2.3
'''
the import user command looks for .pythonrc.py and execute it
in our case .pythonrc.py gives acces to the modules from
$HOME/control/python/pythonLibs
'''
import user

import gtk
#import numarray as  na
import numpy as na
import gobject
import copy
import time
import IRCamLibs_FlipQuadrants.IRCamCommands as IRCamLibsIRCamCommands
import IRCamLibs_FlipQuadrants.camStructures as IRCamLibscamStructures

class detectorParameters(gtk.Window):
    def __init__(self, ircc = None, parent=None):
        if ircc == None: self.ircc = IRCamLibsIRCamCommands.IRCamCommands()
        else: self.ircc = ircc
        self.ircc.getStruct()
        
        # Create the toplevel window
        gtk.Window.__init__(self)
        try:
            self.set_screen(parent.get_screen())
        except AttributeError:
            self.connect('destroy', lambda *w: gtk.main_quit())

        self.set_title("daq structure")
        self.set_default_size(230, 400)

        sw = gtk.ScrolledWindow()
        sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_ALWAYS)
        self.add(sw)

        table = gtk.Table(1, 3, False)
        sw.add_with_viewport(table)

        frame = gtk.Frame("server IP")
        self.hostEntry = gtk.Entry()
        self.hostEntry.set_size_request(40, 20)
        self.hostEntry.set_text(self.ircc.host)
        frame.add(self.hostEntry)
        table.attach(frame,
            # X direction #          # Y direction
            0, 1,                      0,1,
            gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
            0,                         0);

        frame = gtk.Frame("server port")
        self.portEntry = gtk.Entry()
        self.portEntry.set_size_request(40, 20)
        self.portEntry.set_text(str(self.ircc.port))
        frame.add(self.portEntry)
        table.attach(frame,
            # X direction #          # Y direction
            0, 1,                      1,2,
            gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
            0,                         0);

        self.daqEntries = []
        for ndx, key in enumerate(self.ircc.daqKeys):
            self.daqEntries.append(gtk.Entry())
            toString = IRCamLibscamStructures.daqToString
            self.daqEntries[ndx].set_text(toString[ndx](self.ircc.daq[key]))
            frame = gtk.Frame(key)
            frame.add(self.daqEntries[ndx])
            table.attach(frame,
                # X direction #          # Y direction
                0, 1,                      2+ndx,3+ndx,
                gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                0,                         0);

        button = gtk.Button('GET VALUES FROM RT')
        button.connect('clicked', self.getValuesFromRt)
        table.attach(button,
            # X direction #          # Y direction
            0, 1,                      3+ndx, 4+ndx,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);

        button = gtk.Button('SEND VALUES TO RT')
        button.connect('clicked', self.sendValuesToRt)
        table.attach(button,
            # X direction #          # Y direction
            0, 1,                      4+ndx, 5+ndx,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);

        button = gtk.Button('CLOSE')
        button.connect('clicked', lambda button, w=self: w.destroy())
        table.attach(button,
            # X direction #          # Y direction
            0, 1,                      5+ndx, 6+ndx,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);

        button.set_flags(gtk.CAN_DEFAULT)
        button.grab_default()

        self.show_all()

    def getValuesFromRt(self, widget):
        self.ircc.getStruct()
        for ndx, key in enumerate(self.ircc.daqKeys):
            toString = IRCamLibscamStructures.daqToString
            #print toString[ndx](self.ircc.pythonConfig[key])
            self.daqEntries[ndx].set_text(toString[ndx](self.ircc.daq[key]))
            
    def sendValuesToRt(self, widget):
        self.ircc.host = self.hostEntry.get_text()
        #print "New IP is: ", self.ircc.host
        self.ircc.port = int(self.portEntry.get_text())
        #print "New port is: ", self.ircc.port
        for ndx, key in enumerate(self.ircc.daqKeys):
            fromString = IRCamLibscamStructures.daqFromString
            self.ircc.daq[key] = fromString[ndx](self.daqEntries[ndx].get_text())
            #print "New %s is: "%(key), self.ircc.pythonConfig[key]
        self.ircc.sendStruct()

    

def main(ircc = None):
    det = detectorParameters(ircc = None)
    gtk.main()

if __name__ == '__main__':
    main()

    
